/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/








#ifndef ___LIBKEYINPUT_H___
#define ___LIBKEYINPUT_H___

#include "lki_ecode.h"




#define KEY_R_EZOOM_P		0x28
#define KEY_R_EZOOM_M		0x29
#define KEY_R_COMP1			0x43
#define KEY_R_COMP2			0x44
#define KEY_R_SVIDEO		0x45
#define KEY_R_VIDEO			0x46
#define KEY_R_FREEZE		0x47
#define KEY_R_ENTER			0x49
#define KEY_R_F1			0x51
#define KEY_R_F2			0x52
#define KEY_R_F3			0x53
#define KEY_R_F4			0x54
#define KEY_R_F5			0x55
#define KEY_R_UP			0x58
#define KEY_R_DOWN			0x59
#define KEY_R_LEFT			0x5A
#define KEY_R_RIGHT			0x5B
#define KEY_R_RIGHTUP		0x5C
#define KEY_R_LEFTUP		0x5D
#define KEY_R_BNC			0x00
#define KEY_R_DVL			0x00
#define KEY_R_EASYMP		0x00
#define KEY_R_EFECT			0x00
#define KEY_R_PREVIEW		0x00
#define KEY_R_0				0x76
#define KEY_R_RIGHTDOWN		0x5E
#define KEY_R_LEFTDOWN		0x5F
#define KEY_R_POWER			0x3B
#define KEY_R_MENU			0x3C
#define KEY_R_ESC			0x3D
#define KEY_R_AVMUTE		0x3E
#define KEY_R_COLORMODE		0x3F
#define KEY_R_AUTO			0x4A
#define KEY_R_PATTERN		0x4B
#define KEY_R_ASPECT		0x4C
#define KEY_R_DRGB			0x4D
#define KEY_R_INPUTA		0x4E
#define KEY_R_MEMORY1		0x61
#define KEY_R_MEMORY2		0x62
#define KEY_R_MEMORY3		0x63
#define KEY_R_MEMORY4		0x64
#define KEY_R_MEMORY5		0x65
#define KEY_R_MEMORY6		0x66
#define KEY_R_3				0x73
#define KEY_R_4				0x74
#define KEY_R_5				0x75
#define KEY_R_6				0x76
#define KEY_R_7				0x77
#define KEY_R_8				0x78
#define KEY_R_9				0x79
#define KEY_R_PAGEUP		0x68
#define KEY_R_PAGEDOWN		0x69




#define XMDM_DATALEN				128				
#define XMDM1K_DATALEN				1024			
#define XMDMCRC_PACKETLEN			128+5			
#define XMDM1KCRC_PACKETLEN			1024+5			
#define XMDM_ACK					0x06			
#define XMDM_NAK					0x15			
#define XMDM_CAN					0x18			
#define XMDM_SOH					0x01			
#define XMDM_STX					0x02			
#define XMDM_EOT					0x04			
#define XMDM_EOF					0x1A			
#define XMDM_C						0x43			




#define XMDMBUFF_MAXLEN			XMDM1K_DATALEN+1	
#define COMMBUFF_MAXLEN			XMDMBUFF_MAXLEN		
#define ESCVP21_MAXLEN			128					
#define ESCVP21_DELIMITER		0x0D				
#define ESCVP21_DELIMITER_S		"\x0D"				
#define ESCVP21_STATUS_ERR		"ERR"				
#define ESCVP21_STATUS_SUCCESS	':'					
#define ESCVP21_STATUS_SUCCESS_S	":"				
#define COMMAND_FLG				0x01				
#define EVENT_FLG				0x02				
#define LOCALHOST_ADDR		"127.0.0.1"				
#define LKI_RECEIVE_COMMAND_RETRY_CNT	1			




#define LKI_SUCCESS					0	
#define LKI_ERR_FATAL				-1	
#define LKI_ERR_ESCVP21				-2	
#define LKI_ERR_XMODEM				-3	
#define LKI_ERR_CMD_NOT				-4	
#define LKI_ERR_CMD_CODE			-5	
#define LKI_ERR_CMD_NON_DELIMITER	-6	
#define LKI_ERR_CMD_OVERLENGTH		-7	
#define LKI_ERR_CMD_PARAMRANGE		-8	
#define LKI_ALREADY_CONNECT			-9	
#define LKI_TIMEOUT					-10	
#define LKI_DISCONNECT				-11 
#define LKI_ERR_CMD					-12	




#define TRUE			1				
#define FALSE			0 				




#define ESCVP21_CMDHEAD_MAXLEN		15		
#define CMD_CLASS_INT				0x01L	
#define CMD_CLASS_SUP				0x02L	
#define CMD_CLASS_DBG				0x04L	
#define CMD_CLASS_LOC				0x08L	
#define CMD_CLASS_EXT				0x10L	
#define CMD_CLASS_BIN				0x20L	
#define CMD_CLASS_EV				0x40L	
#define CMD_TO_PW					0x01L	
#define CMD_TO_PWX					0x02L	
#define CMD_TO_KID					0x04L	


#define CMD_NUM_MAX					179		
#define CMD_NULL					""		




#define EV_IMIVENT		kPWStatEv		
#define EV_KEYMAKE		kKeyMakeEv		
#define EV_KEYBREAK		kKeyBreakEv		
#define EV_IMVER		kIMVerEv		
#define EV_LANG			kLangChgEv		
#define EV_SOURCE		kSrcChgEv		
#define EV_DIRCHG		kDirChgEv		
#define EV_PRJID		kPrjIDChgEv		
#define EV_NWSET		kNWCfgChgEv		
#define EV_NWGET		kNWInfGetEv		




typedef enum tagCOMID{


	cmd_DELIMITER = 0,
	cmd_APPINFO,
	cmd_KIDINT,
	cmd_PASSWD,
	cmd_PASSWD_,
	cmd_PWR_,
	cmd_LANG_,

	cmd_CPREPEAT,
	cmd_CPREPEAT_,
	cmd_CPINTERVAL,
	cmd_CPINTERVAL_,
	cmd_CPSORT,
	cmd_CPSORT_,
	cmd_CPEFFECT,
	cmd_CPEFFECT_,
	cmd_CPUIMODE,
	cmd_CPUIMODE_,

	cmdASETS,
	cmdASETS_,
	cmdASPECT,
	cmdASPECT_,
	cmdAUDIO,
	cmdAUDIO_,
	cmdAUTOKEYSTONE,
	cmdAUTOKEYSTONE_,

	cmdBLUE,
	cmdBLUE_,
	cmdBRIGHT,
	cmdBRIGHT_,

	cmdCMODE,
	cmdCMODE_,
	cmdCOMPORT,
	cmdCOMPORT_,
	cmdCONTRAST,
	cmdCONTRAST_,
	cmdCPROMPT,
	cmdCPROMPT_,
	cmdCSEL,
	cmdCSEL_,
	cmdCTEMP,
	cmdCTEMP_,

	cmdDENSITY,
	cmdDENSITY_,

	cmdERACQ,
	cmdERACQ_,

	cmdFREEZE,
	cmdFREEZE_,

	cmdGREEN,
	cmdGREEN_,

	cmdHPOS,
	cmdHPOS_,
	cmdHREVERSE,
	cmdHREVERSE_,
	cmdHVRESOL_,

	cmdIMEVENT_,
	cmdIMNWADHOC,
	cmdIMNWADHOC_,
	cmdIMNWCH,
	cmdIMNWCH_,
	cmdIMNWCNAME,
	cmdIMNACNAME_,
	cmdIMNWDHCP,
	cmdIMNWDHCP_,
	cmdIMNWEATRAPS,
	cmdIMNWEATRAPS_,
	cmdIMNWESS,
	cmdIMNWESS_,
	cmdIMNWGW,
	cmdIMNWGW_,
	cmdIMNWIP,
	cmdIMNWIP_,
	cmdIMNWKEY,
	cmdIMNWKEY_,
	cmdIMNWMAC,
	cmdIMNWMAC_,
	cmdIMNWMASK,
	cmdIMNWMASK_,
	cmdIMNWMODE,
	cmdIMNWMODE_,
	cmdIMNWPNAME,
	cmdIMNWPNAME_,
	cmdIMNWSYSCONT,
	cmdIMNWSYSCONT_,
	cmdIMNWSYSLOCATE,
	cmdIMNWSYSLOCATE_,
	cmdIMNWSYSNAME,
	cmdIMNWSYSNAME_,
	cmdIMNWTRAPIP1,
	cmdIMNWTRAPIP1_,
	cmdIMNWTRAPIP2,
	cmdIMNWTRAPIP2_,
	cmdIMNWWEP,
	cmdIMNWWEP_,
	cmdIMNWWEPKEY,
	cmdIMNWWEPKEY_,
	cmdIMNWWEPMODE,
	cmdIMNWWEPMODE_,
	cmdIMPWR,
	cmdIMSRESET,
	cmdIMSTAT,
	cmdIMVER,
	cmdIMVER_,
	cmdINFREQ_,
	cmdINITALL,
	cmdINITITEM,
	cmdINPUTS,
	cmdINPUTS_,
	cmdIPROMPT,
	cmdIPROMPT_,
	cmdIPS,
	cmdIPS_,

	cmdKEY,
	cmdKEYSTONEINIT,
	cmdKEYSTONEINIT_,

	cmdLAMP_,
	cmdLANG,
	cmdLANG_,
	cmdLINIT,

	cmdMSEL,
	cmdMSEL_,
	cmdMUTE,
	cmdMUTE_,

	cmdNOSEL,
	cmdNOSEL_,

	cmdOVSCAN,
	cmdOVSCAN_,

	cmdPCMODE_,
	cmdPINPS,
	cmdPINPS_,
	cmdPTBL,
	cmdPTBL_,
	cmdPTBLVER,
	cmdPTBLVER_,
	cmdPRESET,
	cmdPRESET_,
	cmdPWR,
	cmdPWR_,
	cmdPWSTATUS_,

	cmdRED,
	cmdRED_,
	cmdRESOL,
	cmdRESOL_,

	cmdSCREEN,
	cmdSCREEN_,
	cmdSHARP,
	cmdSHARP_,
	cmdSMODE,
	cmdSMODE_,
	cmdSOURCE,
	cmdSOURCE_,
#if 0 
	cmdSPEED,
#endif
	cmdSPEED_,
	cmdSPOWER,
	cmdSPOWER_,
	cmdSYNC,
	cmdSYNC_,
	cmdSYNCMODE_,
	cmdSYNCPOL,
	cmdSYNCPOL_,
	cmdSYNCTERM,
	cmdSYNCTERM_,

	cmdTEMP_,
	cmdTINT,
	cmdTINT_,
	cmdTONEH,
	cmdTONEH_,
	cmdTRACKING,
	cmdTRACKING_,

	cmdVER_,
	cmdVINPUT,
	cmdVINPUT_,
	cmdVINPUTS_,
	cmdVKEYSTONE,
	cmdVKEYSTONE_,
	cmdVOL,
	cmdVOL_,
	cmdVPOS,
	cmdVPOS_,
	cmdVREVERSE,
	cmdVREVERSE_,

	_END_

}COMID;




typedef struct tagCmdTbl{
	char 	sCmd[ESCVP21_CMDHEAD_MAXLEN+1];		
	int	iClass;								
	int	iTo;								
	unsigned long	iEvID;						
	unsigned char	cEvParam[3];				
	int	iPrmNum;							
	int	iPrmType[3];				
}CMDTBL;




typedef struct tagEvTbl{
	unsigned long	ulEvNum;					
	int			iParamNum;					
}EVTBL;

#if __cplusplus
extern "C" {
#endif





int LKI_OpenSocket(const char* pAddr);
int LKI_CloseSocket(void);


int LKI_SetAcceptableEvent(const int iEvent);
int LKI_GetAcceptableEvent(unsigned int* pEvent);


int LKI_ComSequence(const char* pSend, char** ppReceive);
int LKI_ComSequenceINT(int iFd, const char* pSend, char** ppReceive);
int LKI_ComSequence2(const COMID eID, const char* pParam, char** ppRet);
int LKI_ReceiveEventWait(char** ppReceive, const int iSec, const int iMSec);


int LKI_StrCmdLen(int iFlg, const char* pBuff);
int LKI_Ascii2Bin(const char* pHex, unsigned char** ppBin);
int LKI_Encode21(char* pBuff, COMID eID, const char* pParam);
int LKI_GetCmdID(const char* pCmd);
CMDTBL* LKI_GetCmdInfo(const char* pCmd);
int LKI_GetCmdInfoID(const int iID, CMDTBL* pInfo);

int LKI_Send(COMID id, const char *parm);
size_t LKI_Receive(COMID id, const char *parm, char *ptr, size_t size);

#if __cplusplus
}
#endif 

#endif 

