/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/







#include "stdio.h"
#include "libkeyinput.h"

#if __cplusplus
extern "C" {
#endif




const CMDTBL gstCmdTbl[] = {
	{"\r",		0,	CMD_TO_PW,	0x00000000,	{0,0,0},0,{0,0,0}},

	{"_APPINFO",	CMD_CLASS_INT, CMD_TO_KID, 0x00000000, {0,0,0},0,{0,0,0}},
	{"_KIDINT",		CMD_CLASS_INT, CMD_TO_KID, 0x00000000, {0,0,0},0,{0,0,0}},
	{"_PASSWD",		CMD_CLASS_INT, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"_PASSWD?",	CMD_CLASS_INT, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"_PWR?",	CMD_CLASS_INT, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"_LANG?",	CMD_CLASS_INT, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},

	{"_CPREPEAT",	CMD_CLASS_INT, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"_CPREPEAT?",	CMD_CLASS_INT, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"_CPINTERVAL",	CMD_CLASS_INT, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"_CPINTERVAL?",CMD_CLASS_INT, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"_CPSORT",		CMD_CLASS_INT, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"_CPSORT?",	CMD_CLASS_INT, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"_CPEFFECT",	CMD_CLASS_INT, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"_CPEFFECT?",	CMD_CLASS_INT, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"_CPUIMODE",	CMD_CLASS_INT, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"_CPUIMODE?",	CMD_CLASS_INT, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},

	{"ASETS", 	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"ASETS?", 	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{1,0,0}},
	{"ASPECT", 	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"ASPECT?", 0, CMD_TO_PW, 0x00000000, {0,0,0},0,{3,0,0}},
	{"AUDIO",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"AUDIO?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{3,0,0}},
	{"AUTOKEYSTONE",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"AUTOKEYSTONE?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{1,0,0}},

	{"BLUE",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"BLUE?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{2,0,0}},
	{"BRIGHT",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"BRIGHT?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{2,0,0}},

	{"CMODE",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"CMODE?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{3,0,0}},
	{"COMPORT",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"COMPORT?",0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"CONTRAST",0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"CONTRAST?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{2,0,0}},
	{"CPROMPT", 	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"CPROMPT?", 	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{1,0,0}},
	{"CSEL",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"CSEL?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{3,0,0}},
	{"CTEMP",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"CTEMP?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{2,0,0}},

	{"DENSITY",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"DENSITY?",0, CMD_TO_PW, 0x00000000, {0,0,0},0,{2,0,0}},

	{"ERACQ",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"ERACQ?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},

	{"FREEZE",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"FREEZE?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{1,0,0}},

	{"GREEN",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"GREEN?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{2,0,0}},

	{"HPOS",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"HPOS?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{2,0,0}},
	{"HREVERSE",0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"HREVERSE?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{1,0,0}},
	{"HVRESOL?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{1,0,0}},

	{"IMEVENT?",	CMD_CLASS_SUP, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMNWADHOC",	0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMNWADHOC?",	0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{2,0,0}},
	{"IMNWCH",	0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMNWCH?",	0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{2,0,0}},
	{"IMNWCNAME",	CMD_CLASS_EV, CMD_TO_PWX, 0x00000100, {0x40,0,0},0,{0,0,0}},
	{"IMNWCNAME?",0, CMD_TO_PWX, 0x00000000, {0x40,0,0},0,{1,0,0}},
	{"IMNWDHCP",	CMD_CLASS_EV, CMD_TO_PWX, 0x00000100, {0x20,0,0},0,{0,0,0}},
	{"IMNWDHCP?",	0, CMD_TO_PWX, 0x00000000, {0x20,0,0},0,{1,0,0}},
	{"IMNWEATRAPS",	0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMNWEATRAPS?",	0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMNWESS",	0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMNWESS?",	0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{4,0,0}},
	{"IMNWGW",	CMD_CLASS_EV, CMD_TO_PWX, 0x00000100, {0x02,0,0},0,{0,0,0}},
	{"IMNWGW?",	0, 	CMD_TO_PWX, 0x00000000, {0x02,0,0},0,{1,0,0}},
	{"IMNWIP",	CMD_CLASS_EV, CMD_TO_PWX, 0x00000100, {0x01,0,0},0,{0,0,0}},
	{"IMNWIP?",	0, CMD_TO_PWX, 0x00000200, {0x01,0,0},0,{1,0,0}},
	{"IMNWKEY",	0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMNWKEY?",	0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{1,0,0}},
	{"IMNWMAC",	CMD_CLASS_EV, CMD_TO_PWX, 0x00000100, {0x80,0,0},0,{0,0,0}},
	{"IMNWMAC?",	0, CMD_TO_PWX, 0x00000000, {0x80,0,0},0,{1,0,0}},
	{"IMNWMASK",	CMD_CLASS_EV, CMD_TO_PWX, 0x00000100, {0x04,0,0},0,{0,0,0}},
	{"IMNWMASK?",	0, 	CMD_TO_PWX, 0x00000000, {0x04,0,0},0,{1,0,0}},
	{"IMNWMODE", 0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMNWMODE?",	0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMNWPNAME",	0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMNWPNAME?",0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{4,0,0}},
	{"IMNWSYSCONT", 0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMNWSYSCONT?",0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMNWSYSLOCATE", 0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMNWSYSLOCATE?", 0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMNWSYSNAME", 0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMNWSYSNAME?",0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMNWTRAPIP1",	CMD_CLASS_EV, CMD_TO_PWX, 0x00000100, {0x08,0,0},0,{0,0,0}},
	{"IMNWTRAPIP1?",	0,	CMD_TO_PWX, 0x00000000, {0x08,0,0},0,{1,0,0}},
	{"IMNWTRAPIP2",	CMD_CLASS_EV, CMD_TO_PWX, 0x00000100, {0x10,0,0},0,{0,0,0}},
	{"IMNWTRAPIP2?",	0,	CMD_TO_PWX, 0x00000000, {0x10,0,0},0,{1,0,0}},
	{"IMNWWEP",	0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMNWWEP?",	0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{1,0,0}},
	{"IMNWWEPKEY",	0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMNWWEPKEY?",	0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{3,0,0}},
	{"IMNWWEPMODE",	0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMNWWEPMODE?", 0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{3,0,0}},
	{"IMPWR",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMSRESET", 	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMSTAT", 	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMVER", 		0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IMVER?", 		0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"INFREQ?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{1,0,0}},
	{"INITALL",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"INITITEM",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"INPUTS",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"INPUTS?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{3,0,0}},
	{"IPROMPT",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IPROMPT?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{1,0,0}},
	{"IPS"	,	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"IPS?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},

	{"KEY", 			0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"KEYSTONEINIT", 	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"KEYSTONEINIT?", 	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{3,0,0}},

	{"LAMP?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{2,0,0}},
	{"LANG",	CMD_CLASS_SUP, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"LANG?",	CMD_CLASS_SUP, CMD_TO_PW, 0x00000000, {0,0,0},0,{3,0,0}},
	{"LINIT",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},

	{"MSEL",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"MSEL?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{3,0,0}},
	{"MUTE",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"MUTE?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},

	{"NOSEL",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"NOSEL?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{3,0,0}},

	{"OVSCAN",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"OVSCAN?",0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},

	{"PCMODE?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{1,0,0}},
	{"PINPS",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"PINPS?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"PTBL", CMD_CLASS_BIN, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"PTBL?", CMD_CLASS_BIN, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"PTBLVER",  0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"PTBLVER?", 0, CMD_TO_PWX, 0x00000000, {0,0,0},0,{0,0,0}},
	{"PRESET",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"PRESET?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"PWR", 	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"PWR?", 	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"PWSTATUS?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},

	{"RED",		0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"RED?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{2,0,0}},
	{"RESOL",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"RESOL?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{3,0,0}},

	{"SCREEN",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"SCREEN?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{1,0,0}},
	{"SHARP",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"SHARP?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{2,0,0}},
	{"SMODE",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"SMODE?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{3,0,0}},
	{"SOURCE",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"SOURCE?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{3,0,0}},
#if 0 
	{"SPEED",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
#endif
	{"SPEED?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"SPOWER",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"SPOWER?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{1,0,0}},
	{"SYNC",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"SYNC?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{2,0,0}},
	{"SYNCMODE?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{3,0,0}},
	{"SYNCPOL",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"SYNCPOL?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{2,0,0}},
	{"SYNCTERM",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"SYNCTERM?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},

	{"TEMP?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"TINT",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"TINT?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{2,0,0}},
	{"TONEH",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"TONEH?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{2,0,0}},
	{"TRACKING",0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"TRACKING?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{2,0,0}},

	{"VER?",	CMD_CLASS_SUP, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"VINPUT",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"VINPUT?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{3,0,0}},
	{"VINPUTS?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{3,0,0}},
	{"VKEYSTONE",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"VKEYSTONE?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"VOL",		0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"VOL?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{2,0,0}},
	{"VPOS",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"VPOS?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{2,0,0}},
	{"VREVERSE",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{0,0,0}},
	{"VREVERSE?",	0, CMD_TO_PW, 0x00000000, {0,0,0},0,{1,0,0}},

	{"", 0, 0, 0x00000000, {0,0,0},0,{0,0,0}},
};


const EVTBL gstEvTbl[] = {
	{0x00000001, 3},		
	{0x00000002, 1},		
	{0x00000004, 1},		
	{0x00000008, 1},		
	{0x00000010, 0},		
	{0x00000020, 1},		
	{0x00000040, 1},		
	{0x00000080, 1},		
	{0x00000100, 1},		
	{0x00000200, 1},		
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
	{0x00000000, 0},
};

unsigned char gKisyuTbl[] = {
	0x30,0x30,0x30,0x31,0xA4,0x00,0x00,0x00,
	0x09,0x00,0x00,0x00,0x0D,0x00,0x1A,0x00,
	0x27,0x00,0x34,0x00,0x40,0x00,0x4C,0x00,
	0x59,0x00,0x66,0x00,0x0B,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0xF4,0x0B,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0xF4,0x0B,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0xF4,0x0B,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF4,
	0x0A,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0xF5,0x0A,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF5,
	0x0B,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0xF4,0x0B,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0xF4,0x3C,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC3
};

#if __cplusplus
}
#endif 
