/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



#include "stdafx.h"
#include "patch32.h"

#include "../CommonBf/ReadBuf.h"		



#ifdef __cplusplus	
extern "C"{
#endif





#define DLL16NAME            "EP_NSB2.DLL"
#define DLL32NAME            "EP_NSB4.DLL"


#define THUNK_CONNECT16NAME  patch3216_ThunkConnect16
#define THUNK_CONNECT32NAME  patch3216_ThunkConnect32

#define DDIHOOK_MIN				0x0000 
#define DDIHOOK_RECORDER        0x0001 
#define DDIHOOK_REMOTE          0x0002
#define DDIHOOK_FONTS			0x0003 
#define DDIHOOK_MAGNIFIER		0x0004 
#define DDIHOOK_MAX				0x0005 











static LPVOID pBuffer_base=NULL;
static HPATCH hPatch =NULL;
static HINSTANCE hInstance;


BOOL WINAPI THUNK_CONNECT32NAME
(
        LPSTR module16,
        LPSTR module32,
        HINSTANCE hInst,
        DWORD dwReason
);
BOOL WINAPI THUNK_CONNECT_RDTSC
(
        LPSTR module16,
        LPSTR module32,
        HINSTANCE hInst,
        DWORD dwReason
);


DWORD FAR PASCAL PatchDdi16   (DWORD hWnd,DWORD hInst,DWORD ddiType,DWORD *pAdd);
DWORD FAR PASCAL UnpatchDdi16 (DWORD hPatch);
DWORD FAR PASCAL rdtsc16      ();

BOOL APIENTRY DllMain(
	HANDLE hModule, 
    DWORD  ul_reason_for_call, 
    LPVOID lpReserved
){

	if (!(THUNK_CONNECT32NAME(
					DLL16NAME,    
					DLL32NAME,    
					(HINSTANCE)hModule,
					ul_reason_for_call))
	){
		return FALSE;
	}
	switch (ul_reason_for_call) {
		case DLL_PROCESS_ATTACH:
			hInstance = (HINSTANCE)hModule;
			break;
		case DLL_PROCESS_DETACH:
			if(hPatch){
				Finalize();
			}
			hInstance = NULL;
			break;
		case DLL_THREAD_ATTACH:
			break;
		case DLL_THREAD_DETACH:
			break;
	}
	return TRUE;
}

DLLEXPORT HPATCH __stdcall PatchDdi32(HWND hWnd,HINSTANCE hInst,DWORD ddiType,DWORD *pAdd){

	return (HPATCH)PatchDdi16((DWORD)hWnd,(DWORD)hInst,(DWORD)ddiType,(DWORD*)pAdd);
}

DLLEXPORT BOOL __stdcall UnpatchDdi32 (HPATCH hPatch){

	return (BOOL)UnpatchDdi16 ((DWORD)hPatch);
}

DLLEXPORT BOOL Initialize(){
	DWORD dwAddres;
	if(hPatch){
		return FALSE;
	}
	hPatch = PatchDdi32(NULL,hInstance,DDIHOOK_REMOTE,&dwAddres);
	
	if(hPatch){
		pBuffer_base = (LPVOID)dwAddres;
		return TRUE;
	}
	return FALSE;
}

DLLEXPORT BOOL Finalize(){
	BOOL ret=FALSE;
	if(pBuffer_base || hPatch){
		pBuffer_base=NULL;
		ret = UnpatchDdi32 (hPatch);
		hPatch=NULL;
	}
	return ret;
}


DLLEXPORT int  ReadBuffer(char * pData,unsigned int size){
	unsigned int ret =0;
	CReadBuf readBf;

	

	
	
	ret = readBf.ReadBufferCommon((char *)pBuffer_base, pData, size);

	if( ret == 1 ){
		return ret;
	}else if( ret == size ){
		
		
		if( readBf.MoveReadPointer((char *)pBuffer_base, size) )
			return ret;
	}

	
	

	return ret;
}


DLLEXPORT int PeekBuffer(char * pData,unsigned int size){
	int ret =0;
	CReadBuf readBf;

	

	
	
	ret = readBf.ReadBufferCommon((char *)pBuffer_base, pData, size);
	



	return ret;
}



DLLEXPORT BOOL MoveReadPointer(unsigned int size)
{
	CReadBuf readBf;
	return readBf.MoveReadPointer((char *)pBuffer_base, size);
}


DLLEXPORT BOOL ReSetOverFlow()
{
	CReadBuf readBf;
	return readBf.ReSetOverFlow((char *)pBuffer_base);
}


DLLEXPORT BOOL SetDCHandle(unsigned long dcHandle)
{
	CReadBuf readBf;
	return readBf.SetDCHandle((char *)pBuffer_base, dcHandle);
}









#ifdef __cplusplus
};
#endif

