/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#pragma once

#if     !defined(__MIRROR_IOCTLOODE_H__)
#define __MIRROR_IOCTLOODE_H__





#ifndef _NTDDK_
#ifndef CTL_CODE

  #define METHOD_BUFFERED                 0
  #define METHOD_IN_DIRECT                1
  #define METHOD_OUT_DIRECT               2
  #define METHOD_NEITHER                  3

  #define FILE_ANY_ACCESS                 0
  #define FILE_SPECIAL_ACCESS    (FILE_ANY_ACCESS)
  #define FILE_READ_ACCESS          ( 0x0001 )    
  #define FILE_WRITE_ACCESS         ( 0x0002 )    

  #define CTL_CODE( DeviceType, Function, Method, Access ) ( \
    ((DeviceType) << 16) | ((Access) << 14) | ((Function) << 2) | (Method) \
  )

#endif
#endif

#define MIRROR_TYPE 40000


#define IOCTL_MIRROR_INITIALIZE_BUFFER CTL_CODE( MIRROR_TYPE, 0x900, METHOD_BUFFERED, FILE_READ_ACCESS )
#define IOCTL_MIRROR_FINALIZE_BUFFER   CTL_CODE( MIRROR_TYPE, 0x901, METHOD_BUFFERED, FILE_READ_ACCESS )
#define IOCTL_MIRROR_READ_BUFFER       CTL_CODE( MIRROR_TYPE, 0x902, METHOD_BUFFERED, FILE_READ_ACCESS )
#define IOCTL_MIRROR_WRITE_BUFFER      CTL_CODE( MIRROR_TYPE, 0x903, METHOD_BUFFERED, FILE_WRITE_ACCESS)
#define IOCTL_MIRROR_MAPPING_BUFFER    CTL_CODE( MIRROR_TYPE, 0x904, METHOD_BUFFERED, FILE_READ_ACCESS )
#define IOCTL_MIRROR_UNMAPPING_BUFFER  CTL_CODE( MIRROR_TYPE, 0x905, METHOD_BUFFERED, FILE_READ_ACCESS )


#define IOCTL_MIRROR_MAPPING_MDL       CTL_CODE( MIRROR_TYPE, 0x906, METHOD_BUFFERED, FILE_READ_ACCESS )
#define IOCTL_MIRROR_UNMAPPING_MDL     CTL_CODE( MIRROR_TYPE, 0x907, METHOD_BUFFERED, FILE_READ_ACCESS )

#endif

