/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/




#include "stdafx.h"
#include "win2kbuf.h"
#include "LogFile.h"

#include <stdlib.h>
#include <stdio.h>
#include <tchar.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif





CLogFile::CLogFile(LPSTR filename)
{
	m_hlogfile = NULL;
#ifdef _DEBUG
    OpenFile(filename);
	if(m_hlogfile) {
		DWORD byteswritten;

		SYSTEMTIME stime;
		GetLocalTime(&stime);

		char temp[BUFFER_LENGTH];

		sprintf(temp,"%04d/%02d/%02d ",stime.wYear,stime.wMonth,stime.wDay);
		WriteFile(m_hlogfile, temp, strlen(temp), &byteswritten, NULL); 
		WriteFile(m_hlogfile, "\r\n", 2, &byteswritten,NULL); 

	}
#else
	filename;
#endif
}

CLogFile::~CLogFile()
{
    CloseFile();

}
void CLogFile::OpenFile(LPSTR filename)
{
	char pathDLL [BUFFER_LENGTH];
	if(GetAppDir(pathDLL) == 0)
		return;
  
	sprintf(pathDLL,"%s\\%s",pathDLL,filename);
    
    m_hlogfile = CreateFile(pathDLL,
							GENERIC_WRITE,
							FILE_SHARE_READ,
							NULL,
							CREATE_ALWAYS,
							FILE_ATTRIBUTE_NORMAL,
							NULL);
    
}


void CLogFile::CloseFile() {
    if (m_hlogfile != NULL) {
        CloseHandle(m_hlogfile);
        m_hlogfile = NULL;
    }
}


void CLogFile::TimePrint(LPSTR format)
{
	if(!m_hlogfile) return;

	DWORD byteswritten;

	SYSTEMTIME stime;
	GetLocalTime(&stime);

	char temp[BUFFER_LENGTH];

	sprintf(temp,"%02d:%02d:%02d ",stime.wHour,stime.wMinute,stime.wSecond);

	WriteFile(m_hlogfile, temp, strlen(temp), &byteswritten, NULL); 
	
	WriteFile(m_hlogfile, format, strlen(format), &byteswritten, NULL); 
	
	WriteFile(m_hlogfile, "\r\n", 2, &byteswritten,NULL); 
}

void CLogFile::TimePrint(LPSTR format,unsigned long cnt)
{
	if(!m_hlogfile) return;

	char temp[BUFFER_LENGTH];
	sprintf(temp,"%s:%ld",format,cnt);

	TimePrint(temp);
	return;
}

void CLogFile::TimePrintHex(LPSTR format,unsigned long cnt)
{
	if(!m_hlogfile) return;

	char temp[BUFFER_LENGTH];
	sprintf(temp,"%s:%lxh",format,cnt);

	TimePrint(temp);
	return;
}

void CLogFile::TimePrint(LPSTR format,LPRECT tmpRect)
{
	if(!m_hlogfile) return;

	char temp[BUFFER_LENGTH];

	sprintf(temp,"%s:%ld %ld %ld %ld",format,
				 tmpRect->left,tmpRect->top,tmpRect->right,tmpRect->bottom);

	TimePrint(temp);
	return;
}

void CLogFile::TimePrint(LPSTR format,LPRECT tmpRect,unsigned long counter)
{
	if(!m_hlogfile) return;

	char temp[BUFFER_LENGTH];

	sprintf(temp,"%s:%lx:%ld %ld %ld %ld",format,counter,
				 tmpRect->left,tmpRect->top,tmpRect->right,tmpRect->bottom);

	TimePrint(temp);
	return;
}

void CLogFile::TimePrint(LPSTR format,double diff,unsigned int width,unsigned int hight)
{
	if(!m_hlogfile) return;

	char temp[BUFFER_LENGTH];
	sprintf(temp,"%s:%f %u %u",format,diff,width,hight);

	TimePrint(temp);
	return;
}

void CLogFile::TimePrint(LPSTR format,unsigned int width,unsigned int hight)
{
	if(!m_hlogfile) return;

	char temp[BUFFER_LENGTH];
	sprintf(temp,"%s:%u %u",format,width,hight);

	TimePrint(temp);
	return;
}
void CLogFile::TimePrint(LPSTR format,LPSTR data)
{
	if(!m_hlogfile) return;

	char temp[BUFFER_LENGTH];
	sprintf(temp,"%s:%s",format,data);

	TimePrint(temp);
	return;
}


int CLogFile::GetAppDir (char *pDst)
{
	char szPath[BUFFER_LENGTH];
	if (GetModuleFileName(NULL, szPath, BUFFER_LENGTH)) {
		TCHAR szDrive	[BUFFER_LENGTH];
		TCHAR szDir		[BUFFER_LENGTH];
		TCHAR szFname	[BUFFER_LENGTH];
		TCHAR szExt		[BUFFER_LENGTH];
		_tsplitpath(szPath, szDrive, szDir, szFname, szExt);
		return sprintf(pDst,"%s%s",szDrive, szDir);
	}
	return 0;
}
