/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#pragma once

#include "..\Common\ReadBuf.h"

class MirrorBuffer {
public:
private:


	HANDLE m_hDevice;
	char * m_ptr;

	CReadBuf m_buffRead;

	CRITICAL_SECTION	m_bufferLock; 

public:
	MirrorBuffer();
	~MirrorBuffer();
	BOOL Initialize(HANDLE hProccess = NULL);

	void Finalize();
	int WriteBuffer(char * pData,unsigned int size);
	int ReadBuffer(char * pData,unsigned int size);
	int PeekBuffer(char * pData,unsigned int size);
	int CountBuffer();
	int ClearBuffer();

	BOOL MoveReadPointer(unsigned int size);	
	BOOL ReSetOverFlow();
	BOOL SetDCHandle(unsigned long dcHandle);

private:
};
