/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/








#include "stdafx.h"
#include "stdio.h"



#ifdef CO_E_NOTINITIALIZED
#undef CO_E_NOTINITIALIZED
#endif

#include <winddi.h>

#include <tchar.h>



#include "Win2kBuf.h"
#include "MirrorBuffer.h"

#include "Registry.h"

#include "LogFile.h"
CLogFile buffLog("Win2kBuf.log"); 




static const LPSTR driverName = "EPSON GDI Monitor Driver";



static HINSTANCE m_appInstance;
static LPSTR dispCode[7];
static HKEY hKeyProfileMirror;
static HKEY hKeyDevice;

LPSTR GetDispCode(INT code);

MirrorBuffer m_mirrorBuffer;


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}



BOOL gbInitialized=FALSE;

__declspec(dllexport) BOOL Initialize (){


	{
		if(gbInitialized){
			return FALSE;
		}
		gbInitialized =TRUE;
	}


	if(MirrorDriverChange(MIRRORDRIVER_ON)){


		if(	m_mirrorBuffer.Initialize() == FALSE)
		{

			return FALSE;
		}
		return TRUE;
	}
	return FALSE;
}

__declspec(dllexport) BOOL Finalize(){


	{
		if(!gbInitialized){
			return TRUE;
		}
		gbInitialized =FALSE;
	}

	m_mirrorBuffer.Finalize();


	return MirrorDriverChange(MIRRORDRIVER_OFF); 
}

__declspec(dllexport) int ReadBuffer(char * pData,unsigned int size){






	int getSize = m_mirrorBuffer.ReadBuffer(pData,size);

	return getSize;

}

__declspec(dllexport) int PeekBuffer(char * pData,unsigned int size){


	int getSize = m_mirrorBuffer.PeekBuffer(pData,size);

	return getSize;

}


__declspec(dllexport) int MoveReadPointer(unsigned int size)
{
	return m_mirrorBuffer.MoveReadPointer(size);
}


__declspec(dllexport) BOOL ReSetOverFlow()
{
	return m_mirrorBuffer.ReSetOverFlow();
}

__declspec(dllexport) BOOL SetDCHandle(unsigned long dcHandle)
{
	return m_mirrorBuffer.SetDCHandle(dcHandle);
}

BOOL MirrorDriverChange(DWORD data)
{
	    DEVMODE devmode;
	BOOL bChange =FALSE;
	DWORD dwZero = 0;
	DWORD dwOne  = 1;

    FillMemory(&devmode, sizeof(DEVMODE), 0);
    devmode.dmSize = sizeof(DEVMODE);
    devmode.dmDriverExtra = 0;

	bChange = EnumDisplaySettings(NULL,ENUM_CURRENT_SETTINGS,&devmode);
	devmode.dmFields = DM_BITSPERPEL |DM_PELSWIDTH | DM_PELSHEIGHT;

    if (bChange) {
        DISPLAY_DEVICE dispDevice;       
        LPSTR deviceName = NULL;
        INT devNum = 0;
        BOOL result;

        FillMemory(&dispDevice, sizeof(DISPLAY_DEVICE), 0);
        dispDevice.cb = sizeof(DISPLAY_DEVICE);
       
        devmode.dmDeviceName[0] = '\0';


		while (result = EnumDisplayDevices(NULL,devNum,&dispDevice,0)){
			if (strcmp(&dispDevice.DeviceString[0], driverName) == 0){
				break;
			}
			devNum++;
		}
		if (!result){
			return FALSE;
        }

        CHAR deviceNum[MAX_PATH];
        LPSTR deviceSub;

		_strupr(&dispDevice.DeviceKey[0]);

		deviceSub = strstr(&dispDevice.DeviceKey[0],REGKEY_MIRROR_SERCH_KEY);

		buffLog.TimePrint("dispDevice.DeviceKey :",dispDevice.DeviceKey);
		buffLog.TimePrintHex("dispDevice.DeviceKey :",(unsigned long)deviceSub);


		strcpy(deviceNum,REGKEY_MIRROR_KEYNAME);
		
		if (!deviceSub){ 
			strcat(deviceNum, REGKEY_MIRROR_LAST_ORIGINAL);
		}else{
			strcat(deviceNum, ++deviceSub);
		}

		buffLog.TimePrint("RegKey :",deviceNum);

		CRegistry regKey;

		if(!regKey.create(HKEY_LOCAL_MACHINE,deviceNum,NULL,KEY_WRITE))
		{
			buffLog.TimePrint("RegKey Create Error");
			return FALSE;
		}
		if(!regKey.setINT(REGKEY_MIRROR_VALUENAME,data))
		{
			buffLog.TimePrint("RegKey SetINT Error");
			return FALSE;
		}
 
 
       strcpy((LPSTR)&devmode.dmDeviceName[0], "mirror");
        deviceName = (LPSTR)&dispDevice.DeviceName[0];

        INT code ;


        code = ChangeDisplaySettingsEx(
				deviceName,&devmode, NULL,0,NULL
		);

















		regKey.close();


		return TRUE;
	}
	return FALSE;
}