/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/




#if !defined(AFX_ADAPTERSINFO_H__F23A3B89_D615_4421_9348_A1AA0700CCD0__INCLUDED_)
#define AFX_ADAPTERSINFO_H__F23A3B89_D615_4421_9348_A1AA0700CCD0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif 

#include "Iphlpapi.h"	


#define ADPINFO_NOERR				0
#define ADPINFO_ERR_ALREADYINIT		-100	
#define ADPINFO_ERR_FAILALLOCMEM	-101	
#define ADPINFO_ERR_NODATA			-102	
#define ADPINFO_ERR_NOTSUPPORTED	-103	
#define ADPINFO_ERR_UNKNOWN			-104	
#define ADPINFO_ERR_GETADPINFO		-105	
#define ADPINFO_ERR_GETIPADDR		-106	

#define ADPINFO_MACADDRESS_MAXLEN	6		


typedef struct {
	ULONG	uIPAddr;
	ULONG	uSubnet;
} ADP_IPADDR;


class CAdaptersInfo  
{

public:
	CAdaptersInfo();
	virtual ~CAdaptersInfo();

	int			Init(void);					
	void		Clear(void);				
	UINT		GetCount(void);				
	char*		GetAdapterName(int index);	
	int			GetAdapterType(int index);	

	int			GetIPAddress(ADP_IPADDR* pAddr, int index, int pos=0);		



	ULONG		GetGatewayAddr(int index, int pos=0);	

	BYTE*		GetMacAddr(int index);		
	int			GetAdapterIndex(BYTE *pMacAddr);	
	char*		GetDescription(int index);	

	IP_ADAPTER_INFO*	GetAdapterPoi(int index);	

private:
	UINT		m_nAdapterCount;			
	BYTE*		m_pAdapterInfoBuf;			
	CPtrList	m_AdaptersPList;			




};

#endif 
