/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_ECBUTTON_H__007FB271_D6C4_4430_9CEF_8E6E03D92E94__INCLUDED_)
#define AFX_ECBUTTON_H__007FB271_D6C4_4430_9CEF_8E6E03D92E94__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif 


#include "..\\Common\\EMPLocalize.h"


#define WM_ECBUTTON_REPEAT		WM_USER+2025	
#define IDC_REPEAT_TIMER		1500			
#define ECON_REPEAT_TIME		200				
#define REPEAT_WPARAM_DOWN		0				
#define REPEAT_WPARAM_HOLD		1				
#define REPEAT_WPARAM_UP		2				


#define WIDTHBYTES(bits)    (((bits) + 31) / 32 * 4)



class CECButton : public CButton
{

public:
	CECButton(CEMPLocalize* pLocal);


public:

	void	SetLCRes(CEMPLocalize* plczRes){ m_plczRes = plczRes; }

	

	void	KillRepeatTimer(void){ KillTimer(m_nRpTimer); }
	


	
	
	public:
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	


public:
	virtual ~CECButton();

	
protected:
	
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg UINT OnGetDlgCode();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
		
	

	DECLARE_MESSAGE_MAP()

private:
	DWORD				m_dwLowStyle;
	BOOL				m_bDefault;
	CEMPLocalize*		m_plczRes;
	LONG				OnBsSetStyle(UINT wParam, LONG lParam);
	BOOL				SetRgn(int nBmpID, int nWid, int nHei, int nTop);


	BOOL				m_bRepeat;	
	UINT				m_nRpTimer;

	CFont				m_Font;		
};






#endif 
