/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



#include "stdafx.h"
#include "ECComboBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif




CECComboBox::CECComboBox()
{
	m_bgColor = RGB(255,255,255);
	m_pbgBrush = new CBrush(m_bgColor);
}

CECComboBox::~CECComboBox()
{
	if( m_pbgBrush ){
		delete m_pbgBrush;
		m_pbgBrush = NULL;
	}
}


BEGIN_MESSAGE_MAP(CECComboBox, CComboBox)
	
	ON_WM_GETDLGCODE()
	ON_WM_CTLCOLOR_REFLECT()
	ON_WM_CTLCOLOR()
	
END_MESSAGE_MAP()




UINT CECComboBox::OnGetDlgCode() 
{
	

	return CComboBox::OnGetDlgCode();
}

void
CECComboBox::ResizeWidth(char *addstr)
{
	CSize nTxtSize;
	CString csTxt;
	if( !addstr ) return;
	csTxt = addstr;


	CDC *pDC = GetDC();
	CFont *oldFont = pDC->SelectObject(this->GetFont());
	nTxtSize = pDC->GetTextExtent(csTxt);
	pDC->SelectObject(oldFont);

	if( nTxtSize.cx+20 > GetDroppedWidth() )
		SetDroppedWidth(nTxtSize.cx+20);
}


void
CECComboBox::SetBackColor(COLORREF col)
{
	m_bgColor = col;
	if( m_pbgBrush ){
		delete m_pbgBrush;
		m_pbgBrush = new CBrush(m_bgColor);
	}
}


HBRUSH
CECComboBox::CtlColor(CDC* pDC, UINT nCtlColor) 
{
	
	pDC;
	nCtlColor;
	
	pDC->SetBkMode(TRANSPARENT);
	pDC->SetBkColor(m_bgColor);
	return *m_pbgBrush;
}

HBRUSH
CECComboBox::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	CComboBox::OnCtlColor(pDC, pWnd, nCtlColor);
	
	
	pDC->SetBkColor(m_bgColor);
    return *m_pbgBrush;
}

