/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/




#if !defined(AFX_ECSEARCHCLIENT_H__A7EFD001_A880_11D6_BC84_002018A23969__INCLUDED_)
#define AFX_ECSEARCHCLIENT_H__A7EFD001_A880_11D6_BC84_002018A23969__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif 


#include "EconCommand.h"

#define	ECUDP_UDP_BUFFSIZE		2048			
#define	ECSC_PACKETLOST_LIMIT	1				
#define ECS_MESSAGE				(WM_USER+2022)	
#define ECS_SLEEP_TIME			1				
#define ECS_RECEIVING_TIME		2000			
#define ECS_THREADWAIT_TIME		2000			


typedef struct {
	ULONG			m_projIPaddress;
	UINT			m_projState;
	char			m_projName[ECON_PROJNAME_MAXLEN];
	unsigned char	m_projUniqInfo[ECON_UNIQINFO_LENGTH];
	char			m_projKeyword[ECON_KEYWORD_MAXLEN];
	BOOL			m_projUseKeyword;
	UINT			m_nLostCounter;
	int				m_nDisplayType;
} CLIENTINFO, *PCLIENTINFO;


enum _e_command {
	e_finish_search,							
	e_sockerror,								
	e_memerror,									
	e_commanderror								
};

class CECSearchClient  
{
public:
	CECSearchClient(HWND hPntWnd, ULONG ulSvrAddr, UINT nPort);
	virtual ~CECSearchClient();

	HWND			m_hParentWnd;			
	UINT			m_nPort;				
	ULONG			m_ulSvrAddr;			

	BOOL			SearchClient(ULONG ulHostAddr=NULL, BOOL bNoCheck=FALSE);
	void			StartReceiveUDP(void);
	void			EndReceiveUDP(void);
	void			OnReceive(BYTE *pBuf, LPCTSTR rcvIP);

	int				GetClientCount(void);
	BOOL			GetClientInfo(int index, CLIENTINFO *pCltInf);
	BOOL			GetClientInfo(unsigned char* pUniqInfo, CLIENTINFO *pCltInf);
	BOOL			GetClientInfoByIP(ULONG ipaddr, CLIENTINFO *pCltInf);
	BOOL			SetClientInfo(CLIENTINFO *pCltInf);
	void			ClearClientList(void);
	BOOL			GetRunThread(void);
	void			SetRunThread(BOOL run);
	BOOL			GetKill(void);
	void			SetKill(BOOL bKill);

	BOOL			SendUDP(CEconCommand *econ, ULONG ulHostAddr);
	BOOL			SendSearchCommand(ULONG ulHostAddr);
	void			CheckLostCount(void);


	
	void			ResetListChangeFlg(void){ m_bListChangeFlg = FALSE; }
	BOOL			GetListChangeFlg(void){ return m_bListChangeFlg; }
	
private:
	
	CAsyncSocket*	m_pSock;				
	CPtrList		m_ClientList;			
	ULONG			m_ulHostAddr;			

	BOOL			m_bKill;				
	BOOL			m_bRunThread;			
	CRITICAL_SECTION	m_csLock;			

	BOOL			m_bListChangeFlg;		
};

#endif 
