/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



#include "stdafx.h"
#include "ECStatic.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif




CECStatic::CECStatic(CEMPLocalize* pLocal)
{
	m_plczRes = pLocal;
}

CECStatic::~CECStatic()
{
}


BEGIN_MESSAGE_MAP(CECStatic, CStatic)
	
	ON_WM_CREATE()
	
END_MESSAGE_MAP()




int CECStatic::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CStatic::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	
	if( !m_plczRes )
		return -1;

	
	int nID = GetDlgCtrlID();
	PLCCONTROL pCtl = m_plczRes->GetCtlInf(nID);
	if( !pCtl )
		return -1;

	
	lpCreateStruct->x = pCtl->rec.left;
	lpCreateStruct->y = pCtl->rec.top;
	lpCreateStruct->cx = pCtl->rec.right - pCtl->rec.left;
	lpCreateStruct->cy = pCtl->rec.bottom - pCtl->rec.top;

	
	
	if( pCtl->textID ){
		
		LOGFONT fnt;
		memset(&fnt, 0, sizeof(LOGFONT));
		::GetObject(GetStockObject(DEFAULT_GUI_FONT), sizeof(LOGFONT), &fnt);

		
		fnt.lfHeight = -(pCtl->fontsize);
		fnt.lfWidth = 0;
		lstrcpy(fnt.lfFaceName, pCtl->font);

		
		if( !m_Font.CreateFontIndirect(&fnt) )
			return FALSE;

		this->SetFont(&m_Font);

		TCHAR *pStr = m_plczRes->GetString(pCtl->textID);
		if( pStr )
			this->SetWindowText(pStr);
	}		
	return 0;
}
