/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(__EMPCOMMON_H__)
#define __EMPCOMMON_H__


#include "HelpID.h"

#define ECON_APPNAME			"EP_NSS"					
#define ECON_PRODUCTNAME		"EMP NS Connection"			
#define ECON_INSTANCE_NAME		"Global\\EPSON_EMPNSConnection_Mutex"
#define ECON_LOCALIZE_DLLNAME	""
#define ECON_VNESFILE_EPNSSE	"EP_NSSE.DLL"
#define ECON_VNESFILE_ZLIB		"ZLIB.DLL"
#define ECON_VNESFILE_EPNSB2	"EP_NSB2.DLL"
#define ECON_VNESFILE_EPNSB4	"EP_NSB4.DLL"
#define ECON_VNESFILE_EPNSBN	"EP_NSBN.DLL"
#define ECON_EPNSSOP_FNAME		"EP_NSSOP.DLL"

#define ECON_GROUPINI_FNAME		"NSGroup.ini"





#define ESCVP_PORTNUMBER		3629



#define ECON_APP_VERSION		"Ver 1.00"



#define ECON_PROTOCOL_VERSION	"01"


#define ECON_HELPFILE_PATH				"EP_NSS.hlp"

#define _USE_SYSTEMFONT_						


#define ECON_REGISTRY_ROOTKEY			HKEY_LOCAL_MACHINE


#define ECON_REGISTRY_SUBKEY			"SOFTWARE\\SEIKO EPSON\\EMP NS Connection"		




#define ECON_REG_APPPATH				"AppPath"
#define ECON_REG_OUTPUTLOG				"ECOutputLogFile"
#define ECON_REG_USEENC					"UseEncryption"
#define ECON_REG_USEIPCON				"UseIPConnect"
#define ECON_REG_ESCVPPORT				"ESCVPPortNum"
#define ECON_REG_LOCALFNAME				"LocalizeFName"
#define ECON_REG_IPCONADDR				"IPConnectAddr"
#define ECON_REG_CURRENTLAN				"CurrentLAN"
#define ECON_REG_ADAPTERIPADDR			"AdapterIPAddr"


#define ECON_REG_USEGROUPLIST			"UseGroupList"

#define ECON_REG_MAXPROJECTOR			"IM_MaxProjectors"
#define ECON_REG_RESOLUTIONWID			"IM_ResolutionMaxWidth"
#define ECON_REG_RESOLUTIONHEI			"IM_ResolutionMaxHeight"


#define ECON_REG_NSGROUPPATH			"GroupFilePath"



#define ECON_TIMEREVENT_SEARCHTIMER		1		
#define ECON_TIMEREVENT_SEARCHRESULT	2		
#define ECON_TIMEREVENT_INDICATOR		3		
#define ECON_TIMEREVENT_EXPANDWINDOW	6

#define ECON_TIMEREVENT_ARROWANIME		7		
#define ECON_ARROWBLINK_TIME			1000	





												

#define	ECON_PROJLIST_TIMERINTERVAL		2000	
#define ECON_PROJLIST_SEARCHRSLTCNTMAX	3		
#define ECON_PROJLIST_SEARCHTIMEOUT		500		
#define ECON_PROJLIST_CONNECTTIMEOUT	500		
#define ECON_PROJLIST_SENDREQCONCOUNT	1		
#define ECON_PROJLIST_DISCONTIMEOUT		200		
#define ECON_PROJLIST_IPSEATCHTIMEOUT	300		
#define ECON_PROJLIST_INDICATORTIMEOUT	1000	
#define ECON_PROJLIST_DISCONWAITTIME	2000	

#define ECON_PROJLIST_IPLISTMAXCOUNT	16		












#define UIMODE_NORMAL			0		
#define UIMODE_PROJLIST			1		
#define UIMODE_IPCONNECT		2		
#define UIMODE_EZOOM			3		
#define UIMODE_BASESETTING		4		


#define ECON_KEYWORDRETRY_COUNT			4		
#define ECON_PROJSTAT_OTHERSUSING		3		
#define ECON_PROJSTAT_OTHERAPPUSING		4		
#define ECON_ENCRYPTION_PASSWORD	"superman"	
#define ECON_IPADDRSTR_MAXLEN			16		
#define ECON_HOSTNAME_MAXLEN			255		
#define ECON_MACADDRESS_MAXLEN			6		
#define ECON_RECONNECT_RETRYCNT			1		
#define ECON_RECONNECT_RETRYTIME		3000	

#define ECON_SELECTPROJ_MAXNUM			4		

#define ECON_SELECTPROJ_MAXNUM_LIMIT	8		
#define ECON_XGA_WIDTH_LIMIT			1600	
#define ECON_XGA_HEIGHT_LIMIT			1200	

#define ECON_FULLCOLOR_BPP				24		
#define ECON_XGA_WIDTH					1024	
#define ECON_XGA_HEIGHT					768		


#define ECON_UXGA_WIDTH					1600	
#define ECON_UXGA_HEIGHT				1200	




#define ECON_SXGA_WIDTH					1280	
#define ECON_SXGA_HEIGHT				1024	


#define DISPLAYWAIT_DELAY				50		
#define ECON_RECONSRCH_SLEEP			2000	
#define ID_DLGINITERR					100		
#define PROJLIST_ITEM_HEIGHT			22		
#define ECON_RESOLUTION_CHANGE_RETRY	3		
#define MESSAGE_MAXLEN					1024	
#define ECON_REPEAT_DIST				3		
#define ECON_GROUPNAME_MAXLEN			32		
#define MAC_ADDR_LENGTH					6		

#define ECON_SPLASH_TIME				7000	



#define ECON_LBX_PROJLIST			60000		
#define ECON_IPA_IPADDRESS			60001		
#define ECON_BTN_SEARCH				60002		
#define ECON_BTN_CONNECT			60003		
#define ECON_BTN_OPTION				60004		
#define ECON_BTN_EXIT				60005		
#define ECON_BTN_HELP				60006		
#define ECON_BTN_LIST				60007		
#define ECON_BTN_URL				60008		
#define ECON_BTN_PAUSE				60009		
#define ECON_BTN_AVMUTE				60010		
#define ECON_BTN_EZOOM				60011		
#define ECON_BTN_KIHON				60012		
#define ECON_BTN_VIDEO				60013		
#define ECON_BTN_PC					60014		
#define ECON_BTN_DISCON				60015		
#define ECON_BTN_IPCON				60016		
#define ECON_BTN_EASYCON			60017		
#define ECON_STX_STATMES			60018		

#define ECON_STX_STATMES2			60078		
#define ECON_STX_STATMES3			60079		

#define ECON_STX_SCHRESULT			60019		
#define ECON_BTN_OPTCLOSEB			60020		
#define ECON_CKB_OPTENC				60021		
#define ECON_STX_OPTENC				60022		
#define ECON_CKB_OPTIP				60023		
#define ECON_STX_OPTIP				60024		
#define ECON_BTN_OPTLANSEL			60025		
#define ECON_BTN_OPTHOZON			60026		
#define ECON_BTN_OPTCLOSE			60027		
#define ECON_BTN_BARCLOSE			60028		
#define ECON_BTN_BARMIN				60029		
#define ECON_BMP_INDICATOR			60030		
#define ECON_BTN_KAKUCLOSE			60031		
#define ECON_BTN_EZOOMMINUS			60032		
#define ECON_BTN_EZOOMPLUS			60033		
#define ECON_BTN_EZOOMCANCEL		60034		
#define ECON_BTN_EZOOMUP			60035		
#define ECON_BTN_EZOOMDOWN			60036		
#define ECON_BTN_EZOOMLEFT			60037		
#define ECON_BTN_EZOOMRIGHT			60038		
#define ECON_BTN_LIGHTMINUS			60039		
#define ECON_BTN_LIGHTPLUS			60040		
#define ECON_BTN_CONTRASTMINUS		60041		
#define ECON_BTN_CONTRASTPLUS		60042		
#define ECON_BTN_KEYSTONEMINUS		60043		
#define ECON_BTN_KEYSTONEPLUS		60044		
#define ECON_BTN_COLORMODE			60045		
#define ECON_CMB_SELPROJLIST		60046		
#define ECON_BTN_KEYWORDCLOSEBOX	60047		
#define ECON_STX_KEYMESSAGE			60048		
#define ECON_STX_KEYPROJNAME		60049		
#define ECON_STX_KEYWORD			60050		
#define ECON_EDT_PROJNAME			60051		
#define ECON_EDT_KEYWORD			60052		
#define ECON_BTN_KEYWORDOK			60053		
#define ECON_BTN_KEYWORDCANCEL		60054		
#define ECON_BTN_LANSELCLOSEBOX		60055		
#define ECON_STX_LANMESSAGE			60056		
#define ECON_CMB_LANSELECT			60057		
#define ECON_BTN_LANSELOK			60058		
#define ECON_BTN_LANSELCANCEL		60059		
#define ECON_STX_MAINTITLE			60060		

#define ECON_BTN_OPTSYOSAI			60061		
#define ECON_BTN_OPTHLP1			60062		
#define ECON_BTN_OPTHLP2			60063		
#define ECON_BTN_GRPSHINKITUIKA		60064		
#define ECON_BTN_GRPLISTTUIKA		60065		
#define ECON_BTN_GRPLISTSAKUJYO		60066		
#define ECON_BTN_GRPIMPORT			60067		
#define ECON_BTN_GRPEXPORT			60068		
#define ECON_BTN_GRPHOZON			60069		
#define ECON_BTN_GRPSAKUJYO			60070		
#define ECON_BTN_GRPTOJIRU			60071		
#define ECON_BTN_GRPDLGCLOSE		60072		
#define ECON_IPA_GROUPIPADDR		60073		
#define ECON_BTN_GRPHLP				60074		
#define ECON_BTN_GRPCOMBO			60075		
#define ECON_LBX_IPPROJLIST			60080		
#define ECON_BTN_MAINHELP			60081		
#define ECON_STX_IPADDRESS			60082		
#define ECON_STX_PROJLIST			60083		
#define ECON_LBX_GROUPLISTBOX		60089		
#define ECON_CKB_USEGROUP			60090		
#define ECON_CMB_GROUPSELECT		60091		
#define ECON_LBXITEM_PROJNAME		60094		
#define ECON_LBXITEM_IPADDRESS		60095		
#define ECON_BTN_LANMINIHLP			60097		
#define ECON_STX_SPLASHVER1			60098		
#define ECON_STX_SPLASHVER2			60099		
#define ECON_STX_SPLASHMES1			60100		
#define ECON_STX_SPLASHMES2			60101		
#define ECON_BTN_KEYWORDHLP			60102		

#define BMP_BKGND_SPLASH			50000
#define BMP_BKGND_KUGIRI			50021
#define BMP_BKGND_KUGIRIGRAY		50022
#define BMP_INDICATOR				50026
#define BMP_PROJNAMELIST			50030

#define BMP_BKGND_BAR				50023
#define BMP_BKGND_EASYMODE			50001


#define BMP_BKGND_IPMODE			50001

#define BMP_BKGND_EZOOM				50027
#define BMP_BKGND_KIHON				50028
#define BMP_BGGND_OPTION			50039
#define BMP_PLIST_CHECKBOX			50005
#define BMP_PLIST_PROJICON			50004
#define BMP_BGGND_KEYWORD			50044
#define BMP_BGGND_LANSELECT			50045
#define BMP_HLP_ARROW				51033


#define DLGID_PROJLIST				5000
#define DLGID_OPTION				5001
#define DLGID_KEYWORD				5002
#define DLGID_LANSELECT				5003
#define DLGID_SPLASHWND				5006


#define PROJECTOR_INFO_MODEL	0x0000000f 



#define PROJECTOR_MODEL_BER	0x00000000 
#define PROJECTOR_MODEL_KIR	0x00000001 
#define PROJECTOR_MODEL_UK		0x00000002 



#endif
