/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#ifndef __EP_NSSDIALOGS_H__
#define	__EP_NSSDIALOGS_H__

#include "..\\Common\\EMPCommon.h"
#include "..\\Common\\EMPLocalize.h"


typedef struct {
	BOOL			bUseEnc;			
	BOOL			bUseIPConnect;		
	BOOL			bUseGroupList;		
	
	
	TCHAR			sGroupID[ECON_GROUPNAME_MAXLEN + 1];
	
} EPNSD_OPTION;


typedef struct {
	BOOL			bOnStartFlg;
	BYTE			bMACAddr[6];
	ULONG			nIPAddr;
	ULONG			nSubnetAddr;
	ULONG			nGateAddr;
} EPNSD_ADAPTER;


typedef struct {
	CEMPLocalize*	pLocal;				

	CWinApp*		pMainApp;			
	TCHAR			sAppPath[MAX_PATH];	


	BOOL			bOptionChange;		
	BOOL			bAdapterChange;		


	EPNSD_OPTION	stOption;			
	EPNSD_ADAPTER	stAdapter;			
	
} EPNSD_DLGDATA;


#ifdef  __cplusplus
extern "C" {
#endif

__declspec(dllexport) BOOL EPNSD_Init(EPNSD_DLGDATA* pDlgdat);
__declspec(dllexport) int  EPNSD_DoOptionDlg(CWnd* pParent);
__declspec(dllexport) int  EPNSD_DoLANSelectDlg(CWnd* pParent);
__declspec(dllexport) int  EPNSD_DoGroupDlg(CWnd* pParent);
__declspec(dllexport) int  EPNSD_DoVersionDlg(CWnd* pParent);
__declspec(dllexport) BOOL EPNSD_GetDlgData(EPNSD_DLGDATA* pDlgdatBuf, int nSize);


#ifdef  __cplusplus
}       
#endif

#endif