/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/




#if !defined(AFX_ECONCOMMAND_H__BD7C448E_778E_4EA8_8CF3_3D56ED158030__INCLUDED_)
#define AFX_ECONCOMMAND_H__BD7C448E_778E_4EA8_8CF3_3D56ED158030__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif 

#include "..\\common\\econproto.h"

#define ECMD_ERR_MAGICCODE			-1
#define ECMD_ERR_PROTOVERSION		-2

class CEconCommand  
{
public:
	CEconCommand(ULONG ulSvrAddr, int port);	

	CEconCommand();								
	
	virtual ~CEconCommand();

	void			SetParam(ULONG ulSvrAddr, int port);

	
	void			MakeHeader(int cmdID);
	void			MakeReqConnect(	BOOL useEnc,
									unsigned char *encKey,
									ULONG subnet,
									ULONG gateway
									);
	
	void			MakeDispWait(void);
	


	void			MakeSendReq(unsigned char sendReq);
	
	BOOL			AddRecord(	unsigned char* pUniqInf,
								char* pKeyword,
								ULONG ulPingAddr
								);

	BOOL			DeleteRecord( unsigned char* pUniqInf );

	void			Clear(void);

	BOOL			Send(	CAsyncSocket *sock,
							BOOL	bByUDP,
							ULONG	hostaddr=0
							);
	
	int				CheckHeader(BYTE *pHeader);
	void			Recv(BYTE *pHeader, BYTE *pDataBuf);

	int				GetRecordNum(void);
	ECONCOMMAND*	GetEconCommand(void);
	ECONRECORD*		GetEconRecord(int index);


private:
	int					m_nPort;
	ECONHEADER			m_header;
	ECONCOMMAND			m_command;
	BOOL				m_bHeaderOnly;
	CPtrList			m_lstRecord;

	BYTE*				m_pRecvBuf;

	void				OutputLog(void);

};

#endif 
