/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



#include "stdafx.h"
#include "IPEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif




CIPEdit::CIPEdit()
{
	m_pNextEdit = NULL;
	m_bRecvIMENotify = FALSE;
	m_bDotKeyLock = TRUE;
}

CIPEdit::~CIPEdit()
{
}


BEGIN_MESSAGE_MAP(CIPEdit, CEdit)
	
	ON_WM_CHAR()
	ON_WM_RBUTTONDOWN()
	ON_CONTROL_REFLECT(EN_KILLFOCUS, OnKillfocus)
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	ON_MESSAGE(WM_IME_NOTIFY, OnIMENotify)
	
END_MESSAGE_MAP()



void
CIPEdit::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	
	if( !((nChar >= '0' && nChar <= '9') || nChar == 8 || nChar == 46) )
		return;

	
	if( nChar == 46 ){
		if( this->LineLength() > 0 && !m_bDotKeyLock){
			if( m_pNextEdit ){
				m_pNextEdit->SetFocus();
				m_pNextEdit->SetSel((DWORD)0xFF00);
				m_pNextEdit->m_bDotKeyLock = TRUE;		
			}
		}
		return;
	}else
	{
		m_bDotKeyLock = FALSE;							
	}

	
	if( nChar == 8 && this->LineLength()==0 ){
		if( m_pPrevEdit ){
			m_pPrevEdit->SetFocus();
			m_pPrevEdit->SetSel((DWORD)0xFF00);
			m_pPrevEdit->m_bDotKeyLock = TRUE;		
		}
	}


	CEdit::OnChar(nChar, nRepCnt, nFlags);

	
	if( this->LineLength() == (int)(this->GetLimitText()) && nChar != 8){
		if( m_pNextEdit ){
			m_pNextEdit->SetFocus();
			m_pNextEdit->SetSel((DWORD)0xFF00);
			m_pNextEdit->m_bDotKeyLock = TRUE;		
		}
	}
}



void
CIPEdit::OnRButtonDown(UINT nFlags, CPoint point) 
{
	nFlags;
	point;
	return;
}



void
CIPEdit::SetValue(unsigned char val)
{
	char buf[10];
	sprintf(buf,"%d",val);
	this->SetWindowText(buf);
}



void
CIPEdit::OnKillfocus() 
{
	
	CString str;
	this->GetWindowText(str);
	if( !str.IsEmpty() ){
		int nVal = atoi((LPCTSTR)str);









		int nID = this->GetDlgCtrlID();
		if( nID == IPADR_EDIT_CTRLID + 1 || nID == IPADR_EDIT_CTRLID + 2 )
		{
			if(nVal > 255 )
				nVal = 255;
		}else
		{
			if(nVal > 254 )
				nVal = 254;
		}


		str.Format("%d",nVal);
		this->SetWindowText((LPCTSTR)str);
	}
}



void CIPEdit::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	m_bRecvIMENotify = FALSE;
	CEdit::OnKeyDown(nChar, nRepCnt, nFlags);
}



LRESULT
CIPEdit::OnIMENotify(WPARAM wParam, LPARAM lParam)
{
	if( wParam == 0x0b)
		m_bRecvIMENotify = TRUE;
	return 0;
	lParam;
}



void CIPEdit::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	
	if( nChar == VK_DOWN || nChar == VK_RIGHT ){
		m_bDotKeyLock = FALSE;						
		if( m_pNextEdit && !m_bRecvIMENotify){
			m_pNextEdit->SetFocus();
			m_pNextEdit->SetSel((DWORD)0xFF00);
			m_pNextEdit->m_bDotKeyLock = TRUE;		
		}
	}else if( nChar == VK_UP || nChar == VK_LEFT ){
		m_bDotKeyLock = FALSE;						
		if( m_pPrevEdit && !m_bRecvIMENotify){
			m_pPrevEdit->SetFocus();
			m_pPrevEdit->SetSel((DWORD)0xFF00);
			m_pPrevEdit->m_bDotKeyLock = TRUE;		
		}
	}
	CEdit::OnKeyUp(nChar, nRepCnt, nFlags);
}