/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/




#if !defined(AFX_INIFILEUTIL_H__0677C483_A8D2_4B15_8D52_9440C44EA9E2__INCLUDED_)
#define AFX_INIFILEUTIL_H__0677C483_A8D2_4B15_8D52_9440C44EA9E2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif 

#include "EP_INIFILE.h"

class CIniFileUtil  
{
public:
	CIniFileUtil(CPtrList *pList,CString sPath);
	virtual ~CIniFileUtil();

	BOOL		ReadFromFile();						
	BOOL		ReadFromFileNoCase();				
	BOOL		ReadFile();							
	BOOL		SaveListToFile();
	BOOL		CopyToNewFile(CString sNewFilePath);

	BOOL		GetGroup(CString sGroupName,EPNSD_IPGROUP &nsdGroup);

private:
	BOOL		InsertSectionToListNoCase(CString &sSecName);
	BOOL		InsertSectionToList(CString &sSecName);

	BOOL		WriteSectionName(CString sSecName);
	BOOL		WriteSectionIPs(EPNSD_IPGROUP *pGroup);
	BOOL		WriteGroupToFile(EPNSD_IPGROUP *pGroup);
	BOOL		WriteGroupToFileNoCase(EPNSD_IPGROUP *pGroup);

	BOOL		SetGroups();
	BOOL		SetGroupsNoCase();
	BOOL		SetSectionNames();
	BOOL		SetSectionsFromString(CString &sBuff, DWORD dwBuffSize);
	BOOL		SetIPsFromString(EPNSD_IPGROUP *pGroup,CString &sBuff);
	
	BOOL		CheckSectionNameBuffSize(DWORD dwSize);
	

	BOOL		IsIPRegistered(EPNSD_IPGROUP *pGroup);

	CString		m_sFilePath;			
	CPtrList	*m_pPList;				

	BYTE		*m_pbSectionNames;		
	DWORD		m_dwSecNamesBuffSize;	
	DWORD		m_dwSecNamesReadSize;

	
	
	

	int			GetOSVersion();
};

#endif 
