/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(__LOCALDEF_H__)
#define __LOCALDEF_H__

static const char magic_code[] = "ECOM";

#define LOCALSTR_MAXLEN		512
#define MAGICCODE_LENGTH	4




#define CTLTYPE_BUTTON		1
#define CTLTYPE_STATIC		2
#define CTLTYPE_CHECKBOX	3


#define CTLALIGN_LEFT		0
#define CTLALIGN_RIGHT		1
#define CTLALIGN_CENTER		2


#define ECON_CTRLRESOURCE_ID		60000		


#define BMP_BKGND_PROJLIST			50000	


typedef struct{
	int		rsID;
	int		wid;
	int		hei;
	char	font[30];
	int		fontsize;
	int 	charset;
	int		weight;
	int		backgndID;
} LCDIALOG, *PLCDIALOG;



typedef struct{
	int	rsID;
	int type;
	int dlgID;
	RECT	rec;
	int bmpID;
	int textID;
	int tapStop;
	char	font[30];
	int		fontsize;

	int hintTxtID;
	COLORREF txtColor;
	COLORREF txtColorDown;
	COLORREF txtDisableColor1;
	COLORREF txtDisableColor2;
	int txtDisableOff;
	int textX;
	int textY;
	int	textAlign;
	int repeat;

} LCCONTROL, *PLCCONTROL;



typedef struct{
	int		rsID;
	int		maskID;
	int		bitSize;
	BOOL	useMask;
	BITMAPINFOHEADER	binf;
} LCBITMAP, *PLCBITMAP;



typedef struct {
	int		rsID;
	char	rsString[LOCALSTR_MAXLEN];
} LCSTRING;



typedef struct{
	char	magic[4];
	int		nVersion;
	int		nDlgCnt;
	int		nCtlCnt;
	int		nStrCnt;
	int		nBmpCnt;
	int		nMskCnt;
} LCHEADER, *PLCHEADER;


#endif