/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/















#ifndef VNCLOGGING
#define VNCLOGGING

#include <stdarg.h>
#include <stdio.h>
#include <time.h>


#define LL_ERROR	0

#define LL_STATE	0

#define LL_CLIENTS	1

#define LL_CONNERR	0

#define LL_SOCKERR	4

#define LL_INTERR	0


#define LL_INTWARN	8

#define LL_INTINFO	9

#define LL_SOCKINFO	10

#define LL_ALL		10

class Log  
{
public:
    
    static const int ToDebug;
    static const int ToFile;
    static const int ToConsole;

    
    
    
    
    
    
    
    
    
	Log(int mode = ToDebug, int level = 1, LPSTR filename = NULL, bool append = false);

    inline void Print(int level, LPSTR format, ...) {
        if (level > m_level) return;
        va_list ap;
        va_start(ap, format);
        ReallyPrint(format, ap);
        va_end(ap);
    }
    
    
    void SetLevel(int level);

    
    void SetMode(int mode);

    
    
    void SetFile(LPSTR filename, bool append = false);

	virtual ~Log();

private:
	void ReallyPrintLine(LPSTR line);
    void ReallyPrint(LPSTR format, va_list ap);
	void OpenFile();
    void CloseFile();
    bool m_tofile, m_todebug, m_toconsole;
    int m_level;
    HANDLE hlogfile;
	LPSTR m_filename;
	bool m_append;

	time_t m_lastLogTime;
};

extern Log ratelog;

#endif 
