/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_PROJLISTBOX_H__08AE9CFA_1D81_48ED_ABD4_E962F04CD1AA__INCLUDED_)
#define AFX_PROJLISTBOX_H__08AE9CFA_1D81_48ED_ABD4_E962F04CD1AA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif 


#include "EMPLocalize.h"
#include "EMPCommon.h"
#include "ECSearchClient.h"


#define PLIST_STYLE_CHECKBOX	0x01				
#define PLIST_STYLE_IPADDRESS	0x02				


#define PLIST_STATUS_NOUSE		0x00				
#define PLIST_STATUS_USING		0x01				
#define PLIST_STATUS_OTHERPC	0x02				
#define PLIST_STATUS_APPUSING	0x03				
#define PLIST_STATUS_SEARCHING	0x04				
#define PLIST_STATUS_NOREPLY	0x05				


#define PLIST_SRCHTIMER_EVENT	2110
#define PLIST_ANIMATION_EVENT	2120
#define PLIST_SRCHTIMER_TIME	2000
#define PLIST_ANIMATION_TIME	500


#define PLIST_COLOR_TEXT		RGB(0,0,0)			
#define PLIST_COLOR_BACKGOURND	RGB(160,160,170)	
#define PLIST_COLOR_LIGHTPEN	RGB(200,200,210)	
#define PLIST_COLOR_DARKPEN		RGB(80,80,90)	

#define PLIST_COLOR_SELTEXT		RGB(255,255,255)	
#define PLIST_COLOR_SELBACKGND	RGB(120,120,130)	



#define PLIST_IMAGE_WIDTH		18					
#define PLIST_IMAGE_HEIGHT		16					
#define PLIST_IMAGE_INITNUM		0					
#define PLIST_IMAGE_GROWNUM		3					


#define PROJNAME_MAXLEN			512
#define UNIQINFO_LENGTH			6


typedef struct {
	char			projName[PROJNAME_MAXLEN];		
	unsigned char	projUniqInfo[UNIQINFO_LENGTH];  
	unsigned char	projState;						
	BOOL			bSelected;						

	ULONG			ulIPAddr;						

} ECITEM;


const UINT PLIST_NETWORKERR = 
		RegisterWindowMessage("EPSON.EMPController.ProjList.Messages");


class CProjListBox : public CListBox
{

public:
	CProjListBox();

	


public:
	CBrush			bkBrush;

	DWORD			m_dwStyle;
	void			SetPLStyle(DWORD dwStyle){ m_dwStyle = dwStyle; }	


	ULONG			m_ConIPList[ECON_SELECTPROJ_MAXNUM_LIMIT];
	int				m_nConIPNum;




	UINT		m_maxProjectors;			




public:
	void	SetLocalize(CEMPLocalize *pLocal){ m_pLocal = pLocal;}



	
	
	
	BOOL	AddECItem(ECITEM* pEc, int nIndexIns = -1);
	BOOL	AddECItem(char* projName, unsigned char* UniqInfo, unsigned char state, ULONG ulIPAddr=0, int nIndexIns = -1);
	
	BOOL	UpdateECItem(int index, ECITEM* pEc);
	BOOL	UpdateECItem(int index, char* projName, unsigned char* UniqInfo, unsigned char state, ULONG ulIPAddr=0);

	void	DeleteECItem(int index);
	unsigned char* GetUniqInfo(int index);
	BOOL	GetSelected(int index);
	void	SaveCheckedItem(void);
	void	ClearCheckedItem(void);

	void	SetListEnable(BOOL bEnable);
	void	SetPLFont(CFont* pFont){ m_pFont = pFont; SetFont(m_pFont,TRUE);}

	BOOL	m_bExistNowSrch;	
	UINT	m_nSrchTimer;		


	BOOL	StartSearchClient(ULONG ulSvrIPAddr, UINT nPort, BYTE *bMACAddr, int nMACSize);

	void	StopSearchClient(void);								
	void	DeleteSearchClient(void);							
	BOOL	IsSearching(void);									
	BOOL	GetClientInfo(int index, CLIENTINFO *pCltInf);
	CECSearchClient *	GetSrchClient(void);					
	void	UpdateIPList(void);									


	
	
	public:
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	virtual void DeleteItem(LPDELETEITEMSTRUCT lpDeleteItemStruct);
	virtual int CompareItem(LPCOMPAREITEMSTRUCT lpCompareItemStruct);
	virtual int VKeyToItem(UINT nKey, UINT nIndex);
	


public:
	virtual ~CProjListBox();



	
protected:
	
	afx_msg void OnDblclk();
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg HBRUSH CtlColor(CDC* pDC, UINT nCtlColor);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	

	DECLARE_MESSAGE_MAP()
private:
	BOOL				m_bListEnable;
	CEMPLocalize*		m_pLocal;
	int					m_CheckedItemCnt;
	CFont*				m_pFont;
	BOOL				m_bFocus;	


	unsigned char		m_CheckedItem[ECON_SELECTPROJ_MAXNUM_LIMIT * UNIQINFO_LENGTH];


	CECSearchClient*	m_pSrchClient;

	int					m_nAnimeFlag;
	UINT				m_nAnimTimer;
	BOOL				CheckSelectedProjctors(void);
	BOOL				IsCheckedItem(unsigned char *pUniqInfo);
	
	void				ChangeCheckBoxValue(int sel);


	void				SendSearchPacket(void);
	BYTE				m_bMACAddr[ECON_MACADDRESS_MAXLEN];


};






#endif 
