/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/




#if !defined(AFX_DIALOGSMNG_H__2C6570A5_0E70_49A7_89A6_15B23C599245__INCLUDED_)
#define AFX_DIALOGSMNG_H__2C6570A5_0E70_49A7_89A6_15B23C599245__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif 

#include "..\\Common\\EP_NSSDialogs.h"

typedef  BOOL (*PROC_EPNSD_Init)(EPNSD_DLGDATA* pDlgdat);
typedef  BOOL (*PROC_EPNSD_GetDlgData)(EPNSD_DLGDATA* pDlgdat, int nSize);
typedef  int  (*PROC_EPNSD_DoOptionDlg)(CWnd* pParent);
typedef  int  (*PROC_EPNSD_DoLANSelDlg)(CWnd* pParent);
typedef  int  (*PROC_EPNSD_DoGroupDlg)(CWnd* pParent);
typedef  int  (*PROC_EPNSD_DoVersionDlg)(CWnd* pParent);

class CDialogsMng  
{
public:
	CDialogsMng();
	virtual ~CDialogsMng();

	BOOL					Load(const char* sFileName);	

	EPNSD_DLGDATA*			GetDlgData(void){ return &m_dlgdata; }
	void					SetDlgData(EPNSD_DLGDATA* pDlgData)
							{ memcpy(&m_dlgdata, pDlgData, sizeof(EPNSD_DLGDATA)); }

	int						Show_OptionDlg(CWnd* pParent);
	int						Show_LANSelDlg(CWnd* pParent);
	int						Show_GroupDlg(CWnd* pParent);
	int						Show_VersionDlg(CWnd* pParent);

private:
	EPNSD_DLGDATA			m_dlgdata;
	HMODULE					m_hNSSOPLib;
	PROC_EPNSD_Init			m_pfnEPNSD_Init;
	PROC_EPNSD_GetDlgData	m_pfnEPNSD_GetDlgData;
	PROC_EPNSD_DoOptionDlg	m_pfnEPNSD_DoOptionDlg;
	PROC_EPNSD_DoLANSelDlg	m_pfnEPNSD_DoLANSelDlg;
	PROC_EPNSD_DoGroupDlg	m_pfnEPNSD_DoGroupDlg;
	PROC_EPNSD_DoVersionDlg	m_pfnEPNSD_DoVersionDlg;
};

#endif 
