/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#if !defined(AFX_CLIENT_H__97102EEB_F79F_48DD_9CF3_513D27FC2366__INCLUDED_)
#define AFX_CLIENT_H__97102EEB_F79F_48DD_9CF3_513D27FC2366__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif 
#include "EP_NSS.h"
#include "ClientSock.h"
#include "..\\Common\\EconCommand.h"
#include <winuser.h>


#define __USE_KEEPALIVE__								


#define VNESLOST_TIMEOUT				5000			
#define THREAD_SLEEP_TIME				5				
#define ECM_CLIENTCOMMAND				WM_USER+2020	
#define WM_TERM_CTTHREAD				WM_USER+2021
#define ECM_RECVBUF_MAXLEN				2048			
#define CLIENTNODATARECV_MAX			10				
														


#ifdef __USE_KEEPALIVE__ 

#define KEEPALIVE_TIME					5000			



														
#endif 




enum _e_throw_commands {
	e_disconclient	=1,
	e_interrupt		=2,
	e_VNeSrecvnodata=3,


	e_resendid		=6,
	e_networkerr	=7
};


enum _e_client_status {
	e_connected		= 1,	
	e_restart		= 2,	
	e_restarted		= 4,	
	e_disablesock	= 8,	
	e_recvconnect	= 16,	
	e_keyworderror	= 32,	
	e_vneslost		= 64	
};




class CECClientThread : public CWinThread
{

	DECLARE_DYNAMIC(CECClientThread)

public:
	CECClientThread(HWND hMainWnd, ULONG ulSvrAddr, int nPort);

	virtual	~CECClientThread();

	HWND				m_hMainWnd;			
	HANDLE				m_hEventKill;
	HANDLE				m_hEventDead;
	CRITICAL_SECTION	m_csLock;
	SOCKET				m_hSocket;			
	CClientSock*		m_pSock;
	BOOL				m_bsent_restart;


	BOOL				m_useKeyword;


	unsigned char	m_cUniqInfo[ECON_UNIQINFO_LENGTH];	



#ifdef __USE_KEEPALIVE__ 
	DWORD				m_dwKeepAliveSentTime;


#endif 


	ULONG			GetIPAddress(void);		
	unsigned char*	GetUniqInfo(void);		
	char*			GetProjName(void);		
											
	DWORD			GetStatus(void);		
	void			SetStatus(DWORD state);	

	void			KillThread();			

											
	void			OnReceive(CClientSock *sock, int nErrorCode);
	void			OnSockClose(void);
	
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	

protected:

	DWORD			m_nState;							
	ULONG			m_ulIPAddr;							
	ULONG			m_ulSvrAddr;						
	int				m_nPort;							

	char			m_projName[ECON_PROJNAME_MAXLEN];	
	DWORD			m_dwVNeSLostTime;					
	
	void			NoticeToMain(int cmd);				
	
	virtual void	Delete();
	virtual BOOL	OnIdle( LONG lCount );
	afx_msg void	OnTermThread(UINT, LONG);
	
	

	DECLARE_MESSAGE_MAP()
};



#endif
