/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#if !defined(AFX_ECPING_H__A960D78E_9E40_11D6_BC84_002018A23969__INCLUDED_)
#define AFX_ECPING_H__A960D78E_9E40_11D6_BC84_002018A23969__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif 

#include "IPexport.h"

#define ECPING_TIMEOUT			200			
#define ECPING_IPCOUNTMAX		8			
#define	ECP_SLEEP_TIME			10			
#define ECP_THREADWAIT_TIME		2000		
#define ECPING_DLLNAME			"ICMP.DLL"
#define ECPING_SUCCESS			1
#define ECPING_NOREPLY			0
#define ECPING_ERROR			-1




typedef  HANDLE ( WINAPI *PROC_IcmpCreateFile)(void);
typedef  DWORD ( WINAPI *PROC_IcmpSendEcho)(
								HANDLE                   IcmpHandle,
								ULONG                   DestinationAddress,
								LPVOID                   RequestData,
								WORD                     RequestSize,
								PIP_OPTION_INFORMATION   RequestOptions,
								LPVOID                   ReplyBuffer,
								DWORD                    ReplySize,
								DWORD                    Timeout
							 );
typedef  BOOL ( WINAPI *PROC_IcmpCloseHandle)(HANDLE  IcmpHandle);


class CECPing  
{
public:
	CECPing();
	virtual ~CECPing();

	BOOL					Init(ULONG ulAddr, ULONG ulMask, ULONG ulGateway);
	int						GetIPCount(void){	return m_nPingCount; }
	ULONG					GetIPAddr(int index);
	BOOL					Echo(ULONG ulHost);
	int						EchoCheck(ULONG ulAddr, DWORD timeout=ECPING_TIMEOUT);

	BOOL					SearchIPAddr(void);
	BOOL					GetRunThread(void);
	void					SetRunThread(BOOL run);
	BOOL					GetKill(void);

private:
	BOOL					m_bKill;
	BOOL					m_bRunThread;
	CRITICAL_SECTION		m_csLock;
	int						m_nPingCount;
	int						m_nCurPos;
	ULONG					m_ulPCAddr;
	ULONG					m_ulPCMask;
	ULONG					m_uIPCGateway;
	ULONG					m_ulIPList[ECPING_IPCOUNTMAX];
	BOOL					m_bCompleteSearchIP;

	HMODULE					m_hICMPMofule;
	PROC_IcmpCreateFile		m_pfnICMPCreateFile;
	PROC_IcmpSendEcho		m_pfnICMPSendEcho;
	PROC_IcmpCloseHandle	m_pfnICMPCloseHandle;
	
	int						ICMPEcho(ULONG ulAddr, DWORD timeout=ECPING_TIMEOUT);
};

#endif 
