/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#if !defined(AFX_ECSERVER_H__B132AA60_2609_4278_BF33_DA5001C14FE2__INCLUDED_)
#define AFX_ECSERVER_H__B132AA60_2609_4278_BF33_DA5001C14FE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif 

class CECServer;

#include <afxmt.h>
#include "EP_NSS.h"
#include "ECClientThread.h"
#include "..\\Common\\ECSearchClient.h"
#include "ListenThread.h"



#include "..\\Common\\EconCommand.h"


#define	ECS_NOERR						 0		
#define ECS_ERR_MEMALLOC				-1		
#define ECS_ERR_NORECVCLIENT			-2		
#define ECS_ERR_WRITETOSTRMFILE			-3		
#define ECS_ERR_POSTMESSAGE				-4		
#define ECS_ERR_READFROMSTRMFILE		-5		
#define ECS_ERR_FAILCONREQUEST			-7		
#define ECS_ERR_SOCKETERROR				-8		
#define ECS_ERR_NOTALLRECEIVE			-9		
#define ECS_ERR_NORECEIVE				-10		
#define ECS_ERR_CREATETHREAD			-11		
#define ECS_ERR_PARAM					-12		
#define ECS_ERR_KEYWORD					-13		
#define ECS_ERR_NORECVANDKEYWORD		-14		
#define ECS_NOTALLRECVANDKEYWORD		-15		
#define ECS_ERR_UNKNOWN					-99		


#define ECON_UDPRECV_BUFSIZE	1024
#define ECS_TIMEOVER_CONNECT	500
#define ECS_TIMEOVER_DISCONNECT	250
#define ECS_SLEEPTIME			20

typedef struct{
	unsigned char UniqInfo[ECON_UNIQINFO_LENGTH];
} UNIQINFO;

class CListenThread;

class CECServer  
{
public:

	CECServer(HWND hPntWnd, ULONG ulSvrIP, UINT nPort);
	virtual ~CECServer();

	HWND			m_hParentWnd;			
	ULONG			m_ilSvrAddr;			
	unsigned int	m_nPort;				


	UNIQINFO		m_KwdErrList[ECON_SELECTPROJ_MAXNUM_LIMIT];

	int				m_nKwdErrCount;
	CListenThread*  m_pListener;


	void	SetParentHWND(HWND hParent){ m_hParentWnd = hParent; }






	int		StartEasyConnect(CECSearchClient *pECsc, CLIENTINFO* pConCltInf, 
		                     UINT nConCltNum, BOOL bEasyMode, int *keyError);



	int		RestartClients(void);

	void	ClearThreadList(void);		
	int		GetThreadCount(void);		
	void	OnAcceptClient(CECClientThread* pThread);	

	BOOL	StartListen(void);
	void	CloseListen(void);

	CRITICAL_SECTION	m_csLock;

	CECClientThread*	GetClientThread(int index);
	CECClientThread*	GetClientThread(unsigned char* pUniqInfo);


	CEconCommand*		GetEconCommand(void){ return &m_EconCmd; }


	BOOL	KillClientThread(unsigned char* pUniqInfo);	
	void	SetStatusAllClients(DWORD status, BOOL flg);

private:



	CPtrList		m_TCPThreadList;		
	CEconCommand	m_EconCmd;				



};

#endif 
