/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



#if !defined(AFX_EP_NSS_H__74161484_633C_11D6_BC84_002018A23969__INCLUDED_)
#define AFX_EP_NSS_H__74161484_633C_11D6_BC84_002018A23969__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif 

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"



#include "..\\Common\\EMPCommon.h"
#include "..\\Common\\EMPLocalize.h"

#include "..\\Common\\Log.h"
extern Log eclog;
extern Log netlog;
extern Log ecctlog;
extern Log listenlog;
extern Log searchlog;
extern Log escvplog;
extern Log pinglog;

class CEP_NSSApp : public CWinApp
{
public:
	CEP_NSSApp();

	UINT		m_nPort;					

	UINT		m_maxProjectors;			
	UINT		m_resolutionMaxWidth;		
	UINT		m_resolutionMaxHeight;		



	BOOL			m_bUseGroupList;			

	ULONG		m_nAdpIPAddress;
	BYTE		m_sCurrentMACAddr[ECON_MACADDRESS_MAXLEN+1];
	char		m_sAppPath[MAX_PATH];		
	BOOL		m_bUseEncryption;			
	BOOL		m_bUseIPConnect;			
											
	char		m_sIPConAddr[ECON_IPADDRSTR_MAXLEN];

	UINT		m_nIPListMaxCount;			


	char		m_sNSGroupPath[MAX_PATH];

	BOOL		SaveRegistry(void);			
private:
	HANDLE		m_hMutex;					
	
	BOOL		m_bOutputLogFile;			
	char		m_sLocalizeFName[MAX_PATH];	
	unsigned short m_usESCVPPort;			

	BOOL		CheckMutex(void);
	int			GetOSVersion(void);			
	BOOL		LoadRegistry(void);			
	
	int			GetAppDir(char *pDst);		
	BOOL		CheckFileExists(CEMPLocalize *plocaldata, char* pFName); 

	
	public:
	virtual BOOL InitInstance();
	


	
	
	DECLARE_MESSAGE_MAP()
};




#endif
