/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



#include "stdafx.h"
#include "EP_NSS.h"
#include "EP_NSSDlg.h"



#include "..\\Common\\AdaptersInfo.h"	

#include "KeywordDlg.h"
#include "EVStream.h"

#include <time.h>
#include "PNEnc.h"
#include <imm.h>

#include "..\\Common\\ECStatic.h"
#include "..\\Common\\IniFileUtil.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

RECT	g_RedrawRec = {5,6,309,298};

RECT	g_ArrowRec = {336,111,343,117};



UINT HTTPOpenThProc( LPVOID pParam );

UINT HTTPOpenThProc( LPVOID pParam )
{
	URLINFO *pURLInf = (URLINFO*)pParam;

	CWaitCursor wait;
	HINSTANCE hShellInst = ::ShellExecute(NULL, "open", pURLInf->sProjURL, NULL, NULL, SW_SHOW);
	if( (int)hShellInst <= 32 ){
		eclog.Print(LL_ERROR, "Failed to open URL.error code = %d\n",(int)hShellInst);




		::MessageBox(NULL, pURLInf->sErrorMessage, ECON_PRODUCTNAME, MB_OK|MB_ICONSTOP);


	}
	return 0;
}


UINT ShowMessageThProc( LPVOID pParam );

UINT ShowMessageThProc( LPVOID pParam )
{
	char *sMessage = (char*)pParam;




	::MessageBox(NULL, sMessage, ECON_PRODUCTNAME, MB_OK|MB_ICONWARNING);


	return 0;
}





CEP_NSSDlg::CEP_NSSDlg(CEMPLocalize *plczRes, CWnd* pParent)
	: CDialog(CEP_NSSDlg::IDD, pParent)
{
	
	
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_plczRes = plczRes;
	m_nUIMode = UIMODE_PROJLIST;
	m_nBackBmpID = BMP_BKGND_EASYMODE;
	m_bUseIPConnect = FALSE;
	m_bUseEnc = FALSE;
	m_sIPConAddr[0] = '\0';
	m_bNowConnect   = FALSE;

	m_nBtnTop  = 0;
	m_nAdpIndex = 0;
	m_nAdpIPAddress = 0;
	m_pECSrchClt = NULL;
	m_nSearchTimer = 0;
	m_nResultTimer = 0;
	m_nIndicateTimer = 0;
	m_bExistProj = FALSE;
	m_pECServer  = NULL;
	m_nConnectCnt = 0;
	m_nIndiCounter = 0;

	m_ulSvrIPAddr=0;
	m_ulSvrSubnet=0;
	m_ulSvrGateway=0;
	m_nVNeSSendDataCnt = 0;
	m_bReConnecting = FALSE;
	m_nFirstSearch  = TRUE;
	m_nWaitCursor = FALSE;
	m_bExpandWindow = FALSE;
	m_nSearchResultCounter = 0;
	m_bEasyMode = TRUE;
	m_pECPing = NULL;
	m_pEscvp = NULL;	


	m_bEMPConnecting = FALSE;
	m_bChangeScrSaveState = FALSE;
	m_usESCVPPort = 0;

	m_ProjListBox.m_maxProjectors=0;	
	m_resolutionMaxWidth=0;		
	m_resolutionMaxHeight=0;		

	memset(&m_URLInfo, 0, sizeof(URLINFO));
	memset(m_cVPSelectClient, 0, ECON_UNIQINFO_LENGTH);
	memset(&m_vnesInitData, 0, sizeof(rfbServerInitMsg));

	m_lstStatic.RemoveAll();


	m_IPProjListBox.m_maxProjectors=0;


	m_nGuideMesStatus = 0;			


	m_bHelpArrow	= FALSE;		
	m_nHelpArrowTimer	= NULL;


	m_bNoSupportUXGA = FALSE;


	m_bDisconnecting = FALSE;


	m_pSplash = NULL;

	lstrcpy(m_sGroupName, "");
}

void CEP_NSSDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	
	DDX_Control(pDX, IDC_IPPROJLIST, m_IPProjListBox);
	DDX_Control(pDX, IDC_CMPROJLIST, m_cbSelProj);
	DDX_Control(pDX, IDC_PROJLIST, m_ProjListBox);
	
}

BEGIN_MESSAGE_MAP(CEP_NSSDlg, CDialog)
	
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SHOWWINDOW()
	ON_WM_NCHITTEST()
	ON_BN_CLICKED(ECON_BTN_EXIT, OnBtnExit)
	ON_BN_CLICKED(ECON_BTN_HELP, OnBtnHelp)
	ON_BN_CLICKED(ECON_BTN_LIST, OnBtnList)
	ON_BN_CLICKED(ECON_BTN_URL, OnBtnURL)
	ON_BN_CLICKED(ECON_BTN_PAUSE, OnBtnPause)
	ON_BN_CLICKED(ECON_BTN_AVMUTE, OnBtnAVMute)
	ON_BN_CLICKED(ECON_BTN_EZOOM, OnBtnEZoom)
	ON_BN_CLICKED(ECON_BTN_KIHON, OnBtnKihon)
	ON_BN_CLICKED(ECON_BTN_VIDEO, OnBtnVideo)
	ON_BN_CLICKED(ECON_BTN_PC, OnBtnPC)
	ON_BN_CLICKED(ECON_BTN_CONNECT, OnBtnConnect)
	ON_BN_CLICKED(ECON_BTN_DISCON, OnBtnDisConnect)
	ON_BN_CLICKED(ECON_BTN_IPCON, OnBtnIPCon)
	ON_BN_CLICKED(ECON_BTN_EASYCON, OnBtnEasyCon)
	ON_BN_CLICKED(ECON_BTN_OPTION, OnBtnOption)
	ON_BN_CLICKED(ECON_BTN_SEARCH, OnBtnSearch)
	ON_BN_CLICKED(ECON_BTN_BARMIN,	OnBtnMin)
	ON_BN_CLICKED(ECON_BTN_KAKUCLOSE, OnBtnKakuClose)
	ON_BN_CLICKED(ECON_BTN_EZOOMMINUS, OnBtnEZoomMinus)
	ON_BN_CLICKED(ECON_BTN_EZOOMPLUS, OnBtnEZoomPlus)
	ON_BN_CLICKED(ECON_BTN_EZOOMCANCEL, OnBtnEZoomCancel)
	ON_BN_CLICKED(ECON_BTN_LIGHTMINUS, OnBtnBrightMinus)
	ON_BN_CLICKED(ECON_BTN_LIGHTPLUS, OnBtnBrightPlus)
	ON_BN_CLICKED(ECON_BTN_CONTRASTMINUS, OnBtnContrastMinus)
	ON_BN_CLICKED(ECON_BTN_CONTRASTPLUS, OnBtnContrastPlus)
	ON_BN_CLICKED(ECON_BTN_KEYSTONEMINUS, OnBtnKeystoneMinus)
	ON_BN_CLICKED(ECON_BTN_KEYSTONEPLUS, OnBtnKeystonePlus)
	ON_BN_CLICKED(ECON_BTN_COLORMODE, OnBtnColorMode)
	ON_BN_CLICKED(ECON_BTN_MAINHELP, OnBtnMiniHelp)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_CBN_CLOSEUP(IDC_CMPROJLIST, OnCloseupCmprojlist)
	ON_WM_SYSCOMMAND()
	ON_WM_QUERYENDSESSION()
	ON_BN_CLICKED(ECON_BTN_BARCLOSE, OnBtnExit)
	ON_MESSAGE(WM_CTLCOLORSTATIC ,OnCtlColorStatic)
	ON_MESSAGE(ECS_MESSAGE, OnESCCommand)
	ON_MESSAGE(ECM_CLIENTCOMMAND ,OnECMCommand)
	ON_MESSAGE(WM_POWERBROADCAST, OnPowerBroadcast)
	ON_MESSAGE(WM_ECBUTTON_REPEAT, OnECBtnCommand)
	ON_REGISTERED_MESSAGE(EV_COMMAND, OnVNeSCommand)
	ON_WM_SETCURSOR()
	ON_REGISTERED_MESSAGE(PLIST_NETWORKERR, OnIPProjListMes)
	ON_NOTIFY_EX(TTN_NEEDTEXT, 0, ToolHint)
	
END_MESSAGE_MAP()







BOOL CEP_NSSDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	SetIcon(m_hIcon, TRUE);			
	SetIcon(m_hIcon, FALSE);		

	
	int nErr = InitEP_NSSDialog();
	if( nErr != ECDLG_NOERR ){
		if( nErr == ECDLG_ERR_MEMALLOC )
			ECMessageBox(IDS_ERR_STRING0016);
		else if( nErr == ECDLG_ERR_INIT )
			ECMessageBox(IDS_ERR_STRING0013);
		else if( nErr == ECDLG_ERR_LOADVNES )
			ECMessageBox(IDS_ERR_STRING0022);

		EndDialog(IDCANCEL);
		return TRUE;
	}

	m_pSplash = new CSplashWnd(m_plczRes, NULL);
	if( m_pSplash )
		m_pSplash->Create(IDD_SPLASHDLG, NULL);

	m_pSplash->ShowWindow(SW_SHOW);



	
	ChangeUIMode(UIMODE_PROJLIST);


	
	PostMessage(WM_TIMER, ECON_TIMEREVENT_SEARCHTIMER, NULL);

	return TRUE;  
}



BOOL
CEP_NSSDlg::InitEP_NSSDialog()
{
	
	if( !m_plczRes ){
		eclog.Print(LL_ERROR, "Localize data is NULL.\n");
		return ECDLG_ERR_INIT;
	}


	





	TCHAR sPath[MAX_PATH];
	sprintf(sPath, "%s\\%s", ((CEP_NSSApp*)AfxGetApp())->m_sAppPath, ECON_EPNSSOP_FNAME);
	if( !m_cDlgMng.Load(sPath) ){
		eclog.Print(LL_ERROR, "Failed to Load EP_NSSOP.dll.\n");
		return ECDLG_ERR_INIT;
	}




	
	this->SetWindowText(ECON_PRODUCTNAME);
	ModifyStyle(WS_CAPTION, 0);
	SetMenu(0);
	DrawMenuBar();

	
	m_ProjListBox.SetLocalize(m_plczRes);
	m_ProjListBox.SetItemHeight(0, PROJLIST_ITEM_HEIGHT);
	
	ImmAssociateContext(m_ProjListBox.m_hWnd, NULL);
	

	m_ProjListBox.SetPLStyle(PLIST_STYLE_CHECKBOX);


	m_IPProjListBox.SetLocalize(m_plczRes);
	m_IPProjListBox.SetItemHeight(0, PROJLIST_ITEM_HEIGHT);
	ImmAssociateContext(m_IPProjListBox.m_hWnd, NULL);
	m_IPProjListBox.SetPLStyle(PLIST_STYLE_CHECKBOX | PLIST_STYLE_IPADDRESS);



	
	m_cbSelProj.SetBackColor(RGB(190,190,190));

	
	char randStr[ECON_ENCRYPTION_MAXLEN+1];
	srand( (unsigned)time( NULL ) );
	sprintf(randStr, "%08d", rand()+1);
	memcpy(m_cEncPassword, randStr, ECON_ENCRYPTION_MAXLEN);

	
	LCDIALOG *dlg = m_plczRes->GetDlgInf(DLGID_PROJLIST);
	if( !dlg )
		return ECDLG_ERR_INIT;

#ifdef _USE_SYSTEMFONT_
	LOGFONT logFont;
	memset(&logFont, 0, sizeof(logFont));
	::GetObject(GetStockObject(DEFAULT_GUI_FONT), sizeof(LOGFONT), &logFont);
	logFont.lfHeight = -(dlg->fontsize);
	logFont.lfWidth = 0;
	lstrcpy(logFont.lfFaceName, dlg->font);
	m_dlgFont.CreateFontIndirect(&logFont);













	LOGFONT lf;
	m_dlgFont.GetLogFont(&lf);
	eclog.Print(LL_STATE, "set dialog font to default gui font. name=%s / height=%d / width=%d\n"
		                  ,lf.lfFaceName, lf.lfHeight, lf.lfWidth);





#else
	if( !m_dlgFont.CreateFont(-(dlg->fontsize), 0, 0, 0, dlg->weight, FALSE, FALSE, FALSE, (BYTE)dlg->charset,
		            OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, 
					DEFAULT_PITCH | FF_DONTCARE, dlg->font) )
		return ECDLG_ERR_INIT;
#endif

	SetCtrlStat(IDC_PROJLIST, ECON_LBX_PROJLIST, &m_dlgFont);
	SetCtrlStat(IDC_IPSCHRESULT, ECON_STX_SCHRESULT, &m_dlgFont);
	SetCtrlStat(IDC_CMPROJLIST, ECON_CMB_SELPROJLIST, &m_dlgFont);

	SetCtrlStat(IDC_IPPROJLIST, ECON_LBX_IPPROJLIST, &m_dlgFont);











	
	
	LCCONTROL *lcCtl = m_plczRes->GetCtlInf(ECON_IPA_IPADDRESS);
	if( !lcCtl ){
		eclog.Print(LL_ERROR, "Failed to get IPAddress Control data.\n");
		return ECDLG_ERR_INIT;
	}



	if( !m_IPAddress.Create(NULL, NULL, WS_TABSTOP | WS_GROUP, lcCtl->rec, this, ECON_IPA_IPADDRESS) )

	{
		eclog.Print(LL_ERROR, "Failed to create IPAddress Control.\n");
		return ECDLG_ERR_INIT;
	}
	
	m_IPAddress.SetFont(&m_dlgFont);


	
	lcCtl = m_plczRes->GetCtlInf(ECON_BMP_INDICATOR);
	if( !lcCtl ){
		eclog.Print(LL_ERROR, "Failed to get indicator control info.\n");
		return ECDLG_ERR_INIT;
	}

	m_recIndi = lcCtl->rec;


	int nTabOrder[512], nTabCount=0;

	
	for(int i=0; i<m_plczRes->GetHeader()->nCtlCnt; i++)
	{
		LCCONTROL *pCtl = m_plczRes->GetCtlInf( ECON_CTRLRESOURCE_ID + i);
		if( !pCtl ){
			eclog.Print(LL_ERROR, "Failed to get control info id=%d.\n",ECON_CTRLRESOURCE_ID + i);
			return ECDLG_ERR_INIT;
		}

		if( pCtl->dlgID == DLGID_PROJLIST && pCtl->tapStop > 0 && pCtl->tapStop < 512 ){
			nTabOrder[pCtl->tapStop] = pCtl->rsID;
			nTabCount++;
		}



		if( pCtl->type == CTLTYPE_BUTTON && pCtl->dlgID == DLGID_PROJLIST){


			CECButton *pBtn = new CECButton(m_plczRes);

			if( pBtn ){
 				DWORD style = WS_VISIBLE | BS_OWNERDRAW;


				if( pCtl->tapStop ) style |= WS_TABSTOP | BS_DEFPUSHBUTTON | WS_GROUP;

				pBtn->Create("", style, pCtl->rec, this, ECON_CTRLRESOURCE_ID + i);
				pBtn->SetLCRes(m_plczRes);









				try{
					m_lstButton.AddTail(pBtn);
				}catch(CMemoryException* e){
					e->Delete();
					return ECDLG_ERR_MEMALLOC;
				}
			}else{
				return ECDLG_ERR_MEMALLOC;
			}

		
		}else if( pCtl->type == CTLTYPE_STATIC && pCtl->dlgID == DLGID_PROJLIST)
		{
			DWORD style = WS_VISIBLE | SS_NOPREFIX;
			
			if( pCtl->textAlign == CTLALIGN_LEFT )
				style |= SS_LEFT;
			else if( pCtl->textAlign == CTLALIGN_RIGHT )
				style |= SS_RIGHT;
			else if( pCtl->textAlign == CTLALIGN_CENTER )
				style |= SS_CENTER;

			CECStatic *pSTxt = new CECStatic(m_plczRes);
			if( pSTxt )
			{
				pSTxt->Create("", style, pCtl->rec, this, ECON_CTRLRESOURCE_ID + i);
				try{
					m_lstStatic.AddTail(pSTxt);
				}catch(CMemoryException* e){
					e->Delete();
					return -1;
				}
			}
		}

	}


	for(int j=2; j<nTabCount; j++){
		CWnd *preWnd = this->GetDlgItem(nTabOrder[j-1]);
		CWnd *nowWnd = this->GetDlgItem(nTabOrder[j]);
		if( preWnd && nowWnd ){
			nowWnd->SetWindowPos(preWnd,0,0,0,0,SWP_NOMOVE | SWP_NOSIZE );
		}
	}


	
	if( !m_VNeSLib.LoadLib(((CEP_NSSApp*)AfxGetApp())->m_sAppPath) ){
		eclog.Print(LL_ERROR, "Failed to load EP_NSSE.dll file.\n");
		return ECDLG_ERR_LOADVNES;
	}

	
	if( !GetAdaptersInfo() ){
		eclog.Print(LL_ERROR, "Failed to GetAdaptersInfo.\n");
		return ECDLG_ERR_OTHER;
	}

	
	m_pECPing = new CECPing();
	if( !m_pECPing ){
		eclog.Print(LL_ERROR, "Failed to create 'CECPing' Object.\n");
		return ECDLG_ERR_MEMALLOC;
	}

	if( !m_pECPing->Init(m_ulSvrIPAddr, m_ulSvrSubnet, m_ulSvrGateway)){
		eclog.Print(LL_ERROR, "Failed to Initialize 'CECPing' Object.\n");
		delete m_pECPing;
		m_pECPing = NULL;
		return ECDLG_ERR_INIT;
	}

	
	m_pECSrchClt = new CECSearchClient(this->m_hWnd, m_ulSvrIPAddr, ((CEP_NSSApp*)AfxGetApp())->m_nPort);
	if( !m_pECSrchClt ){
		eclog.Print(LL_ERROR, "Failed to create 'CECSearchClient' Object.\n");
		return ECDLG_ERR_MEMALLOC;
	}

	
	m_pECServer = new CECServer(this->m_hWnd, m_ulSvrIPAddr, ((CEP_NSSApp*)AfxGetApp())->m_nPort);
	if( !m_pECServer ){
		eclog.Print(LL_ERROR, "Failed to Create CECServer Object.\n");
		return ECDLG_ERR_MEMALLOC;
	}

	
	if( !m_pECServer->StartListen() ){
		eclog.Print(LL_ERROR, "Failed to Start Socket Listener.\n");
		return ECDLG_ERR_INIT;
	}

	
	if( !m_VNeSLib.VNeSStart(this->m_hWnd) ){
		eclog.Print(LL_ERROR, "Failed to start VNeS Server.\n");
		return ECDLG_ERR_INIT;
	}

	
	EnableToolTips(TRUE);

	return ECDLG_NOERR;
}


void CEP_NSSDlg::OnDestroy() 
{
	eclog.Print(LL_STATE, "Enter OnDestroy Function.\n");

	if( m_nHelpArrowTimer ){
		KillTimer(m_nHelpArrowTimer);
		m_nHelpArrowTimer = NULL;
		
		m_bHelpArrow = FALSE;
	}

	ClearEMPProcess();
	eclog.Print(LL_STATE, "Complete clear EMPProcess function.\n");
	
	
	if( !m_lstButton.IsEmpty()){
		POSITION pos = m_lstButton.GetHeadPosition();
		while(pos){
			CECButton *ecb = (CECButton*)m_lstButton.GetNext(pos);
			if( ecb ) delete ecb;
		}
	}
	m_lstButton.RemoveAll();
	eclog.Print(LL_STATE, "Complete delete Button controls.\n");


		
	if( !m_lstStatic.IsEmpty()){
		POSITION pos = m_lstStatic.GetHeadPosition();
		while(pos){
			CECStatic *ecs = (CECStatic*)m_lstStatic.GetNext(pos);
			if( ecs ) delete ecs;
		}
	}
	m_lstStatic.RemoveAll();
	eclog.Print(LL_STATE, "Complete delete CECStatic controls.\n");


	
	if( !m_lstFont.IsEmpty()){
		POSITION pos = m_lstFont.GetHeadPosition();
		while(pos){
			CFont *pFn = (CFont*)m_lstFont.GetNext(pos);
			if( pFn ) delete pFn;
		}
	}
	m_lstFont.RemoveAll();
	eclog.Print(LL_STATE, "Complete delete Font controls.\n");


	if( m_pSplash ){
		m_pSplash->DestroyWindow();
		delete m_pSplash;
		m_pSplash = NULL;
	}

	CDialog::OnDestroy();
	eclog.Print(LL_STATE, "Exit OnDestroy Function.\n");
}


void
CEP_NSSDlg::ClearEMPProcess()
{
	eclog.Print(LL_STATE, "Enter ClearEMPProcess Function.\n");

	m_bNowConnect = FALSE;


	






	
	if( m_pECServer ){
		m_pECServer->RestartClients(); 
		m_pECServer->ClearThreadList();
		eclog.Print(LL_STATE, "Clear all Client's Socket.\n");
	}


	if( m_VNeSLib.IsConnecting() ){
		m_VNeSLib.Disconnect();
		eclog.Print(LL_STATE, "Disconneted VNeS.\n");
	}


	
	eclog.Print(LL_STATE, "Free Library of VNeS.\n");
	m_VNeSLib.FreeLib();

	
	if( m_nSearchTimer ){
		KillTimer(m_nSearchTimer);
		m_nSearchTimer = NULL;
		eclog.Print(LL_STATE, "Stopped projector search timer.\n");
	}

	
	if( m_nResultTimer ){
		KillTimer(m_nResultTimer);
		m_nResultTimer = NULL;
		eclog.Print(LL_STATE, "Stopped ResultTimer.\n");
	}

	
	if( m_nIndicateTimer ){
		KillTimer(m_nIndicateTimer);
		m_nIndicateTimer = NULL;
		eclog.Print(LL_STATE, "Stopped IndicateTimer.\n");
	}

	
	if( m_pECServer ){
		delete m_pECServer;
		m_pECServer = NULL;
		eclog.Print(LL_STATE, "deleted ECServer class.\n");
	}

	
	if( m_pECSrchClt ){
		delete m_pECSrchClt; 
		m_pECSrchClt = NULL;
		eclog.Print(LL_STATE, "deleted CECSearchClient class.\n");
	}

	
	if( m_pECPing ){
		delete m_pECPing;
		m_pECPing = NULL;
		eclog.Print(LL_STATE, "Killed Ping Thread.\n");
	}

	
	if( m_bChangeScrSaveState ){
		SystemParametersInfo(SPI_SETSCREENSAVEACTIVE, TRUE, NULL, SPIF_SENDCHANGE);
		m_bChangeScrSaveState = FALSE;
	}
	

	eclog.Print(LL_STATE, "Exit ClearEMPProcess Function.\n");	
}



void CEP_NSSDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); 

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this);
		if( m_plczRes ){
			
			m_plczRes->PaintDIBmp(dc, 0, 0, m_nBackBmpID);

			
			if( m_bNowConnect && m_nConnectCnt == 1 ){



				m_plczRes->PaintDIBmp(dc, 89, m_nBtnTop, BMP_BKGND_KUGIRI);
				m_plczRes->PaintDIBmp(dc, 209, m_nBtnTop, BMP_BKGND_KUGIRI);

			}else
			{



				m_plczRes->PaintDIBmp(dc, 89, m_nBtnTop, BMP_BKGND_KUGIRIGRAY);
				m_plczRes->PaintDIBmp(dc, 209, m_nBtnTop, BMP_BKGND_KUGIRIGRAY);

			}

			
			if( !m_bNowConnect )
			{
				m_plczRes->PaintDIBmp(dc, m_recIndi.left, m_recIndi.top, BMP_INDICATOR,
									m_recIndi.right-m_recIndi.left, m_recIndi.bottom-m_recIndi.top,
									0,0);
			}


			if( m_bHelpArrow ){
				m_plczRes->PaintDIBmp(dc, g_ArrowRec.left, g_ArrowRec.top, BMP_HLP_ARROW );
			}


		}		
		CDialog::OnPaint();
	}
}



LRESULT
CEP_NSSDlg::OnPowerBroadcast(WPARAM wParam, LPARAM lParam)
{
	lParam;




	if( wParam == PBT_APMQUERYSUSPEND){
		
		if( m_nSearchTimer ){
			eclog.Print(LL_STATE, "Stopped projector search timer.\n");
			KillTimer(m_nSearchTimer);
			m_nSearchTimer = NULL;
		}

	
	}else if( wParam == PBT_APMRESUMESUSPEND)
	{
		if( !m_nSearchTimer && m_nUIMode == UIMODE_PROJLIST){
			m_nSearchTimer = SetTimer(ECON_TIMEREVENT_SEARCHTIMER, ECON_PROJLIST_TIMERINTERVAL, NULL);
			eclog.Print(LL_STATE, "Start timer for searching projector.\n");
		}
		this->RedrawWindow();
	}


	return TRUE;
}


HCURSOR CEP_NSSDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



void CEP_NSSDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);

	




	



}


	
void
CEP_NSSDlg::ChangeUIMode(int nUIMode)
{
	eclog.Print(LL_STATE, "Enter ChangeUIMode Function. UIMODE=%d\n",nUIMode);

	
	((CEP_NSSApp*)AfxGetApp())->SetThreadPriority(THREAD_PRIORITY_TIME_CRITICAL);

	RECT recDlg, *RedrawRec=NULL;
	int nPreUIMode = m_nUIMode;
	int	nPreBackBmpID = m_nBackBmpID;
	m_nUIMode = nUIMode;
	CWnd* pWnd = NULL;
	m_bHelpArrow = FALSE;
	

	
	
	WINDOWPLACEMENT stWpm;
	GetWindowPlacement(&stWpm);

	recDlg.left = stWpm.rcNormalPosition.left;
	recDlg.top = stWpm.rcNormalPosition.top;
	recDlg.right = stWpm.rcNormalPosition.right;
	recDlg.bottom = stWpm.rcNormalPosition.bottom;


	
	if( nUIMode != UIMODE_PROJLIST ){
		
		if( m_nSearchTimer ){
			eclog.Print(LL_STATE, "Stopped projector search timer.\n");
			KillTimer(m_nSearchTimer);
			m_nSearchTimer = NULL;
		}
	}
	
	if( nUIMode != UIMODE_IPCONNECT){
		if( m_IPProjListBox.IsSearching() ){
			m_IPProjListBox.StopSearchClient();
		} 
	}

	SetItemStat(ECON_BTN_CONNECT, !m_bNowConnect, (m_nUIMode==UIMODE_PROJLIST || m_nUIMode==UIMODE_IPCONNECT));

	switch(nUIMode){

	
	case UIMODE_NORMAL:				
		m_nBackBmpID = BMP_BKGND_BAR;
		break;

	
	case UIMODE_PROJLIST:
		UpdateProjList();
		
		
		if( !m_nSearchTimer){
			m_nSearchTimer = SetTimer(ECON_TIMEREVENT_SEARCHTIMER, ECON_PROJLIST_TIMERINTERVAL, NULL);
			eclog.Print(LL_STATE, "Start timer for searching projector.\n");
		}

		m_nBackBmpID = BMP_BKGND_EASYMODE;
		if( nPreUIMode == UIMODE_IPCONNECT)
			RedrawRec = &g_RedrawRec;

		if( m_bNowConnect ){


			GuideMessage(ECDLG_MESSTAT_CONNECTING);

			SetItemStat(ECON_BTN_CONNECT, !m_bNowConnect, FALSE);
		}else
		{




			GuideMessage(ECDLG_MESSTAT_CLEAR);



			if( !m_nFirstSearch ){

				if( m_pECSrchClt ){
					if( m_pECSrchClt->GetClientCount() == 0){


						GuideMessage(ECDLG_MESSTAT_NOTFOUND);

						m_bExistProj = FALSE;
					}else{


						GuideMessage(ECDLG_MESSTAT_PROJFOUND);

						m_bExistProj = TRUE;
					}
				}
			}
			SetItemStat(ECON_BTN_CONNECT, !m_bNowConnect, m_bExistProj);

		}

		pWnd = this->GetDlgItem(ECON_STX_MAINTITLE);
		if( pWnd )
			pWnd->SetWindowText(m_plczRes->GetString(IDS_RES_STRING0051));

		break;
	
	
	case UIMODE_IPCONNECT:
		m_nBackBmpID = BMP_BKGND_IPMODE;
		if( nPreUIMode == UIMODE_PROJLIST)
				RedrawRec = &g_RedrawRec;
		
		if( m_bNowConnect ){


			GuideMessage(ECDLG_MESSTAT_CONNECTING);

		}else
		{

			











			if( m_IPProjListBox.GetCount() == 0)
				GuideMessage(ECDLG_MESSTAT_NOIPADDRESS);
			else
				GuideMessage(ECDLG_MESSTAT_IPCONNECT);



			
			SetItemStat(ECON_BTN_CONNECT, TRUE, TRUE);
		}
		

		pWnd = this->GetDlgItem(ECON_STX_MAINTITLE);
		if( pWnd )
			pWnd->SetWindowText(m_plczRes->GetString(IDS_RES_STRING0052));


		
		if( !m_IPProjListBox.IsSearching() ){
			m_IPProjListBox.StartSearchClient(	m_ulSvrIPAddr, 
												((CEP_NSSApp*)AfxGetApp())->m_nPort,
												((CEP_NSSApp*)AfxGetApp())->m_sCurrentMACAddr,
												MAC_ADDR_LENGTH);
		}

		break;
	
	case UIMODE_EZOOM:
		m_nBackBmpID = BMP_BKGND_EZOOM;
		break;

	
	case UIMODE_BASESETTING:
		m_nBackBmpID = BMP_BKGND_KIHON;
		break;

	default:
		break;
	}

	
	LCBITMAPDATA *plcBmp=NULL,*pPreBmp=NULL;
	plcBmp = m_plczRes->GetBmpData(m_nBackBmpID);
	pPreBmp = m_plczRes->GetBmpData(nPreBackBmpID);
	if( !plcBmp || !pPreBmp ){
		ECMessageBox(IDS_ERR_STRING0016);
		EndDialog(IDCANCEL);
		return;
	}

	int nDisHeight = pPreBmp->lcBmp.binf.biHeight - plcBmp->lcBmp.binf.biHeight;
	eclog.Print(LL_STATE, "\tnDisHeight = %d.\n", nDisHeight);
	recDlg.top += nDisHeight;
	recDlg.right = recDlg.left + plcBmp->lcBmp.binf.biWidth;
	recDlg.bottom = recDlg.top + plcBmp->lcBmp.binf.biHeight;
	
	
	SCRINFO scrinf;
	GetResolutionInfo(scrinf);
	if( recDlg.top < 0 ){
		recDlg.top = 0;
		recDlg.bottom = plcBmp->lcBmp.binf.biHeight;
	}else if( recDlg.bottom > scrinf.nScrHei ){
		recDlg.top = scrinf.nScrHei - plcBmp->lcBmp.binf.biHeight;
		recDlg.bottom = recDlg.top + plcBmp->lcBmp.binf.biHeight;
	}


	















	
	stWpm.rcNormalPosition.left = recDlg.left;
	stWpm.rcNormalPosition.top = recDlg.top;
	stWpm.rcNormalPosition.right = recDlg.right;
	stWpm.rcNormalPosition.bottom = recDlg.bottom;

	this->SetWindowPlacement(&stWpm);


	

	HRGN hWndRgn = (HRGN)GetNSWindowRgn(m_nBackBmpID);
	if( hWndRgn )
		SetWindowRgn(hWndRgn, TRUE);



	



	
	CECButton *ecb = NULL;


	m_nBtnTop = plcBmp->lcBmp.binf.biHeight - 31;

	for(int i=ECON_BTN_HELP; i<=ECON_BTN_DISCON; i++){
		ecb =(CECButton*)GetDlgItem(i);
		if(ecb){
			RECT bRec;
			ecb->GetWindowRect(&bRec);
			this->ScreenToClient(&bRec);
			ecb->SetWindowPos(NULL, bRec.left, m_nBtnTop,0,0,SWP_NOSIZE|SWP_NOZORDER);
		}
	}
	ecb=(CECButton*)GetDlgItem(ECON_BTN_CONNECT);
	if( ecb ){
		RECT bRec;
		ecb->GetWindowRect(&bRec);
		this->ScreenToClient(&bRec);
		ecb->SetWindowPos(NULL, bRec.left, m_nBtnTop,0,0,SWP_NOSIZE|SWP_NOZORDER);
	}

	ecb=(CECButton*)GetDlgItem(ECON_BTN_BARCLOSE);
	if( ecb ){
		RECT bRec;
		ecb->GetWindowRect(&bRec);
		this->ScreenToClient(&bRec);
		ecb->SetWindowPos(NULL, bRec.left, m_nBtnTop+1,0,0,SWP_NOSIZE|SWP_NOZORDER);
	}
	ecb=(CECButton*)GetDlgItem(ECON_BTN_BARMIN);
	if( ecb ){
		RECT bRec;
		ecb->GetWindowRect(&bRec);
		this->ScreenToClient(&bRec);
		ecb->SetWindowPos(NULL, bRec.left, m_nBtnTop+14,0,0,SWP_NOSIZE|SWP_NOZORDER);
	}


















	
	m_recIndi.top = m_nBtnTop+1;
	m_recIndi.bottom = m_nBtnTop + 23;

	
	SetControlsState(FALSE);

	this->RedrawWindow(RedrawRec);


	
	((CEP_NSSApp*)AfxGetApp())->SetThreadPriority(THREAD_PRIORITY_NORMAL);

	
	if( nUIMode == UIMODE_PROJLIST && !m_bNowConnect){
		m_ProjListBox.SetFocus();
	}else if( nUIMode == UIMODE_IPCONNECT && !m_bNowConnect ){
		m_IPAddress.SetFocus();
	}
	
		
	eclog.Print(LL_STATE, "Exit ChangeUIMode Function.\n",nUIMode);
}



void
CEP_NSSDlg::SetControlsState(BOOL bAllDisable)
{


	SetItemStat(ECON_BTN_EXIT, (!m_bNowConnect && (m_nUIMode==UIMODE_PROJLIST || m_nUIMode==UIMODE_IPCONNECT ))
								, !bAllDisable);

	SetItemStat(ECON_BTN_HELP, TRUE, !bAllDisable);
	SetItemStat(ECON_BTN_LIST, TRUE, m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_URL, TRUE, (m_bNowConnect && m_nConnectCnt==1) && !bAllDisable);
	SetItemStat(ECON_BTN_PAUSE, TRUE, m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_AVMUTE, TRUE, m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_EZOOM, TRUE, m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_KIHON, TRUE, m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_VIDEO, TRUE, (m_bNowConnect && m_nConnectCnt==1 ) && !bAllDisable);
	SetItemStat(ECON_BTN_PC, TRUE, (m_bNowConnect && m_nConnectCnt==1 ) && !bAllDisable);

	SetItemStat(ECON_BTN_DISCON, m_bNowConnect, m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_IPCON, (m_nUIMode==UIMODE_PROJLIST && m_bUseIPConnect), !m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_EASYCON, (m_nUIMode==UIMODE_IPCONNECT), !m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_OPTION, (m_nUIMode==UIMODE_PROJLIST || m_nUIMode==UIMODE_IPCONNECT), !m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_SEARCH, (m_nUIMode==UIMODE_IPCONNECT), !m_bNowConnect && !bAllDisable);


	SetItemStat(ECON_STX_STATMES, (m_nUIMode==UIMODE_PROJLIST|| m_nUIMode==UIMODE_IPCONNECT), TRUE);
	SetItemStat(ECON_STX_STATMES2, (m_nUIMode==UIMODE_PROJLIST|| m_nUIMode==UIMODE_IPCONNECT), TRUE);
	SetItemStat(ECON_STX_STATMES3, (m_nUIMode==UIMODE_PROJLIST|| m_nUIMode==UIMODE_IPCONNECT), TRUE);

	SetItemStat(IDC_PROJLIST, (m_nUIMode==UIMODE_PROJLIST), !bAllDisable);
	SetItemStat(ECON_IPA_IPADDRESS, (m_nUIMode==UIMODE_IPCONNECT),(m_nUIMode==UIMODE_IPCONNECT && !m_bNowConnect && !bAllDisable));
	SetItemStat(IDC_IPSCHRESULT, (m_nUIMode==UIMODE_IPCONNECT), !bAllDisable);



	SetItemStat(ECON_BTN_BARCLOSE, m_bNowConnect, !bAllDisable);
	SetItemStat(ECON_BTN_BARMIN, m_bNowConnect, !bAllDisable);



	SetItemStat(ECON_BTN_KAKUCLOSE, (m_nUIMode==UIMODE_EZOOM || m_nUIMode==UIMODE_BASESETTING ||
									(m_bNowConnect && (m_nUIMode==UIMODE_PROJLIST || m_nUIMode==UIMODE_IPCONNECT)))
								  , !bAllDisable);

	SetItemStat(IDC_CMPROJLIST, (m_nUIMode==UIMODE_EZOOM || m_nUIMode==UIMODE_BASESETTING), m_bNowConnect && !bAllDisable);

	SetItemStat(ECON_BTN_EZOOMMINUS, (m_nUIMode==UIMODE_EZOOM), m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_EZOOMPLUS, (m_nUIMode==UIMODE_EZOOM), m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_EZOOMCANCEL, (m_nUIMode==UIMODE_EZOOM), m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_EZOOMUP, (m_nUIMode==UIMODE_EZOOM), m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_EZOOMDOWN, (m_nUIMode==UIMODE_EZOOM), m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_EZOOMLEFT, (m_nUIMode==UIMODE_EZOOM), m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_EZOOMRIGHT, (m_nUIMode==UIMODE_EZOOM), m_bNowConnect && !bAllDisable);

	SetItemStat(ECON_BTN_LIGHTMINUS, (m_nUIMode==UIMODE_BASESETTING), m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_LIGHTPLUS, (m_nUIMode==UIMODE_BASESETTING), m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_CONTRASTMINUS, (m_nUIMode==UIMODE_BASESETTING), m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_CONTRASTPLUS, (m_nUIMode==UIMODE_BASESETTING), m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_KEYSTONEMINUS, (m_nUIMode==UIMODE_BASESETTING), m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_KEYSTONEPLUS, (m_nUIMode==UIMODE_BASESETTING), m_bNowConnect && !bAllDisable);
	SetItemStat(ECON_BTN_COLORMODE, (m_nUIMode==UIMODE_BASESETTING), m_bNowConnect && !bAllDisable);


	SetItemStat(ECON_STX_MAINTITLE, (m_nUIMode==UIMODE_PROJLIST|| m_nUIMode==UIMODE_IPCONNECT), TRUE);
	SetItemStat(ECON_STX_IPADDRESS, (m_nUIMode==UIMODE_IPCONNECT), TRUE);
	SetItemStat(ECON_STX_PROJLIST, (m_nUIMode==UIMODE_IPCONNECT), TRUE);
	SetItemStat(ECON_BTN_MAINHELP, (m_nUIMode==UIMODE_PROJLIST|| m_nUIMode==UIMODE_IPCONNECT), !m_bNowConnect && !bAllDisable);

	

	m_ProjListBox.SetListEnable(!m_bNowConnect && !bAllDisable);

	SetItemStat(IDC_IPPROJLIST, (m_nUIMode==UIMODE_IPCONNECT), !bAllDisable);
	m_IPProjListBox.SetListEnable(!m_bNowConnect && !bAllDisable);

}


UINT CEP_NSSDlg::OnNcHitTest(CPoint point) 
{
	UINT nHitTest = CDialog::OnNcHitTest(point);
	return (nHitTest ==  HTCLIENT) ? HTCAPTION : nHitTest;
}



HBRUSH
CEP_NSSDlg::OnCtlColorStatic(WPARAM wParam, LPARAM lParam)
{
	lParam;
	SetBkMode((HDC) wParam, TRANSPARENT);
	
	if( m_nUIMode == UIMODE_BASESETTING ||
		m_nUIMode == UIMODE_EZOOM ){
		SetTextColor((HDC)wParam, RGB(210,210,200));
	}else{
		SetTextColor((HDC)wParam, RGB(50,50,50));
	}
	return (HBRUSH)GetStockObject(NULL_BRUSH);
}



BOOL
CEP_NSSDlg::ToolHint( UINT id, NMHDR * pTTTStruct, LRESULT * pResult )
{
	id;
	pResult;

	eclog.Print(LL_STATE, "ToolHint function called. id=%d\n", id);
	if( !m_plczRes ) return FALSE;

    TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pTTTStruct;
    UINT nID =pTTTStruct->idFrom;
    if (pTTT->uFlags & TTF_IDISHWND)
    {
        
        nID = ::GetDlgCtrlID((HWND)nID);
        if(nID)
        {
			LCCONTROL *lcCtl = m_plczRes->GetCtlInf(nID);
			if( lcCtl ){
				eclog.Print(LL_STATE, "Show a ToolHint. nID=%d, text=%s\n", nID, m_plczRes->GetString(lcCtl->textID));
				pTTT->lpszText = m_plczRes->GetString(lcCtl->hintTxtID);
				pTTT->hinst = AfxGetResourceHandle();
				return TRUE;
			}
        }
    }

    return FALSE;
}



void
CEP_NSSDlg::SetItemStat(int nResID, BOOL bVisible, BOOL bEnable,POINT* pPoi)
{
	CECButton *ecb = (CECButton*)GetDlgItem(nResID);
	if( ecb ){
		
		if( pPoi ){
			RECT bRec;
			ecb->GetClientRect(&bRec);
			ecb->MoveWindow(pPoi->x, pPoi->y, bRec.right, bRec.bottom, TRUE);
		}
		ecb->ShowWindow(bVisible*SW_SHOW);
		ecb->EnableWindow(bEnable);
	}
}
	


void
CEP_NSSDlg::OnBtnExit()
{
	
	
	
	

	
	if( m_VNeSLib.IsConnecting() ){
		m_VNeSLib.Disconnect();
		eclog.Print(LL_STATE, "Disconnet VNeS.\n");
	}

	
	eclog.Print(LL_STATE, "Free Library of VNeS.\n");
	m_VNeSLib.FreeLib();

	

	PostQuitMessage(0);
}


void
CEP_NSSDlg::OnBtnHelp()
{


	AfxGetApp()->WinHelp(NULL, HELP_FINDER);

}


void
CEP_NSSDlg::OnBtnList()
{
	if( m_nUIMode == UIMODE_PROJLIST || m_nUIMode == UIMODE_IPCONNECT)
		ChangeUIMode(UIMODE_NORMAL);
	else{
		if( m_bEasyMode ){
			
			PostMessage(WM_TIMER, ECON_TIMEREVENT_SEARCHTIMER, NULL);
			ChangeUIMode(UIMODE_PROJLIST);
		}else
			ChangeUIMode(UIMODE_IPCONNECT);
	}
}


void
CEP_NSSDlg::OnBtnURL()
{

	ULONG IPAddr = 0;
	CECClientThread *pEct = NULL;
	CWaitCursor wait;
	
	if( !m_pECServer || !m_plczRes) goto OnHTTPOpenErr;

	
	pEct = m_pECServer->GetClientThread(m_cVPSelectClient);
	if( !pEct ) goto OnHTTPOpenErr;

	
	IPAddr = pEct->GetIPAddress();
	sprintf(m_URLInfo.sProjURL, "http://%s/", inet_ntoa(*((in_addr*)&IPAddr)));

	
	lstrcpy(m_URLInfo.sErrorMessage, m_plczRes->GetString(IDS_ERR_STRING0014));

	
	AfxBeginThread(HTTPOpenThProc, &m_URLInfo); 

	eclog.Print(LL_STATE, "Open URL '%s'.\n",m_URLInfo.sProjURL);
	return;

OnHTTPOpenErr:
	ECMessageBox(IDS_ERR_STRING0014);
	eclog.Print(LL_ERROR, "Failed to open URL.\n");
	return;
}



void
CEP_NSSDlg::OnBtnPause()
{
	if( !m_bNowConnect || m_bReConnecting ||
		!m_pECServer ) return;

	
	if( m_nUIMode != UIMODE_NORMAL ){
		ChangeUIMode(UIMODE_NORMAL);
	}

	
	CWaitCursor wait;

	
	int i=0;
	CESCVPBase *pEscvp = NULL;
	pEscvp = new CESCVPBase();
	if( !pEscvp )
		goto OnBtnPauseErr;

	
	for(i=0; i<m_pECServer->GetThreadCount(); i++){

		
		CECClientThread *pClient = m_pECServer->GetClientThread(i);
		if( !pClient )
			goto OnBtnPauseErr;

		
		if( !pEscvp->Open(pClient->GetIPAddress(), m_ulSvrIPAddr, m_usESCVPPort) )
			goto OnBtnPauseErr;

		
		if( !pEscvp->SetKeyCommand(VP21CMD_KEY_PAUSE) )
			goto OnBtnPauseErr;

		if( !pEscvp->Close() )
			goto OnBtnPauseErr;
	}

	delete pEscvp;
	return;

OnBtnPauseErr:
	if( pEscvp )
		delete pEscvp;

	ECMessageBox(IDS_ERR_STRING0024);
	return;
}



void
CEP_NSSDlg::OnBtnAVMute()
{
	if( !m_bNowConnect || m_bReConnecting ||
		!m_pECServer ) return;

	
	if( m_nUIMode != UIMODE_NORMAL ){
		ChangeUIMode(UIMODE_NORMAL);
	}

	
	CWaitCursor wait;

	
	int i=0;
	CESCVPBase *pEscvp = NULL;
	pEscvp = new CESCVPBase();
	if( !pEscvp )
		goto OnBtnAVMuteErr;

	
	for(i=0; i<m_pECServer->GetThreadCount(); i++){

		
		CECClientThread *pClient = m_pECServer->GetClientThread(i);
		if( !pClient )
			goto OnBtnAVMuteErr;

		
		if( !pEscvp->Open(pClient->GetIPAddress(), m_ulSvrIPAddr, m_usESCVPPort) )
			goto OnBtnAVMuteErr;

		
		if( !pEscvp->SetKeyCommand(VP21CMD_KEY_AVMUTE) )
			goto OnBtnAVMuteErr;

		if( !pEscvp->Close() )
			goto OnBtnAVMuteErr;
	}

	delete pEscvp;
	return;

OnBtnAVMuteErr:
	if( pEscvp )
		delete pEscvp;

	ECMessageBox(IDS_ERR_STRING0024);
	return;
}


void
CEP_NSSDlg::OnBtnEZoom()
{
	if( m_bNowConnect && !m_bReConnecting )
	{
		if( m_nUIMode == UIMODE_EZOOM )
			ChangeUIMode(UIMODE_NORMAL);
		else
			ChangeUIMode(UIMODE_EZOOM);
	}
		





}



void
CEP_NSSDlg::OnBtnKihon()
{
	if( m_bNowConnect && !m_bReConnecting )
	{
		if( m_nUIMode == UIMODE_BASESETTING )
			ChangeUIMode(UIMODE_NORMAL);
		else
			ChangeUIMode(UIMODE_BASESETTING);
	}





}



void
CEP_NSSDlg::OnBtnVideo()
{
	
	if( m_nUIMode != UIMODE_NORMAL ){
		ChangeUIMode(UIMODE_NORMAL);
	}

	SendVPKeyCmd(VP21CMD_KEY_VIDEO);
}



void
CEP_NSSDlg::OnBtnPC()
{
	
	if( m_nUIMode != UIMODE_NORMAL ){
		ChangeUIMode(UIMODE_NORMAL);
	}

	SendVPKeyCmd(VP21CMD_KEY_PC);
}



void
CEP_NSSDlg::OnBtnConnect()
{
	int i=0;
	int nNoUseIPCount = 0;
	BOOL bErr = FALSE;
	CEconCommand *econ = NULL;
	CECSearchClient *pECSearch = NULL;

	eclog.Print(LL_STATE, "Enter OnBtnConnect Function.\n");

	


	if( !m_pECSrchClt && m_nUIMode == UIMODE_PROJLIST || !m_pECServer || !m_pECPing){
		eclog.Print(LL_ERROR, "Parameter Err.\n");

		ECMessageBox(IDS_ERR_STRING0015);
		return;
	}


	



	CWnd *wCtl = NULL;
	if( m_nUIMode == UIMODE_IPCONNECT )
		wCtl = (CWnd*)GetDlgItem(ECON_IPA_IPADDRESS);
	else if( m_nUIMode == UIMODE_PROJLIST )
		wCtl = (CWnd*)GetDlgItem(ECON_LBX_PROJLIST);

	if( wCtl )
		wCtl->SetFocus();


	
	SetItemStat(ECON_BTN_CONNECT, TRUE, FALSE);

	
	CWaitCursor wait;

	
	if( m_nSearchTimer ){
		eclog.Print(LL_STATE, "Stopped projector search timer.\n");
		KillTimer(m_nSearchTimer);
		m_nSearchTimer =NULL;
	}

	
	UpdateProjList();
	eclog.Print(LL_STATE, "Updated projector list.\n");




	
	

	int nClientNum = 0;
	

	BOOL bExistsUsingClient = FALSE; 

	CProjListBox *pProjList = NULL;
	m_nConnectCInfo = 0;


	
	
	if( m_nUIMode == UIMODE_IPCONNECT ){


		m_IPProjListBox.StopSearchClient();
		m_IPProjListBox.UpdateIPList();
		eclog.Print(LL_STATE, "Stopped projector search timer(IP_Connect).\n");
		
		pProjList = &m_IPProjListBox;
		pECSearch = m_IPProjListBox.GetSrchClient();
		if( !pECSearch ){
			eclog.Print(LL_ERROR, "Failed to get IPProjListBox Pointer.\n");
			ECMessageBox(IDS_ERR_STRING0016);
			SetItemStat(ECON_BTN_CONNECT, TRUE, TRUE);
			return;
		}



		









		
		












		




			








			
















		m_bEasyMode = FALSE;


	
	
	}else if( m_nUIMode == UIMODE_PROJLIST ){

		pProjList = &m_ProjListBox;
		pECSearch = m_pECSrchClt;
		m_bEasyMode = TRUE;
	}
	


	


	int nItemCnt = pProjList->GetCount();


	if( nItemCnt == 0){
		eclog.Print(LL_ERROR, "The ProjListBox has no projector.\n");
		ECMessageBox(IDS_WRN_STRING0000);
		bErr = TRUE;
	}

	










	m_bNoSupportUXGA = FALSE;


	


	for( int index=0; index< pProjList->GetCount(); index++)

	{


		if( pProjList->GetSelected(index) ){


			
			ECITEM* pEc = (ECITEM*)pProjList->GetItemDataPtr(index);
			if( pEc ){
				if( pEc->projState == PLIST_STATUS_NOREPLY ||
					pEc->projState == PLIST_STATUS_SEARCHING)
					continue;
			}else
			{
				continue;
			}


			CLIENTINFO cinf;


			if( pECSearch->GetClientInfo(pProjList->GetUniqInfo(index), &cinf) ){

		
				if( cinf.m_projState == e_pstat_using || 
					cinf.m_projState == e_pstat_appusing)
		
		
					bExistsUsingClient = TRUE;


				eclog.Print(LL_STATE, "DisplayType of '%s' = %x.\n", cinf.m_projName, cinf.m_nDisplayType);


				if( (cinf.m_nDisplayType & PROJECTOR_INFO_MODEL) == PROJECTOR_MODEL_BER ){

					m_bNoSupportUXGA = TRUE;
					eclog.Print(LL_STATE, "Some projector not support over SXGA resolution.\n");
				}





				memcpy(&m_ConnectCInfo[m_nConnectCInfo], &cinf, sizeof(CLIENTINFO));
				m_nConnectCInfo++;

			}else
			{
				eclog.Print(LL_ERROR, "Failed to Get CLIENTINFO in case of EasyConnect.\n");
				ECMessageBox(IDS_ERR_STRING0015);
				bErr = TRUE;
				break;
			}
		}
	}

	


	if( m_nConnectCInfo == 0 && !bErr){

		eclog.Print(LL_STATE, "There is no projector selected.\n");
		ECMessageBox(IDS_WRN_STRING0000);
		bErr = TRUE;
	}






	if( bErr == TRUE )
		goto OnBtnConnectErr;

	eclog.Print(LL_STATE, "success to pick up clients. client count = %d\n", m_nConnectCInfo);


	
	

	
	SCRINFO scrinf;
	GetResolutionInfo(scrinf);






	

	if( scrinf.nScrWid > (int)m_resolutionMaxWidth  
		|| scrinf.nScrHei > (int)m_resolutionMaxHeight  
		


	  )
	{
	
		ECMessageBox(IDS_ERR_STRING0025);
		goto OnBtnConnectErr;
	}


	
	else if( (scrinf.nScrWid > ECON_SXGA_WIDTH || scrinf.nScrHei > ECON_SXGA_HEIGHT) && m_bNoSupportUXGA ){
		ECMessageBox(IDS_ERR_STRING0040);
		goto OnBtnConnectErr;
	}








	else if( scrinf.nScrBPP >= ECON_FULLCOLOR_BPP ){
		int nRet = MessageBox(m_plczRes->GetString(IDS_WRN_STRING0019), ECON_PRODUCTNAME, MB_ICONWARNING|MB_YESNO);

		if( nRet == IDNO )
			goto OnBtnConnectErr;
	}

	if( scrinf.nScrWid > ECON_XGA_WIDTH || scrinf.nScrHei > ECON_XGA_HEIGHT ){
		int nRet = MessageBox(m_plczRes->GetString(IDS_WRN_STRING0020), ECON_PRODUCTNAME, MB_ICONWARNING|MB_YESNO);
		if( nRet == IDNO )
			goto OnBtnConnectErr;
	}


	eclog.Print(LL_STATE, "Checked Display Resolution.\n");


	
	if( bExistsUsingClient ){


		int nRet = MessageBox(m_plczRes->GetString(IDS_WRN_STRING0008), ECON_PRODUCTNAME, MB_ICONWARNING|MB_YESNO);



		if( nRet == IDNO )
			goto OnBtnConnectErr;
	}
	eclog.Print(LL_STATE, "Checked the client that be already connecting with other server.\n");


	








	
#ifdef _DEBUG
	if( m_pECPing )
		eclog.Print(LL_STATE, "Empty ping count = %d\n", m_pECPing->GetIPCount());
#endif

	this->UpdateWindow();

	
	

	econ = m_pECServer->GetEconCommand();
	if( !econ ){
		ECMessageBox(IDS_ERR_STRING0015);
		goto OnBtnConnectErr;
	}
	econ->Clear();
	econ->SetParam(m_ulSvrIPAddr, ((CEP_NSSApp*)AfxGetApp())->m_nPort);
	eclog.Print(LL_STATE, "Created new ECONCOMMAND for connection.\n");
	
	
	nNoUseIPCount = 0;




	for(i=0; i<(int)m_nConnectCInfo; i++){
		CLIENTINFO *cinf = &m_ConnectCInfo[i];

		ASSERT(cinf);


		ULONG hostIP = 0;
		if( m_bEasyMode ){

			hostIP = cinf->m_projIPaddress;

			
			if( !CheckProjIPAddr(hostIP) ){
				eclog.Print(LL_STATE, "missmatch subnet between server and client.\n");
#ifdef _DEBUG
				if( m_pECPing )
					eclog.Print(LL_STATE, "get ping count=%d\n", m_pECPing->GetIPCount());
#endif
				do{
					
					hostIP = m_pECPing->GetIPAddr(nNoUseIPCount);
					eclog.Print(LL_STATE, "get hostIP = %x\n", hostIP);

					
					if( hostIP ==0 ){
						eclog.Print(LL_STATE, "Start to find more ipaddress.\n");
						
						while( m_pECPing->GetRunThread() && !hostIP )
							hostIP = m_pECPing->GetIPAddr(nNoUseIPCount);
					
						eclog.Print(LL_STATE, "Finished to find more ipaddress.\n");
	
						
						if( hostIP == 0 ){
							eclog.Print(LL_ERROR, "Failed to get no-use IP Address.\n");
							ECMessageBox(IDS_ERR_STRING0000);
							goto OnBtnConnectErr;
						}
					}

					nNoUseIPCount++;
				
				}while( m_pECPing->EchoCheck(ntohl(hostIP)) != ECPING_NOREPLY && nNoUseIPCount < ECPING_IPCOUNTMAX);
			}

		}else
		{


			hostIP = cinf->m_projIPaddress;

		}

		
		econ->AddRecord(cinf->m_projUniqInfo, cinf->m_projKeyword, hostIP);
	}
	eclog.Print(LL_STATE, "Created ECONRECORD for connection.\n");

	
	nClientNum = econ->GetRecordNum();
	if( nClientNum == 0 ){
		ECMessageBox(IDS_ERR_STRING0015);
		goto OnBtnConnectErr;
	}

	


	econ->MakeReqConnect(m_bUseEnc, m_cEncPassword, m_ulSvrSubnet, m_ulSvrGateway);


	eclog.Print(LL_STATE, "Maked ReqConnect Command.\n");


	
	
	eclog.Print(LL_STATE, "Call EMPConnect Function.\n");
	if( !EMPConnect(e_emp_connect) ){
		m_pECServer->ClearThreadList();
		SetItemStat(ECON_BTN_CONNECT, TRUE, TRUE);
		if( m_bEasyMode ){
			if( !m_nSearchTimer )
				m_nSearchTimer = SetTimer(ECON_TIMEREVENT_SEARCHTIMER, ECON_PROJLIST_TIMERINTERVAL, NULL);
		}

		else{
			
			m_IPProjListBox.StartSearchClient(	m_ulSvrIPAddr,
												((CEP_NSSApp*)AfxGetApp())->m_nPort,
												((CEP_NSSApp*)AfxGetApp())->m_sCurrentMACAddr,
												MAC_ADDR_LENGTH);
		}

		UpdateProjList();
		return;
	}
	eclog.Print(LL_STATE, "Successed EMPConnect Function.\n");

	
	m_nIndicateTimer = SetTimer(ECON_TIMEREVENT_INDICATOR, ECON_PROJLIST_INDICATORTIMEOUT, NULL);
	
	
	m_ProjListBox.SaveCheckedItem();

	
	for(i=0; i<m_pECServer->GetThreadCount(); i++){
		CECClientThread* pClient = m_pECServer->GetClientThread(i);
		if( pClient ){


			



			CLIENTINFO cinf;



			if( pECSearch->GetClientInfo(pClient->GetUniqInfo(), &cinf)){
				cinf.m_projState = e_pstat_using;			
				memcpy(cinf.m_projName, pClient->GetProjName(), ECON_PROJNAME_MAXLEN);


				pECSearch->SetClientInfo(&cinf);
				if( !m_bEasyMode ){
					pProjList->m_ConIPList[pProjList->m_nConIPNum] = cinf.m_projIPaddress;
					pProjList->m_nConIPNum++;
				}

			}
			












		}
	}
	
	
	BOOL bScrSaveState;
	if( SystemParametersInfo(SPI_GETSCREENSAVEACTIVE, NULL, &bScrSaveState, 0) ){
		if( bScrSaveState ){
			SystemParametersInfo(SPI_SETSCREENSAVEACTIVE, FALSE, NULL, SPIF_SENDCHANGE);
			m_bChangeScrSaveState = TRUE;
		}
	}
	

	
	MSG msg;
	while(::PeekMessage(&msg, this->m_hWnd, WM_LBUTTONDOWN, WM_MBUTTONDBLCLK,PM_REMOVE)){}

	eclog.Print(LL_STATE, "Exit OnBtnConnect Function.\n");
	return;


OnBtnConnectErr:
	SetItemStat(ECON_BTN_CONNECT, TRUE, TRUE);
	if( m_bEasyMode ){
		if( !m_nSearchTimer )
			m_nSearchTimer = SetTimer(ECON_TIMEREVENT_SEARCHTIMER, ECON_PROJLIST_TIMERINTERVAL, NULL);
	}else
	{
		
		m_IPProjListBox.StartSearchClient(	m_ulSvrIPAddr,
											((CEP_NSSApp*)AfxGetApp())->m_nPort,
											((CEP_NSSApp*)AfxGetApp())->m_sCurrentMACAddr,
											MAC_ADDR_LENGTH);
	}

}



void
CEP_NSSDlg::OnBtnDisConnect()
{
	eclog.Print(LL_STATE, "Enter OnBtnDisConnect Function.\n");


	m_bDisconnecting = TRUE;


	CWaitCursor wait;

	
	SetControlsState(TRUE);


	CECSearchClient *pECSearch = NULL;
	if( m_bEasyMode ){
		pECSearch = m_pECSrchClt;
	}else
	{
		pECSearch = m_IPProjListBox.GetSrchClient();
	}


	if( m_nSearchTimer ){
		eclog.Print(LL_STATE, "Stopped projector search timer.\n");
		KillTimer(m_nSearchTimer);
		m_nSearchTimer = NULL;
	}

	
	if( m_bChangeScrSaveState ){
		SystemParametersInfo(SPI_SETSCREENSAVEACTIVE, TRUE, NULL, SPIF_SENDCHANGE);
		m_bChangeScrSaveState = FALSE;
	}
	
		
	
	if( m_pECPing ){

		delete m_pECPing;
		m_pECPing = NULL;
	}

	m_pECPing = new CECPing();
	if( !m_pECPing ){
		eclog.Print(LL_ERROR, "Failed to create 'CECPing' Object.\n");
		ECMessageBox(IDS_ERR_STRING0016);
		EndDialog(IDCANCEL);
		return;
	}

	if( !m_pECPing->Init(m_ulSvrIPAddr, m_ulSvrSubnet, m_ulSvrGateway)){
		eclog.Print(LL_ERROR, "Failed to Initialize 'CECPing' Object.\n");
		delete m_pECPing;
		m_pECPing = NULL;
		ECMessageBox(IDS_ERR_STRING0016);
		EndDialog(IDCANCEL);
		return;
	}

	


	if( m_bEasyMode ){
		m_ProjListBox.ClearCheckedItem();
	}else
	{
		m_IPProjListBox.ClearCheckedItem();
		m_IPProjListBox.m_nConIPNum = 0;
	}

	
	


	if( m_pECServer ){

		for(int i=0; i<m_pECServer->GetThreadCount(); i++){
			CECClientThread* pClient = m_pECServer->GetClientThread(i);
			if( pClient ){
				CLIENTINFO cinf;


				if( pECSearch->GetClientInfo(pClient->GetUniqInfo(), &cinf)){

					cinf.m_projState = e_pstat_nouse;


					pECSearch->SetClientInfo(&cinf);

				}
			}
		}
	}
	
	
	m_nIndiCounter = 0;
	if( m_nIndicateTimer ){
		KillTimer(m_nIndicateTimer);
		m_nIndicateTimer = NULL;
	}
	eclog.Print(LL_STATE, "Stopped Indicator Timer.\n");

	





	
	


	
	if( m_pECServer ){
		m_pECServer->RestartClients(); 
		m_pECServer->ClearThreadList();
		eclog.Print(LL_STATE, "Clear all Client's Socket.\n");
	}


	
	if( m_VNeSLib.IsConnecting() ){
		m_VNeSLib.Disconnect();
		eclog.Print(LL_STATE, "DisConnected VNeS Server.\n");
	}

	m_bExistProj = FALSE;
	m_nConnectCnt = 0;
	m_nVNeSSendDataCnt = 0;
	m_bReConnecting = FALSE;
	

	







	
	m_nWaitCursor = TRUE;
	m_bExpandWindow = TRUE;
	m_nExpandWindowTimer = SetTimer(ECON_TIMEREVENT_EXPANDWINDOW, 2000, NULL);

	
	EnableWindow(FALSE);
	
	









	
	MSG msg;
	while(::PeekMessage(&msg, this->m_hWnd, WM_LBUTTONDOWN, WM_MBUTTONDBLCLK,PM_REMOVE)){}


	eclog.Print(LL_STATE, "Exit OnBtnDisConnect Function.\n");
}


void
CEP_NSSDlg::OnBtnIPCon()
{

	
	if( m_pECSrchClt ){
		delete m_pECSrchClt;
		m_pECSrchClt = NULL;
	}



	m_IPAddress.Clear();


	m_bEasyMode = FALSE;
	ChangeUIMode(UIMODE_IPCONNECT);
}



void
CEP_NSSDlg::OnBtnEasyCon()
{
	

	
	if( m_IPProjListBox.IsSearching() ){
		m_IPProjListBox.StopSearchClient();
	}
	m_IPProjListBox.DeleteSearchClient();

	
	if( !m_pECSrchClt ){
		m_pECSrchClt = new CECSearchClient(this->m_hWnd, m_ulSvrIPAddr, ((CEP_NSSApp*)AfxGetApp())->m_nPort);
		if( !m_pECSrchClt ){
			eclog.Print(LL_ERROR, "Failed to create 'CECSearchClient' Object.\n");
			ECMessageBox(IDS_ERR_STRING0016);
			EndDialog(IDCANCEL);
			return;
		}
	}
	



	
	UpdateProjList();
	

	m_bEasyMode = TRUE;

	
	m_nFirstSearch = TRUE;
	

	
	PostMessage(WM_TIMER, ECON_TIMEREVENT_SEARCHTIMER, NULL);
	ChangeUIMode(UIMODE_PROJLIST);


	GuideMessage(ECDLG_MESSTAT_CLEAR);


	



}



void
CEP_NSSDlg::OnBtnOption()
{

	EPNSD_DLGDATA stDlgData;
	memset(&stDlgData, 0, sizeof(EPNSD_DLGDATA));

	
	stDlgData.pLocal = m_plczRes;
	stDlgData.pMainApp = (CWinApp*)AfxGetApp();
	lstrcpy(stDlgData.sAppPath, ((CEP_NSSApp*)AfxGetApp())->m_sAppPath);

	
	stDlgData.stOption.bUseEnc = m_bUseEnc;
	stDlgData.stOption.bUseIPConnect = m_bUseIPConnect;
	stDlgData.stOption.bUseGroupList = m_bUseGroupList;

	stDlgData.bOptionChange = FALSE;

	
	stDlgData.stAdapter.nIPAddr = ((CEP_NSSApp*)AfxGetApp())->m_nAdpIPAddress;
	stDlgData.stAdapter.nGateAddr = m_ulSvrGateway;
	stDlgData.stAdapter.nSubnetAddr = m_ulSvrSubnet;
	stDlgData.stAdapter.bOnStartFlg = FALSE;
	memcpy(stDlgData.stAdapter.bMACAddr, ((CEP_NSSApp*)AfxGetApp())->m_sCurrentMACAddr,
			MAC_ADDR_LENGTH);
	stDlgData.bAdapterChange = FALSE;


	
	if( m_nSearchTimer ){
		eclog.Print(LL_STATE, "Stopped projector search timer.\n");
		KillTimer(m_nSearchTimer);
		m_nSearchTimer = NULL;
	}

	if( m_nResultTimer ){
		KillTimer(m_nResultTimer);
		m_nResultTimer = NULL;
	}

	
	if( m_pECSrchClt ){
		delete m_pECSrchClt;
		m_pECSrchClt = NULL;
	}
	m_ProjListBox.ResetContent();

	if( m_IPProjListBox.IsSearching() ){
		m_IPProjListBox.StopSearchClient();
	}
	m_IPProjListBox.DeleteSearchClient();




	
	m_cDlgMng.SetDlgData(&stDlgData);
	int nRet = m_cDlgMng.Show_OptionDlg(this);




	
	if( m_nUIMode == UIMODE_PROJLIST ){
		m_pECSrchClt = new CECSearchClient(
							this->m_hWnd, 
							m_cDlgMng.GetDlgData()->stAdapter.nIPAddr,
							((CEP_NSSApp*)AfxGetApp())->m_nPort
							);
		if( !m_pECSrchClt ){
			eclog.Print(LL_ERROR, "Failed to create 'CECSearchClient' Object.\n");
			ECMessageBox(IDS_ERR_STRING0016);
			EndDialog(IDCANCEL);
			return;
		}


		
		if( !m_nSearchTimer){
			m_nSearchTimer = SetTimer(ECON_TIMEREVENT_SEARCHTIMER, ECON_PROJLIST_TIMERINTERVAL, NULL);
			eclog.Print(LL_STATE, "Start timer for searching projector.\n");
		}

		PostMessage(WM_TIMER, ECON_TIMEREVENT_SEARCHTIMER, NULL);
	}else
	{
		m_IPProjListBox.StartSearchClient(	m_cDlgMng.GetDlgData()->stAdapter.nIPAddr,
											((CEP_NSSApp*)AfxGetApp())->m_nPort,
											m_cDlgMng.GetDlgData()->stAdapter.bMACAddr,
											MAC_ADDR_LENGTH);
	}

	


	



	

	
	

	if( m_cDlgMng.GetDlgData()->bAdapterChange ){
		
		
		
		m_ulSvrIPAddr = m_cDlgMng.GetDlgData()->stAdapter.nIPAddr;
		m_ulSvrSubnet = m_cDlgMng.GetDlgData()->stAdapter.nSubnetAddr;
		m_ulSvrGateway = m_cDlgMng.GetDlgData()->stAdapter.nGateAddr;

		in_addr addr;
		eclog.Print(LL_STATE, "The current LAN has changed!\n");
		addr.S_un.S_addr = m_ulSvrIPAddr;
		eclog.Print(LL_STATE, "New IPAddress = %s.\n",inet_ntoa(addr) );
		addr.S_un.S_addr = m_ulSvrSubnet;
		eclog.Print(LL_STATE, "New Subnet Address = %s.\n",inet_ntoa(addr));
		addr.S_un.S_addr = m_ulSvrGateway;
		eclog.Print(LL_STATE, "New Gateway Address = %s.\n",inet_ntoa(addr));

		
		
		ChangeLAN();
	}
		
	if( nRet == IDOK){
		
		m_bUseEnc = m_cDlgMng.GetDlgData()->stOption.bUseEnc;
		m_bUseIPConnect = m_cDlgMng.GetDlgData()->stOption.bUseIPConnect;
		m_bUseGroupList = m_cDlgMng.GetDlgData()->stOption.bUseGroupList;


		memcpy(m_sGroupName, m_cDlgMng.GetDlgData()->stOption.sGroupID, ECON_GROUPNAME_MAXLEN + 1);



		

		((CEP_NSSApp*)AfxGetApp())->m_nAdpIPAddress = m_cDlgMng.GetDlgData()->stAdapter.nIPAddr;
		memcpy(((CEP_NSSApp*)AfxGetApp())->m_sCurrentMACAddr, m_cDlgMng.GetDlgData()->stAdapter.bMACAddr,
			MAC_ADDR_LENGTH);

		((CEP_NSSApp*)AfxGetApp())->m_bUseEncryption = m_bUseEnc;
		((CEP_NSSApp*)AfxGetApp())->m_bUseIPConnect = m_bUseIPConnect;
		((CEP_NSSApp*)AfxGetApp())->m_bUseGroupList = m_bUseGroupList;
		((CEP_NSSApp*)AfxGetApp())->SaveRegistry();

		
		if( lstrlen(m_sGroupName)!=0 && m_bUseGroupList ){
			
			m_IPProjListBox.ResetContent();

			
			CString csPath(((CEP_NSSApp*)AfxGetApp())->m_sNSGroupPath);


			
			EPNSD_IPGROUP group;
			CIniFileUtil ini(NULL,csPath);
			if( ini.GetGroup(CString(m_sGroupName, ECON_GROUPNAME_MAXLEN), group) ){
				for(int i=0; i<ECON_PROJLIST_IPLISTMAXCOUNT; i++){
				 	if( group.dwIPAdd[i] != 0 )
						AddIPProjItem(group.dwIPAdd[i]);
					else
						break;
				}
			}
		}
	
		
		if( m_nUIMode == UIMODE_PROJLIST)
			SetItemStat(ECON_BTN_IPCON, m_bUseIPConnect);

		
		else if( m_nUIMode == UIMODE_IPCONNECT ){
			if( !m_bUseIPConnect ){

				OnBtnEasyCon();
				
			
			

			}


			if( m_IPProjListBox.GetCount() == 0)
				GuideMessage(ECDLG_MESSTAT_NOIPADDRESS);
			else
				GuideMessage(ECDLG_MESSTAT_IPCONNECT);

		}
	}
}


int
CEP_NSSDlg::AddIPProjItem(ULONG ulIPAddr, int nIndexIns )
{
	ECITEM item;

	
	if( ulIPAddr == 0 )
		return ECDLG_ERR_FAILED;

	
	for(int i=0; i<m_IPProjListBox.GetCount(); i++){
		ECITEM *pItem = (ECITEM*)m_IPProjListBox.GetItemDataPtr(i);
		if( pItem ){
			if( pItem->ulIPAddr == ulIPAddr ){
				return ECDLG_ERR_ALREADYEXISTS;
			}
		}
	}

	
	lstrcpy(item.projName, "");				
	item.projState = PLIST_STATUS_SEARCHING;
											
	memset(item.projUniqInfo, 0, ECON_UNIQINFO_LENGTH);	
	item.ulIPAddr = ulIPAddr;				
	item.bSelected = 0;						

	
	int maxcount = (int)((CEP_NSSApp*)AfxGetApp())->m_nIPListMaxCount;
	if( m_IPProjListBox.GetCount() >= maxcount ){
		m_IPProjListBox.DeleteECItem(maxcount-1);
	}

	
	return m_IPProjListBox.AddECItem(&item,nIndexIns);
}


void
CEP_NSSDlg::OnBtnSearch()
{
	ULONG ipAdd;


	
	if( !m_IPAddress.GetAddress(ipAdd) ){
		ECMessageBox(IDS_WRN_STRING0002);
		eclog.Print(LL_STATE, "!!!IPAddress Error.\n");
		m_IPAddress.SetFocus();
		return;
	}

	if( AddIPProjItem(ipAdd, 0) == ECDLG_ERR_ALREADYEXISTS ){
		ECMessageBox(IDS_ERR_STRING0037);
		m_IPAddress.SetFocus();
		return;
	}


	if( m_IPProjListBox.GetCount() == 0)
		GuideMessage(ECDLG_MESSTAT_NOIPADDRESS);
	else
		GuideMessage(ECDLG_MESSTAT_IPCONNECT);



	


	

	






	





	




}










	

	







	








	

	







	







	




	
	

	






	


















	













void
CEP_NSSDlg::OnBtnMin()
{
	ShowWindow(SW_MINIMIZE);
}



void
CEP_NSSDlg::OnBtnKakuClose()
{


	if( m_nUIMode==UIMODE_EZOOM || 
		m_nUIMode==UIMODE_BASESETTING ||
	   (m_bNowConnect && (m_nUIMode==UIMODE_PROJLIST || m_nUIMode==UIMODE_IPCONNECT)) ){

		ChangeUIMode(UIMODE_NORMAL);

		CWnd *wCtl = (CWnd*)GetDlgItem(ECON_BTN_HELP);
		if(wCtl) wCtl->SetFocus();

	}

}



void
CEP_NSSDlg::OnBtnEZoomMinus()
{
	SendVPKeyCmd(VP21CMD_KEY_EZMDEC);
}



void
CEP_NSSDlg::OnBtnEZoomPlus()
{
	SendVPKeyCmd(VP21CMD_KEY_EZMINC);
}



void
CEP_NSSDlg::OnBtnEZoomCancel()
{
	SendVPKeyCmd(VP21CMD_KEY_ZCANCEL);
}


































void
CEP_NSSDlg::OnBtnBrightMinus()
{
	CECClientThread *pClient = NULL;

	if( !m_bNowConnect || m_bReConnecting ) return;

	
	CWaitCursor wait;

	
	CESCVPBase *pEscvp = NULL;
	pEscvp = new CESCVPBase();
	if( !pEscvp )
		goto OnBtnBrightMinusErr;

	
	pClient = m_pECServer->GetClientThread(m_cVPSelectClient);
	if( !pClient )
		goto OnBtnBrightMinusErr;

	
	if( !pEscvp->Open(pClient->GetIPAddress(), m_ulSvrIPAddr, m_usESCVPPort) )
		goto OnBtnBrightMinusErr;

	
	if( !pEscvp->SetIncDecValue(cmdBRIGHT, EVM_PRM_DEC) )
		goto OnBtnBrightMinusErr;

	delete pEscvp;
	return;
	
OnBtnBrightMinusErr:
	if( pEscvp )
		delete pEscvp;

	ECMessageBox(IDS_ERR_STRING0024);
	return;
}



void
CEP_NSSDlg::OnBtnBrightPlus()
{
	CECClientThread *pClient = NULL;

	if( !m_bNowConnect || m_bReConnecting ) return;

	
	CWaitCursor wait;

	
	CESCVPBase *pEscvp = NULL;
	pEscvp = new CESCVPBase();
	if( !pEscvp )
		goto OnBtnBrightPlusErr;

	
	pClient = m_pECServer->GetClientThread(m_cVPSelectClient);
	if( !pClient )
		goto OnBtnBrightPlusErr;

	
	if( !pEscvp->Open(pClient->GetIPAddress(), m_ulSvrIPAddr, m_usESCVPPort) )
		goto OnBtnBrightPlusErr;

	
	if( !pEscvp->SetIncDecValue(cmdBRIGHT, EVM_PRM_INC) )
		goto OnBtnBrightPlusErr;

	delete pEscvp;
	return;
	
OnBtnBrightPlusErr:
	if( pEscvp )
		delete pEscvp;

	ECMessageBox(IDS_ERR_STRING0024);
	return;
}



void
CEP_NSSDlg::OnBtnContrastMinus()
{
	CECClientThread *pClient = NULL;

	if( !m_bNowConnect || m_bReConnecting ) return;

	
	CWaitCursor wait;

	
	CESCVPBase *pEscvp = NULL;
	pEscvp = new CESCVPBase();
	if( !pEscvp )
		goto OnBtnContrastMinusErr;

	
	pClient = m_pECServer->GetClientThread(m_cVPSelectClient);
	if( !pClient )
		goto OnBtnContrastMinusErr;

	
	if( !pEscvp->Open(pClient->GetIPAddress(), m_ulSvrIPAddr, m_usESCVPPort) )
		goto OnBtnContrastMinusErr;

	
	if( !pEscvp->SetIncDecValue(cmdCONTRAST, EVM_PRM_DEC) )
		goto OnBtnContrastMinusErr;

	delete pEscvp;
	return;
	
OnBtnContrastMinusErr:
	if( pEscvp )
		delete pEscvp;

	ECMessageBox(IDS_ERR_STRING0024);
	return;
}



void
CEP_NSSDlg::OnBtnContrastPlus()
{
	CECClientThread *pClient = NULL;

	if( !m_bNowConnect || m_bReConnecting ) return;

	
	CWaitCursor wait;

	
	CESCVPBase *pEscvp = NULL;
	pEscvp = new CESCVPBase();
	if( !pEscvp )
		goto OnBtnContrastPlusErr;

	
	pClient = m_pECServer->GetClientThread(m_cVPSelectClient);
	if( !pClient )
		goto OnBtnContrastPlusErr;

	
	if( !pEscvp->Open(pClient->GetIPAddress(), m_ulSvrIPAddr, m_usESCVPPort) )
		goto OnBtnContrastPlusErr;

	
	if( !pEscvp->SetIncDecValue(cmdCONTRAST, EVM_PRM_INC) )
		goto OnBtnContrastPlusErr;

	delete pEscvp;
	return;
	
OnBtnContrastPlusErr:
	if( pEscvp )
		delete pEscvp;

	ECMessageBox(IDS_ERR_STRING0024);
	return;
}



void
CEP_NSSDlg::OnBtnKeystoneMinus()
{
	SendVPKeyCmd(VP21CMD_KEY_KEYSTNDEC);
}



void
CEP_NSSDlg::OnBtnKeystonePlus()
{
	SendVPKeyCmd(VP21CMD_KEY_KEYSTNINC);
}



void
CEP_NSSDlg::OnBtnColorMode()
{
	SendVPKeyCmd(VP21CMD_KEY_COLORMODE);
}



void
CEP_NSSDlg::SendVPKeyCmd(char param)
{
	CECClientThread *pClient = NULL;
	CECSearchClient *pECSearch = NULL;

	if( !m_bNowConnect || m_bReConnecting ) return;

	
	CWaitCursor wait;

	
	CESCVPBase *pEscvp = NULL;
	pEscvp = new CESCVPBase();
	if( !pEscvp )
		goto SendVPKeyCmdErr;

	
	pClient = m_pECServer->GetClientThread(m_cVPSelectClient);
	if( !pClient )
		goto SendVPKeyCmdErr;



	if( m_bEasyMode ){
		pECSearch = m_pECSrchClt;
	}else
	{
		pECSearch = m_IPProjListBox.GetSrchClient();
	}
	CLIENTINFO cinf;
	if( pECSearch ){
		if( pECSearch->GetClientInfoByIP(pClient->GetIPAddress(), &cinf) ){
			eclog.Print(LL_STATE, "m_nDisplayType     = %d.\n", cinf.m_nDisplayType);
			if( (cinf.m_nDisplayType & PROJECTOR_INFO_MODEL ) == PROJECTOR_MODEL_KIR ){
				if( param == VP21CMD_KEY_VIDEO )
					param = VP21CMD_KEY_VIDEO_KIR;
				else if( param == VP21CMD_KEY_PC )
					param = VP21CMD_KEY_PC_KIR;
			}
		}
	}


	
	if( !pEscvp->Open(pClient->GetIPAddress(), m_ulSvrIPAddr, m_usESCVPPort))
		goto SendVPKeyCmdErr;

	
	if( !pEscvp->SetKeyCommand(param) )
		goto SendVPKeyCmdErr;

	delete pEscvp;
	return;
	
SendVPKeyCmdErr:
	if( pEscvp )
		delete pEscvp;

	ECMessageBox(IDS_ERR_STRING0024);
	return;
}



BOOL
CEP_NSSDlg::SetCtrlStat(int nDlgItemID, int nResID, CFont* pFon)
{
	if( !m_plczRes) return FALSE;

	CWnd *wnd = (CWnd*)this->GetDlgItem(nDlgItemID);
	LCCONTROL *lcCtl = m_plczRes->GetCtlInf(nResID);
	if( !wnd || !lcCtl) return FALSE;

	
	wnd->SetFont(pFon, TRUE);

	
	int wid = lcCtl->rec.right - lcCtl->rec.left;
	int hei = lcCtl->rec.bottom - lcCtl->rec.top;
	wnd->MoveWindow(lcCtl->rec.left, lcCtl->rec.top, wid, hei, TRUE);
	return TRUE;
}



int
CEP_NSSDlg::ECMessageBox(UINT resID)
{
	int ret = 0;

	if( !m_plczRes ) return -1;

	
	
	if( resID >= FIRST_ERR_STRING_ID && resID < FIRST_WRN_STRING_ID){





		this->SetForegroundWindow();
		ret = MessageBox(m_plczRes->GetString(resID), ECON_PRODUCTNAME, MB_OK|MB_ICONSTOP);

	
	}else if( resID >= FIRST_WRN_STRING_ID && resID < FIRST_INF_STRING_ID){
		





		this->SetForegroundWindow();
		ret = MessageBox(m_plczRes->GetString(resID), ECON_PRODUCTNAME, MB_OK|MB_ICONWARNING);

	


		



			




	}

	else if( resID == IDS_ERR_ADAPTERERROR ){
		char cmes[MESSAGE_MAXLEN];
		sprintf(cmes, "%s\n%s\n\n %s\n %s\n %s"
					,m_plczRes->GetString(IDS_ERR_STRING0030)
					,m_plczRes->GetString(IDS_ERR_STRING0031)
					,m_plczRes->GetString(IDS_ERR_STRING0032)
					,m_plczRes->GetString(IDS_ERR_STRING0033)
					,m_plczRes->GetString(IDS_ERR_STRING0034)
				);




		ret = MessageBox(cmes, ECON_PRODUCTNAME, MB_OK|MB_ICONSTOP);


	}

	return ret;
}


void
CEP_NSSDlg::GuideMessage(UINT nFlag)
{
	if( !m_plczRes ) return;

	CWnd *pWnd;
	TCHAR *pLine1, *pLine2, *pLine3;
	RECT rec = {23, 60, 342, 115};
	if( nFlag == ECDLG_MESSTAT_CLEAR ){
		pLine1 = NULL;
		pLine2 = NULL;
		pLine3 = NULL;
	}else if( nFlag == ECDLG_MESSTAT_PROJFOUND ){
		pLine1 = m_plczRes->GetString(IDS_RES_STRING0017);
		pLine2 = m_plczRes->GetString(IDS_RES_STRING0018);
		pLine3 = m_plczRes->GetString(IDS_RES_STRING0019);
	}else if( nFlag == ECDLG_MESSTAT_NOTFOUND ){
		pLine1 = m_plczRes->GetString(IDS_RES_STRING0020);
		pLine2 = m_plczRes->GetString(IDS_RES_STRING0021);
		pLine3 = m_plczRes->GetString(IDS_RES_STRING0056);
	}else if( nFlag == ECDLG_MESSTAT_IPCONNECT ){
		pLine1 = m_plczRes->GetString(IDS_RES_STRING0014);
		pLine2 = m_plczRes->GetString(IDS_RES_STRING0057);
		pLine3 = m_plczRes->GetString(IDS_RES_STRING0056);
	}else if( nFlag == ECDLG_MESSTAT_CONNECTING ){
		pLine1 = m_plczRes->GetString(IDS_INF_STRING0004);
		pLine2 = m_plczRes->GetString(IDS_RES_STRING0056);
		pLine3 = m_plczRes->GetString(IDS_RES_STRING0056);


	}else if( nFlag == ECDLG_MESSTAT_NOIPADDRESS ){
		pLine1 = m_plczRes->GetString(IDS_INF_STRING0001);
		pLine2 = m_plczRes->GetString(IDS_RES_STRING0056);
		pLine3 = m_plczRes->GetString(IDS_RES_STRING0056);

	}else{
		return;
	}

	pWnd = this->GetDlgItem(ECON_STX_STATMES);
	if( pWnd )
		pWnd->SetWindowText(pLine1);
	pWnd = this->GetDlgItem(ECON_STX_STATMES2);
	if( pWnd )
		pWnd->SetWindowText(pLine2);
	pWnd = this->GetDlgItem(ECON_STX_STATMES3);
	if( pWnd )
		pWnd->SetWindowText(pLine3);

	this->RedrawWindow(&rec);

	
	
	m_nGuideMesStatus = nFlag;


	if( m_nGuideMesStatus == ECDLG_MESSTAT_NOTFOUND ){
		if( m_nHelpArrowTimer == NULL ){
			m_bHelpArrow = TRUE;
			m_nHelpArrowTimer = SetTimer(	ECON_TIMEREVENT_ARROWANIME, 
											ECON_ARROWBLINK_TIME,
											NULL);
		}
	}else
	{
		if( m_nHelpArrowTimer ){
			KillTimer(m_nHelpArrowTimer);
			m_nHelpArrowTimer = NULL;
		
			m_bHelpArrow = FALSE;
			RedrawWindow(&g_ArrowRec);
		}
	}


	
	CWnd *pMiniHlp = GetDlgItem(ECON_BTN_MAINHELP);
	if( pMiniHlp )
		pMiniHlp->EnableWindow((m_nGuideMesStatus != 0));

}






#define SELADPDLG_NOTSUPPORT		-10
#define SELADPDLG_FAILMEMALLOC		-11
#define SELADPDLG_FAILGETADPINF		-12
#define SELADPDLG_EXISTSREGISTLAN	-13		

BOOL
CEP_NSSDlg::GetAdaptersInfo()
{

	EPNSD_DLGDATA stDlgData;

	
	stDlgData.pLocal = m_plczRes;
	stDlgData.bAdapterChange = FALSE;
	stDlgData.pMainApp = (CWinApp*)AfxGetApp();
	lstrcpy(stDlgData.sAppPath, ((CEP_NSSApp*)AfxGetApp())->m_sAppPath);
	stDlgData.stAdapter.nIPAddr = ((CEP_NSSApp*)AfxGetApp())->m_nAdpIPAddress;
	memcpy(stDlgData.stAdapter.bMACAddr, ((CEP_NSSApp*)AfxGetApp())->m_sCurrentMACAddr,
				MAC_ADDR_LENGTH);

	stDlgData.stAdapter.bOnStartFlg = TRUE;

	
	m_cDlgMng.SetDlgData(&stDlgData);
	int nRet = m_cDlgMng.Show_LANSelDlg(this);

	



	
	





	if( nRet == SELADPDLG_NOTSUPPORT ){
		eclog.Print(LL_ERROR, "getadaptersinfo not supported.\n");
		ECMessageBox(IDS_ERR_STRING0018);
		return FALSE;

	}else if( nRet == SELADPDLG_FAILMEMALLOC ){
		eclog.Print(LL_ERROR, "memory alloc error.\n");
		ECMessageBox(IDS_ERR_STRING0016);
		return FALSE;

	}else if( nRet == SELADPDLG_FAILGETADPINF ){
		eclog.Print(LL_ERROR, "Failed to get adapters infomation.\n");


		ECMessageBox(IDS_ERR_ADAPTERERROR);

		return FALSE;

	}else if( nRet == SELADPDLG_EXISTSREGISTLAN || nRet == IDOK ){

		m_ulSvrIPAddr = m_nAdpIPAddress = m_cDlgMng.GetDlgData()->stAdapter.nIPAddr;
		m_ulSvrSubnet = m_cDlgMng.GetDlgData()->stAdapter.nSubnetAddr;
		m_ulSvrGateway = m_cDlgMng.GetDlgData()->stAdapter.nGateAddr;





		if( m_ulSvrIPAddr == 0 ){
			eclog.Print(LL_STATE, "not avilable IPAddress.\n");


			ECMessageBox(IDS_ERR_ADAPTERERROR);

			return FALSE;
		}

		if( nRet == IDOK ){
			((CEP_NSSApp*)AfxGetApp())->m_nAdpIPAddress = m_nAdpIPAddress;


			memcpy(((CEP_NSSApp*)AfxGetApp())->m_sCurrentMACAddr,
				m_cDlgMng.GetDlgData()->stAdapter.bMACAddr, MAC_ADDR_LENGTH);

			((CEP_NSSApp*)AfxGetApp())->SaveRegistry();
		}
	
		
		in_addr addr;
		addr.S_un.S_addr = m_ulSvrIPAddr;
		eclog.Print(LL_STATE, "\tIP Address  = %s.\n", inet_ntoa(addr));
		addr.S_un.S_addr = m_ulSvrSubnet;
		eclog.Print(LL_STATE, "\tSubnet Mask = %s.\n", inet_ntoa(addr));
		addr.S_un.S_addr = m_ulSvrGateway;
		eclog.Print(LL_STATE, "\tGateWay     = %s.\n", inet_ntoa(addr));
		return TRUE;
	}
	return FALSE;
}



BOOL
CEP_NSSDlg::CheckAdaptersInfo()
{
	CAdaptersInfo adpinf;
	if( adpinf.Init() != ADPINFO_NOERR )
		return FALSE;

	for(int i=0; i<(int)adpinf.GetCount(); i++){

		
		if( memcmp(((CEP_NSSApp*)AfxGetApp())->m_sCurrentMACAddr, 
					adpinf.GetMacAddr(i), MAC_ADDR_LENGTH )==0 ){
			
			
			for(int j=0; j<adpinf.GetIPAddress(NULL,i); j++){
				ADP_IPADDR addr;
				adpinf.GetIPAddress(&addr,i,j);
				if( addr.uIPAddr == ((CEP_NSSApp*)AfxGetApp())->m_nAdpIPAddress ){

					if( addr.uSubnet != m_ulSvrSubnet ){
						m_ulSvrSubnet = addr.uSubnet;
						eclog.Print(LL_STATE, "Subnet Address changed.\n");
						
						if( m_pECPing )
							delete m_pECPing;
					
						m_pECPing = new CECPing();
						if( !m_pECPing ){
							eclog.Print(LL_ERROR, "Failed to create 'CECPing' Object.\n");
							ECMessageBox(IDS_ERR_STRING0016);
							EndDialog(IDCANCEL);
							return FALSE;
						}

						if( !m_pECPing->Init(m_ulSvrIPAddr, m_ulSvrSubnet, m_ulSvrGateway)){
							eclog.Print(LL_ERROR, "Failed to Initialize 'CECPing' Object.\n");
							delete m_pECPing;
							m_pECPing = NULL;
							ECMessageBox(IDS_ERR_STRING0016);
							EndDialog(IDCANCEL);
							return FALSE;
						}

					}
					return TRUE;
				}
			}
		}
	}
	return FALSE;
}



void
CEP_NSSDlg::OnTimer(UINT nIDEvent) 
{
	
	if( nIDEvent == ECON_TIMEREVENT_SEARCHTIMER ){
		
		if( !CheckAdaptersInfo() && !m_bNowConnect){
			KillTimer(m_nSearchTimer);
			m_nSearchTimer = NULL;

			ECMessageBox(IDS_ERR_STRING0029);
			eclog.Print(LL_ERROR, "Failed to find current adapter.\n");
			PostQuitMessage(0);
			return;			
		}
		

		
		if( m_pECSrchClt){
			eclog.Print(LL_STATE, "Call StartReceiveUDP.\n");
			m_pECSrchClt->StartReceiveUDP();
		}else{
			eclog.Print(LL_ERROR, "m_pECSrchClt pointer is not avairable.\n");
			KillTimer(m_nSearchTimer);
			m_nSearchTimer = NULL;
			return;
		}		

		m_nSearchResultCounter = 0;
		
		if( m_pECSrchClt)
			m_pECSrchClt->ResetListChangeFlg();

		
		
		
		if( !m_pECSrchClt->SearchClient(0) && !m_bNowConnect){
		
			KillTimer(m_nSearchTimer);
			m_nSearchTimer = NULL;
			ECMessageBox(IDS_ERR_STRING0029);
			eclog.Print(LL_ERROR, "!! Failed to send broadcast for searching projector.\n");
			PostQuitMessage(0);
			
			return;			
		}else
			eclog.Print(LL_STATE, "Sent broadcast packet for search.\n");

		
		m_nResultTimer = SetTimer(ECON_TIMEREVENT_SEARCHRESULT, ECON_PROJLIST_SEARCHTIMEOUT, NULL);

	
	}else if( nIDEvent == ECON_TIMEREVENT_SEARCHRESULT ){
		eclog.Print(LL_STATE, "Timeover of searching.\n");

		m_nSearchResultCounter++;
		if( m_nSearchResultCounter >= ECON_PROJLIST_SEARCHRSLTCNTMAX ){

			
			KillTimer(m_nResultTimer);
			m_nResultTimer = NULL;

			
			if( m_pECSrchClt ){
				eclog.Print(LL_STATE, "Call EndReceiveUDP.\n");
				m_pECSrchClt->EndReceiveUDP();
			}else
			{
				eclog.Print(LL_ERROR, "!! m_pECSrchClt pointer is not avairable.\n");
				CDialog::OnTimer(nIDEvent);
				return;
			}
		}
		

		if( m_pECSrchClt ){
			if( m_pECSrchClt->GetListChangeFlg() ){
				UpdateProjList();
				m_pECSrchClt->ResetListChangeFlg();
			}
		}



		if( m_nUIMode == UIMODE_PROJLIST ){
			if( m_bNowConnect ){




			}else
			{
				if( m_pECSrchClt ){
					if( m_pECSrchClt->GetClientCount() == 0){
						if( m_bExistProj || m_nFirstSearch){


							GuideMessage(ECDLG_MESSTAT_NOTFOUND);

							SetItemStat(ECON_BTN_CONNECT, !m_bNowConnect, FALSE);
						}
						m_bExistProj = FALSE;
					}else{
						if( !m_bExistProj || m_nFirstSearch){


							GuideMessage(ECDLG_MESSTAT_PROJFOUND);

							SetItemStat(ECON_BTN_CONNECT, !m_bNowConnect, TRUE);
						}
						m_bExistProj = TRUE;
					}
				}
				m_nFirstSearch = FALSE;
			}
		}
	
	}else if( nIDEvent == ECON_TIMEREVENT_INDICATOR ){
		eclog.Print(LL_STATE, "Update gauge.\n");

		SCRINFO scrinf;
		GetResolutionInfo(scrinf);

		eclog.Print(LL_STATE, "resolution info height = %d, width = %d, bpp = %d\n", scrinf.nScrHei, scrinf.nScrWid, scrinf.nScrBPP);


		if( m_nIndiCounter > 0 )
			m_nIndiCounter++;

		if( m_nIndiCounter == 0 || m_nIndiCounter > 3 ){
			eclog.Print(LL_STATE, "Call IsSending Function of VNeS Server.\n");

			DWORD datasize;
			m_VNeSLib.IsSending(datasize);
		
			eclog.Print(LL_STATE, "Get sending data size. size= %d\n",(int)datasize);
			
			if( datasize > 0){
				m_nIndiCounter = 1;





			}else{
				m_nIndiCounter = 0;

			}
		}


		if( m_bNowConnect )
		{
			CDC dc;
			HDC hDC = ::GetDC(this->m_hWnd);
			dc.Attach(hDC);

			m_plczRes->PaintDIBmp(dc, m_recIndi.left, m_recIndi.top, m_nBackBmpID,
									m_recIndi.right-m_recIndi.left, m_recIndi.bottom-m_recIndi.top,
									m_recIndi.left,m_recIndi.top);
			if( m_nIndiCounter > 0 ){ 
				m_plczRes->PaintDIBmp(dc, m_recIndi.left, m_recIndi.top, BMP_INDICATOR,
										m_recIndi.right-m_recIndi.left, m_recIndi.bottom-m_recIndi.top,
										0,(m_recIndi.bottom-m_recIndi.top)*m_nIndiCounter);
			}
			dc.Detach();
			::ReleaseDC(this->m_hWnd,hDC);
		}
			

	}else if( nIDEvent == ECON_TIMEREVENT_EXPANDWINDOW){
		m_nWaitCursor = FALSE;
		KillTimer(m_nExpandWindowTimer);
		m_nExpandWindowTimer = NULL;

		if( m_bExpandWindow ){
			
			PostMessage(WM_TIMER, ECON_TIMEREVENT_SEARCHTIMER, NULL);

			
			EnableWindow(TRUE);
			

			m_bNowConnect = FALSE;
			if( m_bEasyMode )
				ChangeUIMode(UIMODE_PROJLIST);
			else
				ChangeUIMode(UIMODE_IPCONNECT);


			m_bDisconnecting = FALSE;


		}else
		{
			m_bNowConnect = TRUE;
			ChangeUIMode(UIMODE_NORMAL);
		}

	}

	else if( nIDEvent == ECON_TIMEREVENT_ARROWANIME ){
		m_bHelpArrow = !m_bHelpArrow;
		RedrawWindow(&g_ArrowRec);
	}
	
	CDialog::OnTimer(nIDEvent);
}



void
CEP_NSSDlg::UpdateProjList()
{
	if( !m_pECSrchClt )
		return;

	
	for(int i=0; i<m_pECSrchClt->GetClientCount(); i++){
		BOOL bUpdateFlg = FALSE;
		CLIENTINFO cinf;
		if( !m_pECSrchClt->GetClientInfo(i, &cinf) ) break;

		
		for(int j=0; j<m_ProjListBox.GetCount(); j++){
			if( memcmp(m_ProjListBox.GetUniqInfo(j), cinf.m_projUniqInfo, ECON_UNIQINFO_LENGTH) == 0){
				bUpdateFlg = TRUE;
				break;
			}
		}

		int state = cinf.m_projState;
		if( state == e_pstat_using ){
			if( !m_pECServer->GetClientThread(cinf.m_projUniqInfo) )
				state = ECON_PROJSTAT_OTHERSUSING;
		}else if( state == e_pstat_appusing){
			state = ECON_PROJSTAT_OTHERAPPUSING;
		}
		if( bUpdateFlg ){
			m_ProjListBox.UpdateECItem(	j,
										cinf.m_projName,
										cinf.m_projUniqInfo,
										(unsigned char)(state-1) );

		}else{
			m_ProjListBox.AddECItem(	cinf.m_projName,
										cinf.m_projUniqInfo,
										(unsigned char)(state-1) );
		}
		UpdateData(TRUE);
	}

	
	for(i=0; i<m_ProjListBox.GetCount(); i++){
		CLIENTINFO cinf;
		if( !m_pECSrchClt->GetClientInfo(m_ProjListBox.GetUniqInfo(i), &cinf)){
			m_ProjListBox.DeleteECItem(i);
			i--;
		}
	}
	m_ProjListBox.RedrawWindow();
}



BOOL
CEP_NSSDlg::CheckProjIPAddr(ULONG addr)
{
	DWORD svrSnt = (DWORD)htonl(m_ulSvrIPAddr) & (DWORD)htonl(m_ulSvrSubnet);
	DWORD cltSnt = (DWORD)htonl(addr) & (DWORD)htonl(m_ulSvrSubnet);
	
	if( svrSnt == cltSnt ) return TRUE;
	return FALSE;
}



LRESULT
CEP_NSSDlg::OnESCCommand(WPARAM wParam, LPARAM lParam)
{
	wParam;
	int nlprm = lParam;
	if( nlprm == e_memerror ){
		eclog.Print(LL_ERROR, "!!! Failed to alloc memory in CSearchClient class.\n");
		ECMessageBox(IDS_ERR_STRING0016);
		PostQuitMessage(0);
	}
	else if( nlprm == e_sockerror ){

		
		eclog.Print(LL_ERROR, "!!! UDP Socket Error occured in CSearchClient class.\n");
		if( m_bNowConnect && !m_bReConnecting ){		
			ECMessageBox(IDS_ERR_STRING0029);
			PostQuitMessage(0);
		}
	}
	else if( nlprm == e_commanderror ){
		eclog.Print(LL_ERROR, "!!! Receive a bad UDP command in CSearchClient class.\n");
	}

	return 0;
}



LRESULT
CEP_NSSDlg::OnECMCommand(WPARAM wParam, LPARAM lParam)
{
	CECClientThread *ect = NULL;
	CEconCommand *pEcon;
	if( !m_pECServer ) return 0;

	int cmdID = (int)wParam;

	if( wParam != e_resendid ){
		ect = (CECClientThread*)lParam;
		if( !ect ) return 0;
		eclog.Print(LL_STATE, "receive command from clientThread cmdID=%d client=%s\n"
							, cmdID, ect->GetProjName());
	}

	switch(cmdID){
	
	case e_interrupt:
	case e_disconclient:


		if( m_bReConnecting || m_bDisconnecting) return 0;


		char wrnmes[LOCALSTR_MAXLEN];
		if(cmdID==e_interrupt){
			sprintf(wrnmes, "%s", m_plczRes->GetString(IDS_WRN_STRING0004));
			eclog.Print(LL_STATE, "receive e_cmd_interrupt command from client ProjectorName=%s\n",
						ect->GetProjName());
		}else{
			sprintf(wrnmes, "%s", m_plczRes->GetString(IDS_WRN_STRING0003));
			eclog.Print(LL_STATE, "receive e_cmd_disconclient command from client ProjectorName=%s\n",
						ect->GetProjName());
		}

		
		pEcon = m_pECServer->GetEconCommand();
		ASSERT(pEcon);
		pEcon->DeleteRecord(ect->GetUniqInfo());
		eclog.Print(LL_STATE, "delete record data of discon client.\n");



		pEcon->MakeReqConnect(m_bUseEnc, m_cEncPassword, m_ulSvrSubnet, m_ulSvrGateway);
		eclog.Print(LL_STATE, "remake record data.\n");


		
		if(cmdID == e_disconclient){

			CECSearchClient *pECSearch = NULL;
			if( m_bEasyMode ){
				pECSearch = m_pECSrchClt;
			}else
			{
				pECSearch = m_IPProjListBox.GetSrchClient();
			}


			if( pECSearch ){

				CLIENTINFO cinf;

				if( pECSearch->GetClientInfo(ect->GetUniqInfo(), &cinf)){
					eclog.Print(LL_STATE, "change icon status to nouse.\n");
					cinf.m_projState = e_pstat_nouse;

					pECSearch->SetClientInfo(&cinf);
				}
			}

		}
		

		
		m_pECServer->KillClientThread(ect->GetUniqInfo());
		eclog.Print(LL_STATE, "Kill thread of discon client.\n");

		
		if( (m_nConnectCnt = m_pECServer->GetThreadCount())==0 ){
			eclog.Print(LL_STATE, "There isn't any client.\n");




			this->SetForegroundWindow();
			::MessageBox(this->m_hWnd, wrnmes, ECON_PRODUCTNAME, MB_ICONWARNING|MB_OK);



			this->UpdateWindow();

			eclog.Print(LL_STATE, "Call OnBtnDisConnect function.\n");
			OnBtnDisConnect();
		}else
		{
			eclog.Print(LL_STATE, "Keep connection.\n");
			
			OnChangeClientCount();
		}
		break;

	
	case e_networkerr:


		if( m_bNowConnect && !m_bEMPConnecting && !m_bDisconnecting){

			

			CECSearchClient *pECSearch = NULL;
			if( m_bEasyMode ){
				pECSearch = m_pECSrchClt;
			}else
			{
				pECSearch = m_IPProjListBox.GetSrchClient();
			}

			if( pECSearch ){
				CLIENTINFO cinf;

				if( pECSearch->GetClientInfo(ect->GetUniqInfo(), &cinf)){
					eclog.Print(LL_STATE, "change icon status to nouse.\n");
					cinf.m_projState = e_pstat_nouse;

					pECSearch->SetClientInfo(&cinf);
				}
			}

		
			
			
			m_pECServer->KillClientThread(ect->GetUniqInfo());
			eclog.Print(LL_STATE, "Kill thread of discon client.\n");

			
			if( (m_nConnectCnt = m_pECServer->GetThreadCount())==0 ){
				eclog.Print(LL_STATE, "There isn't any client.\n");

				
				if( m_nSearchTimer ){
					eclog.Print(LL_STATE, "Stopped projector search timer.\n");
					KillTimer(m_nSearchTimer);
					m_nSearchTimer = NULL;
				}

				
				if( !m_bReConnecting ){
					m_bReConnecting = TRUE;
					eclog.Print(LL_ERROR, "!!!  network error occured  !!!\n");





					this->SetForegroundWindow();
					int nRet = MessageBox(m_plczRes->GetString(IDS_ERR_STRING0009), ECON_PRODUCTNAME, MB_ICONWARNING|MB_YESNO);


					if( nRet == IDNO ){
						OnBtnDisConnect();
						return 0;
					}

					
					TryReconnect();
	
					m_bReConnecting = FALSE;
				}
			}else
			{
				eclog.Print(LL_STATE, "Keep connection.\n");
				
				OnChangeClientCount();
			}			
		}

		break;


	
	






	
	











	






	}


	
	if( !m_bEasyMode ){
		m_IPProjListBox.m_nConIPNum = 0;
		for(int i=0; i<m_pECServer->GetThreadCount(); i++){
			CECClientThread* pClient = m_pECServer->GetClientThread(i);
			if( pClient ){
				m_IPProjListBox.m_ConIPList[m_IPProjListBox.m_nConIPNum] = pClient->GetIPAddress();
				m_IPProjListBox.m_nConIPNum++;
			}
		}
	}


	return 0;
}



LRESULT
CEP_NSSDlg::OnVNeSCommand(WPARAM wParam, LPARAM lParam)
{
	int cmdID = (int)wParam;
	ULONG clientIP = (ULONG)lParam;

	switch(cmdID){

	
	case resolutionChange:
		eclog.Print(LL_STATE, "Receive Resolution Change Message from VNeS.\n");

		






		
		if( m_bNowConnect && !m_bReConnecting){
			int retryCnt=0;
			while(retryCnt++ < ECON_RESOLUTION_CHANGE_RETRY){	

				
				m_pECServer->RestartClients();
				eclog.Print(LL_STATE, "Restart client.\n");

				
				m_pECServer->ClearThreadList();
				eclog.Print(LL_STATE, "clear client threads.\n");

				if( m_VNeSLib.IsConnecting() ){
					m_VNeSLib.Disconnect();
					eclog.Print(LL_STATE, "Disconnet VNeS.\n");
				}

				eclog.Print(LL_STATE, "Start Reconnect.\n");
				m_bReConnecting = TRUE;
				
				CWaitCursor wait;

				
				
				SCRINFO scrinf;
				GetResolutionInfo(scrinf);


				if( scrinf.nScrWid > (int)m_resolutionMaxWidth || scrinf.nScrHei > (int)m_resolutionMaxHeight ){

					ECMessageBox(IDS_ERR_STRING0025);
					m_bReConnecting = FALSE;
					OnBtnDisConnect();
					return 0;
				}
				

				
				else if( (scrinf.nScrWid > ECON_SXGA_WIDTH || scrinf.nScrHei > ECON_SXGA_HEIGHT) && m_bNoSupportUXGA ){
					ECMessageBox(IDS_ERR_STRING0040);
					m_bReConnecting = FALSE;
					OnBtnDisConnect();
					return 0;
				}

			
				if( !EMPConnect(e_emp_resolution) ){
					eclog.Print(LL_ERROR, "Failed to reconnect at changing resolution.\n");
					ECMessageBox(IDS_ERR_STRING0012);
					OnBtnDisConnect();
					m_bReConnecting = FALSE;
					return 0;
				}

				
				rfbServerInitMsg nowResolution;
				m_VNeSLib.GetScreenFormat(nowResolution);

				eclog.Print(LL_STATE, "Check Resolution Info.\n");
				eclog.Print(LL_STATE, "framebufferHeight  previous = %d now = %d.\n",m_vnesInitData.framebufferHeight
																					,nowResolution.framebufferHeight);

				eclog.Print(LL_STATE, "framebufferWidth  previous = %d now = %d.\n",m_vnesInitData.framebufferWidth
																					,nowResolution.framebufferWidth);

				eclog.Print(LL_STATE, "bitsPerPixel  previous = %d now = %d.\n",m_vnesInitData.format.bitsPerPixel
																					,nowResolution.format.bitsPerPixel);

				if( nowResolution.framebufferHeight == m_vnesInitData.framebufferHeight &&
					nowResolution.framebufferWidth  == m_vnesInitData.framebufferWidth &&
					nowResolution.format.bitsPerPixel == m_vnesInitData.format.bitsPerPixel )
					break;
			}
			m_bReConnecting = FALSE;
		}
		break;
	
	
	case clientLost:
		eclog.Print(LL_STATE, "! Receive VNeS Client Lost Message !");

		if( m_pECServer ){
			for(int i=0; i<m_pECServer->GetThreadCount(); i++){
				CECClientThread *client = m_pECServer->GetClientThread(i);
				if( client ){
					eclog.Print(LL_STATE, "get error client info.client ip=%x, vneslost ip = %x\n", client->GetIPAddress(), clientIP);
				
					if( client->GetIPAddress() == clientIP ){
						client->SetStatus( client->GetStatus() | e_vneslost );
						eclog.Print(LL_STATE, "set e_vneslost to client status.\n");
						break;
					}
				}
			}
		}

		break;

	
	case vnesError:
		switch(lParam){
		case VERROR_Memory:
			ECMessageBox(IDS_ERR_STRING0016);
			break;
		case VERROR_AppWindow:
		case VERROR_AlreadyExists:
		case VERROR_Init:
		case VERROR_Palette:
			ECMessageBox(IDS_ERR_STRING0005);
			break;
		case VERROR_HookDriver: 
			ECMessageBox(IDS_ERR_STRING0002);
			break;
		}

		eclog.Print(LL_ERROR,"receive error message from VNeS Server.errorcode=%d\n"
					, (int)lParam);
		EndDialog(IDCANCEL);
		return 0;
	default:
		break;
	}

	return 0;
}


LRESULT
CEP_NSSDlg::OnIPProjListMes(WPARAM wParam, LPARAM lParam)
{
	wParam;
	lParam;
	if( !m_bNowConnect ){
		ECMessageBox(IDS_ERR_STRING0029);
		eclog.Print(LL_ERROR, "!!!Netwrok error occured in IPProjListBox.\n");
		PostQuitMessage(0);
	}
	return 0;
}



BOOL
CEP_NSSDlg::EMPConnect(int reconFlg)
{
	eclog.Print(LL_STATE, "Enter EMPConnect Function. reconFlg=%d\n", reconFlg);


	CECSearchClient *pECSearch = NULL;

	if( m_bEasyMode ){
		pECSearch = m_pECSrchClt;
	}else
	{
		pECSearch = m_IPProjListBox.GetSrchClient();
	}

	if( !m_pECServer || !pECSearch) return FALSE;


	m_bEMPConnecting = TRUE;




	
	if( reconFlg == e_emp_error ){


		





		
		


		pECSearch->ClearClientList();


		
		eclog.Print(LL_STATE, "Call StartReceiveUDP.\n");


		pECSearch->StartReceiveUDP();

		

		

		BOOL err = FALSE;
		if( m_bEasyMode ){
			if( !pECSearch->SearchClient() )
				err = TRUE;
		
		}else
		{
			
			for(int i=0; i<(int)m_nConnectCInfo; i++)
			{
				if( !pECSearch->SearchClient(m_ConnectCInfo[i].m_projIPaddress) ){
					err = TRUE;
					break;
				}
			}
		}

		
		



		if( err ){

		
			



			pECSearch->EndReceiveUDP();

			m_bEMPConnecting = FALSE;
			return FALSE;
		}

		
		
		Sleep(ECON_RECONSRCH_SLEEP);

		
		eclog.Print(LL_STATE, "Call EndReceiveUDP.\n");


		pECSearch->EndReceiveUDP();

		

		eclog.Print(LL_STATE, "client info Count = %d.\n", pECSearch->GetClientCount());

		
		BOOL bUsing = FALSE;

		int nResultNum = 0;
		for(int i=0; i<(int)m_nConnectCInfo; i++){













				CLIENTINFO cinf;


				if( pECSearch->GetClientInfo(m_ConnectCInfo[i].m_projUniqInfo, &cinf) )

				{
			
					if((cinf.m_projState == e_pstat_using || 
					    cinf.m_projState == e_pstat_appusing) &&
			
			


						m_pECServer->GetClientThread(m_ConnectCInfo[i].m_projUniqInfo) == NULL)

					{
						eclog.Print(LL_STATE, "Set bUsing Flag TRUE.\n");
						bUsing = TRUE;

					}
					eclog.Print(LL_STATE, "Get client info of projector.\n");
					nResultNum++;
				}



		}

		
		if( nResultNum == 0 ){
			eclog.Print(LL_ERROR, "!!! Failed to get client info in reconnction.\n");
			m_bEMPConnecting = FALSE;
			return FALSE;
		}

		if( bUsing ){
			eclog.Print(LL_STATE, "Exists using client.\n");



			int nRet = MessageBox(m_plczRes->GetString(IDS_WRN_STRING0008), ECON_PRODUCTNAME, MB_ICONWARNING|MB_YESNO);





			
			this->RedrawWindow(NULL,NULL,RDW_ALLCHILDREN);
			
			if( nRet == IDNO ){
				m_bEMPConnecting = FALSE;



				return FALSE;
			}
		}
	}
	


	
	m_pECServer->RestartClients();
	eclog.Print(LL_STATE, "Restart client.\n");

	
	m_pECServer->ClearThreadList();
	eclog.Print(LL_STATE, "clear client threads.\n");

	
	if( m_VNeSLib.IsConnecting() ){
		m_VNeSLib.Disconnect();
		eclog.Print(LL_STATE, "DisConnected VNeS Server.\n");
	}

	



	m_VNeSLib.GetScreenFormat(m_vnesInitData);

	
	CEconCommand *econ = m_pECServer->GetEconCommand();
	ASSERT(econ);
	ECONCOMMAND *ecdat = econ->GetEconCommand();
	ASSERT(ecdat);
		

	memcpy(&ecdat->command.reqconnect.vnesInitMsg, &m_vnesInitData, sizeof(rfbServerInitMsg));





	if( reconFlg != e_emp_resolution ){
		CEconCommand diswait;
		diswait.Clear();
		diswait.SetParam(m_ulSvrIPAddr, ((CEP_NSSApp*)AfxGetApp())->m_nPort);
		
		
		for(int j=0; j<econ->GetRecordNum();j++){
			
			ECONRECORD *pERec = m_pECServer->GetEconCommand()->GetEconRecord(j);
			ASSERT(pERec);
			if( !diswait.AddRecord(pERec->projUniqInfo, "", 0) ){
				m_bEMPConnecting = FALSE;
				if( reconFlg == e_emp_connect )
					ECMessageBox(IDS_ERR_STRING0015);
				return FALSE;
			}
		}
		
		
		diswait.MakeDispWait();


		BOOL rc=TRUE;
		if( m_bEasyMode ){
			rc = pECSearch->SendUDP(&diswait, 0);
		}else
		{
			for(int i=0; i<(int)m_nConnectCInfo; i++){
				rc = pECSearch->SendUDP(&diswait, m_ConnectCInfo[i].m_projIPaddress);
				if( !rc ) break;
			}
		}
		if( !rc )
		{

			m_bEMPConnecting = FALSE;
			if( reconFlg == e_emp_connect )
				ECMessageBox(IDS_ERR_STRING0015);
			return FALSE;
		}
	}

	
	
	Sleep(DISPLAYWAIT_DELAY);




	int nKeywordRetry = 0;


	while(TRUE){

		
		int nClientCount = m_pECServer->GetEconCommand()->GetRecordNum();

		
		if( reconFlg != e_emp_resolution ){
			for(int j=0; j < nClientCount; j++){
				
				ECONRECORD *pERec = m_pECServer->GetEconCommand()->GetEconRecord(j);
				if( !pERec ){
					m_bEMPConnecting = FALSE;
					return FALSE;
				}

				
				CLIENTINFO cinf;


				if( !pECSearch->GetClientInfo(pERec->projUniqInfo, &cinf) ){

					m_bEMPConnecting = FALSE;
					return FALSE;
				}

				
				if( cinf.m_projUseKeyword ){

					
					BOOL bKwdErr = FALSE;
					if( nKeywordRetry > 0 ){
						for(int k=0; k<m_pECServer->m_nKwdErrCount; k++){
							if( memcmp(pERec->projUniqInfo, &m_pECServer->m_KwdErrList[k], ECON_UNIQINFO_LENGTH)==0){
								bKwdErr = TRUE;
								break;
							}
						}
					}

					
					
					if( nKeywordRetry == 0 || (nKeywordRetry >0 && bKwdErr ) ){
						CKeywordDlg KwDlg(m_plczRes, cinf.m_projName, this);
						int nRet = KwDlg.DoModal();

						
						
						
						this->UpdateWindow();
		
						if( nRet == IDOK ){
							
							memset(pERec->projKeyword, 0, ECON_KEYWORD_MAXLEN);
							lstrcpy((char*)pERec->projKeyword, KwDlg.m_keyword);
						}else{
							
							m_pECServer->GetEconCommand()->DeleteRecord(pERec->projUniqInfo);
							nClientCount = m_pECServer->GetEconCommand()->GetRecordNum();
							if( nClientCount == 0 ){
								m_bEMPConnecting = FALSE;
								return FALSE;
							}
							j=j-1;
						}
					}
				}
			}
		}

		
		CWaitCursor wait;
		eclog.Print(LL_STATE, "set cursor wait.\n");
		
		


		int nNotResKey;



		int nRet = m_pECServer->StartEasyConnect(pECSearch, m_ConnectCInfo, 
												m_nConnectCInfo, m_bEasyMode, &nNotResKey);

		eclog.Print(LL_STATE, "Result of StartEasyConnect = %d.\n",nRet);



		if( nRet < 0 && nNotResKey < 0){

			if( nRet == ECS_ERR_MEMALLOC ){
				eclog.Print(LL_ERROR, "Failed to alloc memory.\n");
				ECMessageBox(IDS_ERR_STRING0016);
				EndDialog(IDCANCEL);
				m_bEMPConnecting = FALSE;
				return FALSE;
			}else
			{
				eclog.Print(LL_ERROR, "Failed to connect EasyConnect Cients.\n");
				if( reconFlg == e_emp_connect )
					ECMessageBox(IDS_ERR_STRING0015);
				m_bEMPConnecting = FALSE;
				return FALSE;
			}	

		}else{







 



			
			if( nRet == nClientCount ){
				break;	

			}else
			{
				
				if( m_pECServer->m_nKwdErrCount > 0 && reconFlg != e_emp_resolution){
					nKeywordRetry++;
	
					
					if( nKeywordRetry >= ECON_KEYWORDRETRY_COUNT ){
						if( nRet > 0 ){
							
							for(int k=0; k<m_pECServer->m_nKwdErrCount; k++){
								m_pECServer->GetEconCommand()->DeleteRecord(m_pECServer->m_KwdErrList[k].UniqInfo);
							}
							

							AfxBeginThread(ShowMessageThProc, m_plczRes->GetString(IDS_ERR_STRING0010));
							break;
						}else{
							if( reconFlg == e_emp_connect )
								ECMessageBox(IDS_ERR_STRING0010);
							m_bEMPConnecting = FALSE;
							return FALSE;
						}
					}






					this->SetForegroundWindow();
					MessageBox(m_plczRes->GetString(IDS_ERR_STRING0026), ECON_PRODUCTNAME, MB_OK|MB_ICONWARNING);



				}else{
					
					if( nRet == 0 ){
						eclog.Print(LL_ERROR, "Failed to connect to all clients.\n");
						if( reconFlg == e_emp_connect )
							ECMessageBox(IDS_ERR_STRING0015);
						m_bEMPConnecting = FALSE;
						return FALSE;
					}else{
						
						AfxBeginThread(ShowMessageThProc, m_plczRes->GetString(IDS_WRN_STRING0001));

						CEconCommand *pEcon = m_pECServer->GetEconCommand();
						if( pEcon ){	
							for(int k=0; k<pEcon->GetRecordNum(); k++){
								ECONRECORD *pErec = pEcon->GetEconRecord(k);
								if( pErec ){
									
									if( !m_pECServer->GetClientThread(pErec->projUniqInfo)){
										pEcon->DeleteRecord(pErec->projUniqInfo);
									}
								}
							}
						}

						break;
					}
				}
			}
		}

		m_pECServer->RestartClients();
		m_pECServer->ClearThreadList();
	}

	m_nConnectCnt = m_pECServer->GetThreadCount();
	if( m_nConnectCnt == 0 ){
		if( reconFlg == e_emp_connect )
			ECMessageBox(IDS_ERR_STRING0015);
		m_bEMPConnecting = FALSE;
		return FALSE;
	}


	




	
	if( reconFlg == e_emp_connect || reconFlg == e_emp_error){
		m_bNowConnect = TRUE;
		ChangeUIMode(UIMODE_NORMAL);


		CWnd *wCtl = (CWnd*)GetDlgItem(ECON_BTN_HELP);
		if(wCtl) wCtl->SetFocus();

	}



	
	if( !VNeSConnect(m_nConnectCnt) ){
		m_bNowConnect = FALSE;

		if( reconFlg == e_emp_connect ){
			ECMessageBox(IDS_ERR_STRING0004);	
			if( m_bEasyMode )
				ChangeUIMode(UIMODE_PROJLIST);
			else
				ChangeUIMode(UIMODE_IPCONNECT);
		}
		
		m_bEMPConnecting = FALSE;
		return FALSE;
	}

	eclog.Print(LL_STATE, "Connected Count = %d\n", m_nConnectCnt);
	m_pECServer->SetStatusAllClients(e_connected, TRUE);

	if( !OnChangeClientCount() ){
		m_bNowConnect = FALSE;
		if( reconFlg == e_emp_connect ){
			ECMessageBox(IDS_ERR_STRING0015);
			if( m_bEasyMode )
				ChangeUIMode(UIMODE_PROJLIST);
			else
				ChangeUIMode(UIMODE_IPCONNECT);
		}
		m_bEMPConnecting = FALSE;
		return FALSE;
	}


	m_bEMPConnecting = FALSE;
	return TRUE;
}
		


BOOL
CEP_NSSDlg::VNeSConnect(int nClientCount)
{
	eclog.Print(LL_STATE, "Enter VNeSConnect Function. Param:nClientCount=%d\n",nClientCount);

	if( !m_pECServer ) return FALSE;

	
	CEVStream evStrm;
	for(int i=0; i<nClientCount; i++){
		CECClientThread *ect = m_pECServer->GetClientThread(i);
		if(ect){
			evStrm.Add(ect->GetIPAddress(),0);
		}else{


			eclog.Print(LL_ERROR, "Failed to get client thread.\n");
			return FALSE;

		}
	}


	
	
	






	

	evStrm.SetEncryption(m_bUseEnc);
	eclog.Print(LL_STATE, "Set UseEncryption flag to VNeS Server.value=%d",m_bUseEnc);


	
	unsigned char pnEncPass[ECON_ENCRYPTION_MAXLEN];
	CPNEnc pnEnc;
	pnEnc.PNEnc(m_cEncPassword, pnEncPass, ECON_ENCRYPTION_MAXLEN);
	evStrm.SetEncKey(pnEncPass);


#ifdef _DEBUG 
	
	eclog.Print(LL_STATE, "Set Encryption key to VNeS Server.encryption key\n Key =");
	for(int k=0; k<ECON_ENCRYPTION_MAXLEN; k++)
		eclog.Print(LL_STATE, "%02x -> %02x ", m_cEncPassword[k], pnEncPass[k]);
	eclog.Print(LL_STATE, "\n");
	
#endif


	
	evStrm.SetSvrAddr(m_ulSvrIPAddr);
	eclog.Print(LL_STATE, "Set Server Address to evstream.\n");

	
	if( !m_VNeSLib.Connect(evStrm) ){
		eclog.Print(LL_ERROR, "!!! Failed to connect VNeS.\n");
		return FALSE;
	}
	eclog.Print(LL_STATE, "Success to connect VNeS.\n");

	eclog.Print(LL_STATE, "Exit VNeSConnect Function.\n");
	return TRUE;
}



BOOL
CEP_NSSDlg::OnChangeClientCount()
{
	
	m_cbSelProj.ResetContent();
	for(int i=0; i<m_nConnectCnt; i++){
		CECClientThread *ect = m_pECServer->GetClientThread(i);
		if(!ect) return FALSE;
		
		int index = m_cbSelProj.AddString(ect->GetProjName());
		m_cbSelProj.ResizeWidth(ect->GetProjName());
		m_cbSelProj.SetItemDataPtr(index, ect);
	}
	
	
	m_cbSelProj.SetCurSel(0);

	CECClientThread *ect = (CECClientThread*)m_cbSelProj.GetItemDataPtr(0);
	if( !ect || (int)ect == -1 ) return FALSE;


	memcpy(m_cVPSelectClient, ect->GetUniqInfo(), ECON_UNIQINFO_LENGTH);

	ChangeUIMode(m_nUIMode);

	return TRUE;
}



void
CEP_NSSDlg::TryReconnect()
{
	eclog.Print(LL_STATE, "Enter TryReconnect Function.\n");

	
	CWaitCursor wait;

	
	m_nIndiCounter = 0;

	
	this->RedrawWindow();

	
	if( m_pECServer )
		m_pECServer->ClearThreadList();


	
	int	 nRetryCnt = 0;
	BOOL bKwdCancel = FALSE;
	while( nRetryCnt++ < ECON_RECONNECT_RETRYCNT ){
		eclog.Print(LL_STATE, "trying to reconnect client. try count = %d\n", nRetryCnt);

		
		if( EMPConnect(e_emp_error) ) break;

		
		if( m_pECServer ){
			if(	m_pECServer->GetEconCommand()->GetRecordNum()==0 ){
				bKwdCancel = TRUE;
				break;
			}
		}

		Sleep(ECON_RECONNECT_RETRYTIME);
	}

	
	if( nRetryCnt > ECON_RECONNECT_RETRYCNT || bKwdCancel){
		eclog.Print(LL_ERROR, "!!! Failed to reconnect client\n");
		ECMessageBox(IDS_ERR_STRING0007);
		OnBtnDisConnect();
	}

	eclog.Print(LL_STATE, "Exit TryReconnect Function.\n");
}







void
CEP_NSSDlg::OnCloseupCmprojlist()
{
	if( !m_pECServer ) return;
	
	memset(m_cVPSelectClient, 0, ECON_UNIQINFO_LENGTH);

	
	int index = m_cbSelProj.GetCurSel();
	if( index == CB_ERR ){
		ECMessageBox(IDS_ERR_STRING0024);
		return;
	}

	
	CECClientThread *ect = (CECClientThread*)m_cbSelProj.GetItemDataPtr(index);
	if( !ect || (int)ect == -1){
		ECMessageBox(IDS_ERR_STRING0024);
		return;
	}

	
	memcpy(m_cVPSelectClient, ect->GetUniqInfo(), ECON_UNIQINFO_LENGTH);
}



void
CEP_NSSDlg::GetResolutionInfo(SCRINFO &scrinf)
{
	HDC hDC;
	hDC = ::GetDC(0);
	scrinf.nScrWid = ::GetDeviceCaps(hDC, HORZRES);
	scrinf.nScrHei = ::GetDeviceCaps(hDC, VERTRES);
	scrinf.nScrBPP = ::GetDeviceCaps(hDC, BITSPIXEL);
	
	::ReleaseDC(0, hDC);
}



void
CEP_NSSDlg::ChangeLAN()
{
	
	if( !(m_nUIMode == UIMODE_PROJLIST || m_nUIMode == UIMODE_IPCONNECT) )
		return;

	
	CWaitCursor wait;


	












	



















	
	if( m_pECServer )
		delete m_pECServer;

	m_pECServer = new CECServer(this->m_hWnd, m_ulSvrIPAddr, ((CEP_NSSApp*)AfxGetApp())->m_nPort);
	if( !m_pECServer ){
		eclog.Print(LL_ERROR, "Failed to Create CECServer Object.\n");
		ECMessageBox(IDS_ERR_STRING0016);
		EndDialog(IDCANCEL);
		return;
	}
	m_pECServer->StartListen();

	
	if( m_pECPing ){

		delete m_pECPing;
		m_pECPing = NULL;
	}

	m_pECPing = new CECPing();
	if( !m_pECPing ){
		eclog.Print(LL_ERROR, "Failed to create 'CECPing' Object.\n");
		ECMessageBox(IDS_ERR_STRING0016);
		EndDialog(IDCANCEL);
		return;
	}

	if( !m_pECPing->Init(m_ulSvrIPAddr, m_ulSvrSubnet, m_ulSvrGateway)){
		eclog.Print(LL_ERROR, "Failed to Initialize 'CECPing' Object.\n");
		delete m_pECPing;
		m_pECPing = NULL;
		ECMessageBox(IDS_ERR_STRING0016);
		EndDialog(IDCANCEL);
		return;
	}

	
	if( m_nUIMode == UIMODE_PROJLIST ){
		
		PostMessage(WM_TIMER, ECON_TIMEREVENT_SEARCHTIMER, NULL);
		ChangeUIMode(UIMODE_PROJLIST);
	}else{
		ChangeUIMode(UIMODE_IPCONNECT);
	}
}

BOOL CEP_NSSDlg::PreTranslateMessage(MSG* pMsg) 
{
	
	if( pMsg->message == WM_KEYDOWN){
		if( pMsg->wParam == 0x1B ){
			return TRUE;
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CEP_NSSDlg::OnSysCommand(UINT nID, LPARAM lParam) 
{

	

	if( nID == SC_KEYMENU) return;


	CDialog::OnSysCommand(nID, lParam);
}

BOOL CEP_NSSDlg::OnQueryEndSession() 
{
	eclog.Print(LL_STATE, "Enter OnQueryEndSession Function.\n");

	if (!CDialog::OnQueryEndSession())
		return FALSE;
	
	eclog.Print(LL_STATE, "Call OnDestroy Function.\n");
	
	PostQuitMessage(0);
	return TRUE;
}

BOOL CEP_NSSDlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	if( m_nWaitCursor ){
		HCURSOR hCur = LoadCursor(NULL, IDC_WAIT);
		SetCursor(hCur);
		return TRUE;
	}
	return CDialog::OnSetCursor(pWnd, nHitTest, message);
}



HRGN
CEP_NSSDlg::GetNSWindowRgn(int nBitmapID)
{
	if( !m_plczRes || !nBitmapID)
		return NULL;

	LCBITMAPDATA *plcBmp =m_plczRes->GetBmpData(nBitmapID);
	if( !plcBmp )
		return NULL;

	int rgWid = plcBmp->lcBmp.binf.biWidth;
	int rgHei = plcBmp->lcBmp.binf.biHeight;
	HRGN hRgn = ::CreateRectRgn(0, 0, rgWid, rgHei);
	if( !hRgn )
		return NULL;

	for(int j=0; j<3; j++){
		HRGN tlMs, trMs, blMs, brMs;
		tlMs = CreateRectRgn(0, j, 1+(j==0)*2, j+1);
		trMs = CreateRectRgn(rgWid-(1+(j==0)*2), j, rgWid, j+1);
		blMs = CreateRectRgn(0, rgHei-j-1, 1+(j==0)*2, rgHei-j);
		brMs = CreateRectRgn(rgWid-(1+(j==0)*2), rgHei-j-1, rgWid, rgHei-j);
		
		if( !tlMs || !trMs || !blMs || !brMs)
			return NULL;

		if( CombineRgn(hRgn, hRgn, tlMs, RGN_XOR) == ERROR ||
			CombineRgn(hRgn, hRgn, trMs, RGN_XOR) == ERROR ||
			CombineRgn(hRgn, hRgn, blMs, RGN_XOR) == ERROR ||
			CombineRgn(hRgn, hRgn, brMs, RGN_XOR) == ERROR ){
			DeleteObject(tlMs);
			DeleteObject(trMs);
			DeleteObject(blMs);
			DeleteObject(brMs);
			return NULL;
		}

		DeleteObject(tlMs);
		DeleteObject(trMs);
		DeleteObject(blMs);
		DeleteObject(brMs);
	}
	return hRgn;
}


LRESULT
CEP_NSSDlg::OnECBtnCommand(WPARAM wParam, LPARAM lParam)
{
	eclog.Print(LL_STATE, "Enter OnECBtnCommand Function.\n");

	CECClientThread *pClient = NULL;
	if( !m_bNowConnect || m_bReConnecting )
		goto SendRpKeyCmdErr;

	
	if( wParam == REPEAT_WPARAM_DOWN ){
		eclog.Print(LL_STATE, "Repeart Button Dowm REPEAT_WPARAM_DOWN.\n");

		if( m_pEscvp == NULL ){
			m_pEscvp = new CESCVPBase();
			if( !m_pEscvp )
				goto SendRpKeyCmdErr;

			
			pClient = m_pECServer->GetClientThread(m_cVPSelectClient);
			if( !pClient )
				goto SendRpKeyCmdErr;

			
			if( !m_pEscvp->Open(pClient->GetIPAddress(), m_ulSvrIPAddr, m_usESCVPPort))
				goto SendRpKeyCmdErr;
		}
	}
	
	else if( wParam == REPEAT_WPARAM_HOLD ){
		eclog.Print(LL_STATE, "Repeart Button hold REPEAT_WPARAM_DOWN.\n");

		
		if( m_pEscvp ){
			char cmd = 0;
			if( lParam == ECON_BTN_EZOOMUP )
				cmd = VP21CMD_KEY_EZMUP;
			else if( lParam == ECON_BTN_EZOOMDOWN )
				cmd = VP21CMD_KEY_EZMDOWN;
			else if( lParam == ECON_BTN_EZOOMLEFT )
				cmd = VP21CMD_KEY_EZMLEFT;
			else if( lParam == ECON_BTN_EZOOMRIGHT )
				cmd = VP21CMD_KEY_EZMRIGHT;
			else
				return 0;

			eclog.Print(LL_STATE, "Call SetKeyCommand Function.\n");
			for(int i=0; i<ECON_REPEAT_DIST; i++){
				if( !m_pEscvp->SetKeyCommand(cmd) )
					goto SendRpKeyCmdErr;
				Sleep(1);
			}
			eclog.Print(LL_STATE, "Success SetKeyCommand Function.\n");
		}
	}
	
	else if( wParam == REPEAT_WPARAM_UP ){
		eclog.Print(LL_STATE, "Repeart Button up REPEAT_WPARAM_DOWN.\n");
		if( m_pEscvp ){
			m_pEscvp->Close();
			delete m_pEscvp;
			m_pEscvp = NULL;
		}
	}	

	return 0;
		
SendRpKeyCmdErr:
	eclog.Print(LL_STATE, "SendRpKeyCmdErr.\n");
	CECButton *pECBtn = (CECButton*)GetDlgItem(lParam);
	if( pECBtn )
		pECBtn->KillRepeatTimer();

	if( m_pEscvp ){
		eclog.Print(LL_STATE, "delete m_pEscvp2.\n");
		m_pEscvp->Close();
		delete m_pEscvp;
		m_pEscvp = NULL;
	}

	if( wParam == REPEAT_WPARAM_DOWN )
		ECMessageBox(IDS_ERR_STRING0024);
	return 0;
}


void
CEP_NSSDlg::OnBtnMiniHelp()
{
	switch(m_nGuideMesStatus){
		case ECDLG_MESSTAT_PROJFOUND:
			AfxGetApp()->WinHelp(Topic_1, HELP_CONTEXT);
			break;
		case ECDLG_MESSTAT_NOTFOUND:
			AfxGetApp()->WinHelp(Topic_52, HELP_CONTEXT);
			break;
		case ECDLG_MESSTAT_IPCONNECT:
		case ECDLG_MESSTAT_NOIPADDRESS:
			AfxGetApp()->WinHelp(Topic_41, HELP_CONTEXT);
			break;
		default:
			break;
	}
}
