/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



#if !defined(AFX_EP_NSSDLG_H__74161486_633C_11D6_BC84_002018A23969__INCLUDED_)
#define AFX_EP_NSSDLG_H__74161486_633C_11D6_BC84_002018A23969__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif 




#include "..\\Common\\ECButton.h"
#include "..\\Common\\ProjListBox.h"
#include "DialogsMng.h"


#include "..\\Common\\ECSearchClient.h"
#include "ECPing.h"
#include "ECServer.h"
#include "VNeSLib.h"



#include "..\\Common\\ECComboBox.h"
#include "..\\Common\\IPAddress.h"


#include "ESCVPBase.h" 

#include "SplashWnd.h"


#define ECDLG_NOERR					 0
#define ECDLG_ERR_NOTALLCON			-1
#define ECDLG_ERR_NORESPONSE		-2
#define ECDLG_ERR_MEMALLOC			-3
#define ECDLG_ERR_VNESCON			-4
#define ECDLG_ERR_INIT				-5
#define ECDLG_ERR_LOADVNES			-6
#define ECDLG_ERR_OTHER				-99

#define ECDLG_ERR_ALREADYEXISTS		-7
#define ECDLG_ERR_FAILED			-8


#define ECDLG_MESSTAT_CLEAR			0
#define ECDLG_MESSTAT_PROJFOUND		1
#define ECDLG_MESSTAT_NOTFOUND		2
#define ECDLG_MESSTAT_IPCONNECT		3
#define ECDLG_MESSTAT_CONNECTING	4


#define ECDLG_MESSTAT_NOIPADDRESS	5


enum _e_ReconnectFlag {
	e_emp_connect				=	1,			
	e_emp_resolution			=	2,			
	e_emp_error					=	3			
};


typedef struct {
	int nScrWid;
	int nScrHei;
	int nScrBPP;
} SCRINFO;


typedef struct {
	char sProjURL[MAX_PATH];
	char sErrorMessage[LOCALSTR_MAXLEN];
} URLINFO;




class CEP_NSSDlg : public CDialog
{

public:
	CEP_NSSDlg(	CEMPLocalize *plczRes,
					CWnd* pParent = NULL);	
											
	char			m_sIPConAddr[ECON_IPADDRSTR_MAXLEN];
	BOOL			m_bUseIPConnect;
	BOOL			m_bUseEnc;
	unsigned short	m_usESCVPPort;				



	TCHAR			m_sGroupName[ECON_GROUPNAME_MAXLEN + 1];

	BOOL			m_bUseGroupList;			



	UINT		m_maxProjectors;			
	UINT		m_resolutionMaxWidth;		
	UINT		m_resolutionMaxHeight;		


	void		OnOK(void){};


	
	enum { IDD = IDD_EMPCONTROL_DIALOG };
	CProjListBox	m_IPProjListBox;
	CECComboBox	m_cbSelProj;
	CProjListBox	m_ProjListBox;
	

	
	
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	
	


protected:
	HICON m_hIcon;
	CIPAddress	m_IPAddress;

	
	
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg UINT OnNcHitTest(CPoint point);
	afx_msg void OnBtnExit();
	afx_msg void OnBtnHelp();
	afx_msg void OnBtnList();
	afx_msg void OnBtnURL();
	afx_msg void OnBtnPause();
	afx_msg void OnBtnAVMute();
	afx_msg void OnBtnEZoom();
	afx_msg void OnBtnKihon();
	afx_msg void OnBtnVideo();
	afx_msg void OnBtnPC();
	afx_msg void OnBtnConnect();
	afx_msg void OnBtnDisConnect();
	afx_msg void OnBtnIPCon();
	afx_msg void OnBtnEasyCon();
	afx_msg void OnBtnOption();
	afx_msg void OnBtnSearch();
	afx_msg void OnBtnMin();
	afx_msg void OnBtnKakuClose();
	afx_msg void OnBtnEZoomMinus();
	afx_msg void OnBtnEZoomPlus();
	afx_msg void OnBtnEZoomCancel();




	afx_msg void OnBtnBrightMinus();
	afx_msg void OnBtnBrightPlus();
	afx_msg void OnBtnContrastMinus();
	afx_msg void OnBtnContrastPlus();
	afx_msg void OnBtnKeystoneMinus();
	afx_msg void OnBtnKeystonePlus();
	afx_msg void OnBtnColorMode();
	afx_msg void OnBtnMiniHelp();
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnCloseupCmprojlist();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg BOOL OnQueryEndSession();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	
	DECLARE_MESSAGE_MAP()

private:
	CVNeSLib			m_VNeSLib;					
	CECPing*			m_pECPing;					
	CPtrList			m_lstButton;				
	CPtrList			m_lstFont;					
	CEMPLocalize*		m_plczRes;					

	int					m_nUIMode;					
	int					m_nBackBmpID;				
	BOOL				m_bNowConnect;				
	int					m_nConnectCnt;				
	CFont				m_dlgFont;					
	int					m_nBtnTop;					

	int					m_nAdpIndex;				
	ULONG				m_nAdpIPAddress;
	CECSearchClient*	m_pECSrchClt;				
	BOOL				m_bExistProj;				
	CECServer*			m_pECServer;				
	RECT				m_recIndi;					
	int					m_nIndiCounter;				

	BOOL				m_bReConnecting;			

	ULONG				m_ulSvrIPAddr;				
	ULONG				m_ulSvrSubnet;				
	ULONG				m_ulSvrGateway;				
	unsigned char		m_cVPSelectClient[ECON_UNIQINFO_LENGTH];
	unsigned char		m_cEncPassword[ECON_ENCRYPTION_MAXLEN]; 
	ULONG				m_nVNeSSendDataCnt;		
	BOOL				m_bEasyMode;				

	BOOL				m_bEMPConnecting;			
	URLINFO				m_URLInfo;					

	UINT				m_nGuideMesStatus;			


	
	UINT				m_nSearchTimer;				
	UINT				m_nResultTimer;				
	UINT				m_nIndicateTimer;			
	UINT				m_nExpandWindowTimer;		
	UINT				m_nSearchResultCounter;		

	UINT				m_nHelpArrowTimer;			




													

	BOOL				m_nFirstSearch;				
	BOOL				m_nWaitCursor;				
	BOOL				m_bExpandWindow;			
	BOOL				m_bChangeScrSaveState;		
	rfbServerInitMsg	m_vnesInitData;				
	CESCVPBase*			m_pEscvp;					

	BOOL				m_bHelpArrow;				



	HRGN				GetNSWindowRgn(int nBitmapID);


	CDialogsMng			m_cDlgMng;					


	CPtrList			m_lstStatic;


	CLIENTINFO			m_ConnectCInfo[ECON_SELECTPROJ_MAXNUM_LIMIT];
	UINT				m_nConnectCInfo;


	BOOL				m_bNoSupportUXGA;


	BOOL				m_bDisconnecting;


	CSplashWnd*			m_pSplash;

	CWnd				m_dmyWnd;
	BOOL				InitEP_NSSDialog(void);
	void				ChangeUIMode(int nUIMode);
	void				ClearEMPProcess(void);
	BOOL				ToolHint( UINT id, NMHDR * pTTTStruct, LRESULT * pResult );
	void				SetItemStat(int nResID, BOOL bVisible=TRUE, BOOL bEnable=TRUE,POINT* pPoi=NULL);
	BOOL				SetCtrlStat(int nDlgItemID, int nResID, CFont* pFon);
	HBRUSH				OnCtlColorStatic(WPARAM wParam, LPARAM lParam);
	LRESULT				OnPowerBroadcast(WPARAM wParam, LPARAM lParam);
	int					ECMessageBox(UINT resID);
	BOOL				GetAdaptersInfo(void);
	BOOL				CheckAdaptersInfo(void);
	void				UpdateProjList(void);
	BOOL				CheckProjIPAddr(ULONG addr);
	LRESULT				OnESCCommand(WPARAM wParam, LPARAM lParam);
	LRESULT				OnECMCommand(WPARAM wParam, LPARAM lParam);
	LRESULT				OnVNeSCommand(WPARAM wParam, LPARAM lParam);
	LRESULT				OnIPProjListMes(WPARAM wParam, LPARAM lParam);
	BOOL				EMPConnect(int reconFlg);
	BOOL				VNeSConnect(int nClientCount);
	void				TryReconnect(void);


	BOOL				OnChangeClientCount(void);
	void				GetResolutionInfo(SCRINFO &scrinf);
	void				ChangeLAN(void);


	void				SendVPKeyCmd(char param); 
	void				SetControlsState(BOOL bAllDisable);
	void				CreateDlgRgn(RECT& rec);
	void				GuideMessage(UINT nFlag);

	LRESULT				OnECBtnCommand(WPARAM wParam, LPARAM lParam);	
	int					AddIPProjItem(ULONG ulIPAddr, int nIndexIns = -1); 
};




#endif 
