/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "EVStream.h"

CEVStream::CEVStream()
{
	m_nIPCount = 0;
	Clear();
}

CEVStream::~CEVStream()
{
	Clear();
}


	
void CEVStream::Clear()
{
	for(int i=0; i<m_nIPCount; i++){
		delete[] m_IPList[i];
	}
	m_baEncKey[0] = 0;
	m_ulSvrAddr = 0;
	m_nIPCount = 0;
	m_bEnc = FALSE;
}



BOOL
CEVStream::Add(ULONG ulAddr, int connect)
{
	if(	m_nIPCount >= EVS_CLIENTCOUNT_MAX -1 )
		return FALSE;

	EVCLIENTINFO *buf = new EVCLIENTINFO;
	if( !buf ) return FALSE;

	buf->ulAddr = ulAddr;
	buf->result = connect;

	m_IPList[m_nIPCount] = buf;
	m_nIPCount++;

	return TRUE;
}



ULONG
CEVStream::GetIPAddress(int index)
{
	if(index < 0 || index >= m_nIPCount) 
		return NULL;

	return ((EVCLIENTINFO *)m_IPList[index])->ulAddr;
}



BOOL
CEVStream::IsConnected(int index)
{
	int result = 0;
	if(index < 0 || index >= m_nIPCount)
		return FALSE;

	result = ((EVCLIENTINFO *)m_IPList[index])->result;
	
	switch(result)
	{
	case connected:
		return TRUE;
		break;
	default: 
		return FALSE;
	}
}



BOOL	
CEVStream::SetResult(int index, int value)
{
	if(index < 0 || index >= m_nIPCount)
		return FALSE;

	if(value < 0 || value > 2)
		return FALSE;

	
	((EVCLIENTINFO *)m_IPList[index])->result = value;

	return TRUE;
}
