/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#if !defined(__EVSTREAM_H__)
#define __EVSTREAM_H__

#if _MSC_VER > 1000
#pragma once
#endif 

#include "windows.h"
#include "stdio.h"
#include "..\\common\\econproto.h"

#define EVS_CLIENTCOUNT_MAX				256				
#define EVS_IPADDRESS_LENGTH			16				
#define EVS_ENCKEY_LENGTH				8				

enum result {
	initialized		= 0,
	connected		= 1,
	failed			= 2
};

class CEVStream  
{
public:
	
	CEVStream();
	virtual ~CEVStream();

	void	Clear(void);								
	BOOL	Add(ULONG ulAddr, int connect = 0);			
	int		GetCount(void){ return m_nIPCount; }		
	BOOL	IsConnected(int index);						
	BOOL	SetResult(int index, int value);			

	ULONG	GetIPAddress(int index);					
	BOOL	GetEncryption(void){ return m_bEnc; }		
	void	SetEncryption(BOOL bEnc){ m_bEnc = bEnc; }	
	ULONG	GetSvrAddr(void){ return m_ulSvrAddr; }		
	void	SetSvrAddr(ULONG addr){ m_ulSvrAddr = addr;}
	BYTE*	GetEncKey(void){ return m_baEncKey; }		
	void	SetEncKey(BYTE* pEnckey)
			{ memcpy(m_baEncKey, pEnckey, EVS_ENCKEY_LENGTH); }	

	rfbPixelFormat	GetClientFormat(){ return m_ClientPixFormat; }
	void	SetClientFormat(rfbPixelFormat &format){ m_ClientPixFormat = format; }

private:
	int			m_nIPCount;								
	BOOL		m_bEnc;									
	ULONG		m_ulSvrAddr;							
	BYTE		m_baEncKey[EVS_ENCKEY_LENGTH];			

	typedef struct {
	ULONG	ulAddr;										
	int  result;										
														
														
														
	}EVCLIENTINFO;

	EVCLIENTINFO*	m_IPList[EVS_CLIENTCOUNT_MAX];

	rfbPixelFormat	m_ClientPixFormat;					

};

#endif
