/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



#include "stdafx.h"
#include "EP_NSS.h"
#include "KeywordDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif




CKeywordDlg::CKeywordDlg(CEMPLocalize *plczRes, char *sProjName, CWnd* pParent )
	: CECDialog(CKeywordDlg::IDD, plczRes, pParent)
{
	
	m_sKeyword = _T("");
	
	lstrcpy(m_sProjName, sProjName);
}

void CKeywordDlg::DoDataExchange(CDataExchange* pDX)
{
	CECDialog::DoDataExchange(pDX);
	
	DDX_Text(pDX, IDC_KEYWORD, m_sKeyword);
	DDV_MaxChars(pDX, m_sKeyword, 4);
	
}


BEGIN_MESSAGE_MAP(CKeywordDlg, CECDialog)
	
	ON_BN_CLICKED(ECON_BTN_KEYWORDOK, OnBtnOk)
	ON_BN_CLICKED(ECON_BTN_KEYWORDCANCEL, OnBtnCancel)
	ON_BN_CLICKED(ECON_BTN_KEYWORDCLOSEBOX, OnBtnCancel)
	ON_BN_CLICKED(ECON_BTN_KEYWORDHLP, OnBtnMiniHlp)
	ON_WM_SHOWWINDOW()
	
END_MESSAGE_MAP()


BOOL CKeywordDlg::OnInitDialog() 
{
	CECDialog::OnInitDialog();

	SetCtrlState(IDC_KEYWORD, ECON_EDT_KEYWORD);
	SetCtrlState(IDC_PROJNAME, ECON_EDT_PROJNAME);
	CEdit *kEdit = (CEdit*)this->GetDlgItem(IDC_KEYWORD);
	if( kEdit )
		kEdit->SetMargins(0,0);


	SetTabOrder();


	return TRUE;  
	              
}


void
CKeywordDlg::OnOK()
{
	UpdateData(TRUE);
	lstrcpy(m_keyword, (LPCTSTR)m_sKeyword);
	if( strlen(m_keyword) == 0 ){
		




		MessageBox(GetLocal()->GetString(IDS_WRN_STRING0006), ECON_PRODUCTNAME, MB_OK|MB_ICONWARNING);


		
		CEdit *ed = (CEdit *)GetDlgItem(IDC_KEYWORD);
		if( ed ) ed->SetFocus();
		
		return;
	}
	CECDialog::OnOK();
}


void CKeywordDlg::OnBtnOk() 
{
	OnOK();
}


void CKeywordDlg::OnBtnCancel()
{
	EndDialog(IDCANCEL);
}


void CKeywordDlg::OnBtnMiniHlp()
{
	AfxGetApp()->WinHelp(Topic_25, HELP_CONTEXT);
}


void CKeywordDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CECDialog::OnShowWindow(bShow, nStatus);
	
	
	CStatic *stWnd;
	stWnd = (CStatic*)GetDlgItem(IDC_PROJNAME);
	if( stWnd )
		stWnd->SetWindowText(m_sProjName);

	
	CEdit *ed = (CEdit *)GetDlgItem(IDC_KEYWORD);
	if( ed ) ed->SetFocus();	
}
