/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



#include "stdafx.h"
#include "EP_NSS.h"
#include "ListenSock.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif




CListenSock::CListenSock()
{
	m_pServer = NULL;
	m_pThread = NULL;
}

CListenSock::~CListenSock()
{
}



#if 0
BEGIN_MESSAGE_MAP(CListenSock, CAsyncSocket)
	
	
END_MESSAGE_MAP()
#endif	




void CListenSock::OnAccept(int nErrorCode) 
{
	listenlog.Print(LL_STATE, "Enter OnAccept Function. errorcode=%d\n",nErrorCode);

	if( nErrorCode == WSAENETDOWN || !m_pServer || !m_pThread){
		listenlog.Print(LL_ERROR, "!!!Filed to check the object pointers.\n");
		if( m_pThread )
			m_pThread->AddClient(NULL, nErrorCode);
		return;
	}
	
	
	CAsyncSocket sock;
	if( !Accept(sock) ){
		if( GetLastError() != WSAEWOULDBLOCK )
			m_pThread->AddClient(NULL,LISOCK_ERR_ACCEPT);
		return;
	}			
	listenlog.Print(LL_STATE, "Accept socket.\n");

	
	CECClientThread* pThread = NULL;

	pThread = new CECClientThread(	m_pServer->m_hParentWnd, 
									m_pServer->m_ilSvrAddr,
									m_pServer->m_nPort);
	listenlog.Print(LL_STATE, "make new Client Thread.\n");

	if( !pThread ){
		m_pThread->AddClient(NULL,LISOCK_ERR_ACCEPT);
		return;
	}else
	{
		if( !pThread->CreateThread(CREATE_SUSPENDED) ){
			delete pThread;
			m_pThread->AddClient(NULL,LISOCK_ERR_ACCEPT);
			return;
		}
		listenlog.Print(LL_STATE, "Create Client Thread.\n");

		pThread->m_hSocket = sock.Detach();
		listenlog.Print(LL_STATE, "Detach socket.\n");

		
		pThread->ResumeThread();
		listenlog.Print(LL_STATE, "Start Cient Thread.\n");

		
		m_pThread->AddClient(pThread, 0);
		listenlog.Print(LL_STATE, "Call AddClient of ListenThread Class.\n");
	}

	CAsyncSocket::OnAccept(nErrorCode);
	listenlog.Print(LL_STATE, "Exit OnAccept Function.\n");
}
