/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#if !defined(AFX_LISTEN_H__97102EEB_F79F_48DD_9CF3_513D27FC2366__INCLUDED_)
#define AFX_LISTEN_H__97102EEB_F79F_48DD_9CF3_513D27FC2366__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif 

#include "ListenSock.h"

#define ECM_LISTENERR		WM_USER+2023
#define WM_TERM_THREAD      WM_USER+2024
#define EVENTKILL_NAME		"SEVENT_LISKILL"
#define EVENTDEAD_NAME		"SEVENT_LISDEAD"




class CListenThread : public CWinThread
{

	DECLARE_DYNAMIC(CListenThread)

public:
	CListenThread(HWND hWnd, CECServer* pServer);
	virtual	~CListenThread();

	HANDLE				m_hEventKill;
	HANDLE				m_hEventDead;
	CRITICAL_SECTION	m_csLock;

	void			KillThread();			

	HWND				m_hWnd;
	UINT				m_nPort;
	CListenSock*		m_pSock;
	CECServer*			m_pServer;
	BOOL				m_bKill;
	CPtrList			m_ClientList;
	
	void				AddClient(CECClientThread* pThread, int nErrorCode);
	int					GetClientCount(void);
	void				ClearClient(void);
	CECClientThread*	GetClient(int index);
	
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	

protected:
	virtual void Delete();


	
	
	afx_msg void OnTermThread(UINT, LONG);
	DECLARE_MESSAGE_MAP()
};



#endif
