/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/






#include "PNEnc.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif





CPNEnc::CPNEnc()
{

}

CPNEnc::~CPNEnc()
{

}


int
CPNEnc::PNEnc(unsigned char *pneIn, unsigned char *pneOut, int nPneOutSize)
{
	if( nPneOutSize < PNENC_OUTPUT_LEN )
		return PNENC_FAIL;

	unsigned int mregIn, mregOut, hiByte, loByte;
	for(int i=0; i<4; i++){
		hiByte = (unsigned int)(pneIn[i*2]);
		loByte = (unsigned int)(pneIn[i*2+1]);
		mregIn = hiByte | loByte << 8;
		
		mregOut = mrndmake(mregIn);

		pneOut[i*2] = (unsigned char)(mregOut & 0x0FF);
		pneOut[i*2+1] = (unsigned char)((mregOut >> 8) & 0x0FF);
	}

	return PNENC_SUCCESS;
}



unsigned int
CPNEnc::mrndmake(unsigned int mregIn)
{
	unsigned int mreg;
	unsigned int mregFunc;
	unsigned int mregOrder;
	unsigned int mregShift;
	unsigned int mregOut;
	unsigned int i,j,hit,lowBit;
	
	mreg = mregIn;
	mregFunc = 147457;
	mregShift = 3723;
	mregOut = 0;
	mregOrder = 0; 

	for( i = 0; i < 32; i++){
		if( mregFunc >> i == 0x01){
			mregOrder = i;
			break;
		}
	}
	for(j = 0; j < ( mregIn & 0x0fff) + mregShift; j++){
		hit = 0;
		lowBit = mreg &( mregFunc >> 1);
		for( i = 0; i < mregOrder; i++) {
			hit ^= ( lowBit >> i);
		}
		lowBit = hit & 0x01;
		mregOut = mregOut << 1;
		mregOut += (mreg >> 16) & 0x01;
		mreg = ( mreg << 1) | lowBit;
	}
	return( mregOut & 0x0ffff);
}