/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



#include "stdafx.h"
#include "EP_NSS.h"
#include "SplashWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif





CSplashWnd::CSplashWnd(CEMPLocalize* pLocal, CWnd* pParent )
	: CECDialog(CSplashWnd::IDD, pLocal, pParent)
{
	m_bMouseDown = FALSE;
	
		
	
}


void CSplashWnd::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	
		
	
}


BEGIN_MESSAGE_MAP(CSplashWnd, CECDialog)
	
	ON_WM_LBUTTONDOWN()
	ON_WM_TIMER()
	ON_WM_SHOWWINDOW()
	ON_WM_LBUTTONUP()
	
END_MESSAGE_MAP()



void CSplashWnd::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CECDialog::OnShowWindow(bShow, nStatus);

	
	TCHAR	sMsg1[LOCALSTR_MAXLEN];
	TCHAR	sMsg2[LOCALSTR_MAXLEN];

	if( FindWindow(SPW_PPCLASSNAME_95, NULL) ||
		FindWindow(SPW_PPCLASSNAME_96, NULL) ||
		FindWindow(SPW_PPCLASSNAME_97, NULL) ||
		FindWindow(SPW_PPCLASSNAME_2000, NULL) ||
		FindWindow(SPW_PPCLASSNAME_2002, NULL) ||
		FindWindow(SPW_PPCLASSNAME_2003, NULL) )
	{
		lstrcpy(sMsg1, GetLocal()->GetString(IDS_RES_STRING0060));
		lstrcpy(sMsg2, GetLocal()->GetString(IDS_RES_STRING0061));
	}else
	{
		lstrcpy(sMsg1, "");
		lstrcpy(sMsg2, "");
	}

	CWnd *pMsgLine1, *pMsgLine2;
	pMsgLine1 = GetDlgItem(ECON_STX_SPLASHMES1);
	pMsgLine2 = GetDlgItem(ECON_STX_SPLASHMES2);
	if( pMsgLine1 && pMsgLine2 ){
		pMsgLine1->SetWindowText(sMsg1);
		pMsgLine2->SetWindowText(sMsg2);
	}
	
	
	m_nEndTimer = SetTimer(SPLASH_ENDTIMER_ID, ECON_SPLASH_TIME, NULL);

	
	SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);
}


void CSplashWnd::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_bMouseDown = TRUE;

	CDialog::OnLButtonDown(nFlags, point);
}


void CSplashWnd::OnLButtonUp(UINT nFlags, CPoint point) 
{
	
	if( m_bMouseDown ){
		
		DestroyWindow();
	}
	m_bMouseDown = FALSE;
	CECDialog::OnLButtonUp(nFlags, point);
}


void CSplashWnd::OnTimer(UINT nIDEvent) 
{
	if( m_nEndTimer ){
		KillTimer(m_nEndTimer);
		m_nEndTimer = NULL;
	}

	
	DestroyWindow();

	CDialog::OnTimer(nIDEvent);
}