/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#ifndef __VNESLIB_H__
#define __VNESLIB_H__

#include <windows.h>
#include "VNeS.h"

class CVNeSLib;


typedef  BOOL (*PROC_VNeSStart)			(HWND);
typedef  BOOL (*PROC_VNeSStop)			();
typedef  BOOL (*PROC_VNeSConnect)		(CEVStream &);
typedef  BOOL (*PROC_VNeSDisconnect)	();
typedef  BOOL (*PROC_VNeSIsSending)		(DWORD &);
typedef  BOOL (*PROC_VNeSSetSendImage)	(BOOL);
typedef  BOOL (*PROC_VNeSReSendRect)	(DWORD);
typedef  BOOL (*PROC_VNeSGetScrFormat)	(rfbServerInitMsg &);

class CVNeSLib {
public:
	CVNeSLib();
	~CVNeSLib();

	BOOL	LoadLib(char *psAppPath);
	BOOL	FreeLib();


	BOOL	VNeSStart(HWND hWnd);
	BOOL	VNeSStop();
	BOOL	Connect(CEVStream &ConnInfo);
	BOOL	Disconnect();
	BOOL	IsSending(DWORD &dwBytesSent);
	BOOL	SetSendImage(BOOL bPause);
	BOOL	ReSendFullScrRect(DWORD dwID);
	BOOL	GetScreenFormat(rfbServerInitMsg &format);
	BOOL	IsConnecting(void) { return m_bConnecting; }

private:
	HMODULE					m_hLibModule;
	PROC_VNeSStart			m_pfnStartVNeS;
	PROC_VNeSStop			m_pfnStopVNeS;
	PROC_VNeSConnect		m_pfnConnect;
	PROC_VNeSDisconnect		m_pfnDisconnect;
	PROC_VNeSIsSending		m_pfnIsSending;
	PROC_VNeSSetSendImage	m_pfnSetSendImage;
	PROC_VNeSReSendRect		m_pfnReSendRect;
	PROC_VNeSGetScrFormat	m_pfnGetScrFormat;

	BOOL					m_bConnecting;

};

#endif 
