/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/








#ifndef ___LIBKEYINPUT_H___
#define ___LIBKEYINPUT_H___



#define _NS_CONNECTION_		




#define XMDM_DATALEN				128				
#define XMDM1K_DATALEN				1024			
#define XMDMCRC_PACKETLEN			128+5			
#define XMDM1KCRC_PACKETLEN			1024+5			
#define XMDM_ACK					0x06			
#define XMDM_NAK					0x15			
#define XMDM_CAN					0x18			
#define XMDM_SOH					0x01			
#define XMDM_STX					0x02			
#define XMDM_EOT					0x04			
#define XMDM_EOF					0x1A			
#define XMDM_C						0x43			




#define XMDMBUFF_MAXLEN			XMDM1K_DATALEN+1	
#define COMMBUFF_MAXLEN			XMDMBUFF_MAXLEN		
#define ESCVP21_MAXLEN			128					
#define ESCVP21_DELIMITER		0x0D				
#define ESCVP21_DELIMITER_S		"\x0D"				
#define ESCVP21_STATUS_ERR		"ERR"				
#define ESCVP21_STATUS_SUCCESS	':'					
#define ESCVP21_STATUS_SUCCESS_S	":"				
#define COMMAND_FLG				0x01				
#define EVENT_FLG				0x02				
#define LOCALHOST_ADDR		"127.0.0.1"				
#define LKI_RECEIVE_COMMAND_RETRY_CNT	1			




#define LKI_SUCCESS					0	
#define LKI_ERR_FATAL				-1	
#define LKI_ERR_ESCVP21				-2	
#define LKI_ERR_XMODEM				-3	
#define LKI_ERR_CMD_NOT				-4	
#define LKI_ERR_CMD_CODE			-5	
#define LKI_ERR_CMD_NON_DELIMITER	-6	
#define LKI_ERR_CMD_OVERLENGTH		-7	
#define LKI_ERR_CMD_PARAMRANGE		-8	
#define LKI_ALREADY_CONNECT			-9	
#define LKI_TIMEOUT					-10	
#define LKI_DISCONNECT				-11 
#define LKI_ERR_CMD					-12	
#define LKI_ERR_DNETRESPONSE		-13 




#define TRUE			1				
#define FALSE			0 				




#define ESCVP21_CMDHEAD_MAXLEN		15		
#define CMD_CLASS_INT				0x00L	
#define CMD_CLASS_SUP				0x01L	
#define CMD_CLASS_DBG				0x02L	
#define CMD_CLASS_LOC				0x04L	
#define CMD_CLASS_EXT				0x10L	
#define CMD_CLASS_BIN				0x20L	
#define CMD_TO_PW					0x01L	
#define CMD_TO_PWX					0x02L	
#define CMD_TO_KID					0x04L	


#define CMD_NUM_MAX					203		
#define CMD_NULL					""		




#define EV_IMIVENT		0x00000001L		
#define EV_REMOCON		0x00000002L		
#define EV_KEYMAKE		0x00000004L		
#define EV_KEYBREAK		0x00000008L		
#define EV_IMVER		0x00000010L		
#define EV_LANG			0x00000020L		
#define EV_SOURCE		0x00000040L		
#define EV_REVERSE		0x00000080L		
#define EV_NWSET		0x00000100L		
#define EV_NWGET		0x00000200L		




typedef enum tagCOMID{


	cmd_APPINFO = 0,
	cmd_KIDINT,

	cmdPTBL_,
	cmdPTBLVER,
	cmdPTBLVER_,

	cmdPWR,
	cmdPWR_,
	cmdINITALL,
	cmdSPEED,
	cmdSPEED_,
	cmdLAMP_,
	cmdLUMINOUS,
	cmdLUMINOUS_,
	cmdKEY,
	cmdSOURCE,
	cmdSOURCE_,
	cmdMUTE,
	cmdMUTE_,
	cmdFREEZE,
	cmdFREEZE_,
	cmdVOL,
	cmdVOL_,
	cmdTONEH,
	cmdTONEL,
	cmdTONEH_,
	cmdTONEL_,
	cmdAUDIO,
	cmdAUDIO_,
	cmdBRIGHT,
	cmdBRIGHT_,
	cmdBLACK,
	cmdBALCK_,
	cmdCONTRAST,
	cmdCONTRAST_,
	cmdWHITE,
	cmdWHITE_,
	cmdSYNC,
	cmdSYNC_,
	cmdTRACKING,
	cmdTRACKING_,
	cmdSHARP,
	cmdSHARP_,
	cmdHPOS,
	cmdHPOS_,
	cmdVPOS,
	cmdVPOS_,
	cmdHREVERSE,
	cmdHREVERSE_,
	cmdVREVERSE,
	cmdVREVERSE_,
	cmdVKEYSTONE,
	cmdVKEYSTONE_,
	cmdVKEYHEIGHT,
	cmdVKEYHEIGHT_,
	cmdHKEYSTONE,
	cmdHKEYSTONE_,
	cmdZOOM,
	cmdZOOM_,
	cmdFOCUS,
	cmdFOCUS_,
	cmdLENS,
	cmdLENS_,
	cmdCSEL,
	cmdCSEL_,
	cmdRED,
	cmdRED_,
	cmdGREEN,
	cmdGREEN_,
	cmdBLUE,
	cmdBLUE_,
	cmdOFFSETR,
	cmdOFFSETR_,
	cmdOFFSETG,
	cmdOFFSETG_,
	cmdOFFSETB,
	cmdOFFSETB_,
	cmdGAINR,
	cmdGAINR_,
	cmdGAING,
	cmdGAING_,
	cmdGAINB,
	cmdGAINB_,
	cmdGAMMAR,
	cmdGAMMAR_,
	cmdGAMMAG,
	cmdGAMMAG_,
	cmdGAMMAB,
	cmdGAMMAB_,
	cmdDENSITY,
	cmdDENSITY_,
	cmdTINT,
	cmdTINT_,
	cmdCTEMP,
	cmdCTEMP_,
	cmdFCOLOR,
	cmdFCOLOR_,
	cmdCMODE,
	cmdCMODE_,
	cmdNR,
	cmdNR_,
	cmdNRS,
	cmdNRS_,
	cmdMSEL,
	cmdMSEL_,
	cmdBSEL,
	cmdBSEL_,
	cmdPINP,
	cmdAUTOKEYSTONE,
	cmdASPECT,
	cmdASPECT_,
	cmdPROJID,
	cmdPROJID_,

	cmdNWIP,
	cmdNWIP_,
	cmdNWGW,
	cmdNWGW_,
	cmdNWMASK,
	cmdNWMASK_,
	cmdNWTRAPIP1,
	cmdNWTRAPIP2,
	cmdNWTRAPIP1_,
	cmdNWTRAPIP2_,
	cmdNWDHCP,
	cmdNWDHCP_,
	cmdNWPNAME,
	cmdNWPNAME_,
	cmdNWCNAME,
	cmdNACNAME_,
	cmdNWMAC_,

	cmdNWMODE,
	cmdNWMODE_,
	cmdNWCH,
	cmdNWCH_,
	cmdNWWEP,
	cmdNWWEP_,
	cmdNWESS,
	cmdNWESS_,
	cmdNWTRAPPAS,
	cmdNWTRAPPAS_,
	cmdNWKEY,
	cmdNWKEY_,

	cmdERR_,
	cmdLEGACY,
	cmdVER_,
	cmdLANG,
	cmdLANG_,
	cmdTEMP_,
	cmdIMAGE,
	cmdIMAGE_,
	cmdERACQ,
	cmdERACQ_,
	cmdKEYSTONEINIT,
	cmdKEYSTONEINIT_,
	cmdNWMAC,
	cmdSTKID,
	cmdSTK,
	cmdDEBUG,
	cmdPDEBUG,
	cmdRET,
	cmdD,
	cmdL,
	cmdE,
	cmdEW,
	cmdI,
	cmdO,
	cmdC,
	cmdR,
	cmdH,
	cmdFD,
	cmdFL,
	cmdI2CW,
	cmdI2CR,
	cmdDRW,
	cmdDRR,
	cmdAMP,
	cmdGAUGEW,
	cmdGAUGER,
	cmdWERMM,
	cmdRERMM,
	cmdWERMD,
	cmdRERMD,
	cmdWERMY,
	cmdRERMY,
	cmdERMNEW,
	cmdVE2D,
	cmdVE2L,
	cmdDAC,
	cmdPLLW,
	cmdPLLR,
	cmdEASYMP,
	cmdJPEG,
	cmdPCAP,
	cmdIMSTU,
	cmdIMDIS,
	cmdDATAINIT,
	cmdKEYGET,
	cmdPGAUGEW,
	cmdPGAUGER,
	cmdPDRW,
	cmdPDRR,
	cmdPWERMD,
	cmdPRERMD,
	cmdPERMNEW,
	cmdPDAC,

	_END_

}COMID;




typedef struct tagCmdTbl{
	char 	sCmd[ESCVP21_CMDHEAD_MAXLEN+1];		
	int	iClass;								
	int	iTo;								
}CMDTBL;

#if __cplusplus
extern "C" {
#endif






int LKI_OpenSocket(const char* pAddr, const char* pSockAddr, unsigned short usPort);
int LKI_CloseSocket(void);


#ifndef _NS_CONNECTION_
int LKI_SetAcceptableEvent(const int iEvent);
int LKI_GetAcceptableEvent(unsigned int* pEvent);
#endif


int LKI_ComSequence(const char* pSend, char** ppReceive);
int LKI_ComSequenceINT(int iFd, const char* pSend, char** ppReceive);
int LKI_ComSequence2(const COMID eID, const char* pParam, char** ppRet);
int LKI_ReceiveEventWait(char** ppReceive, const int iSec, const int iMSec);


int LKI_CreateDNetSession(const int iSec, const int iMSec);


void LKI_InitLib(void);
int LKI_StrCmdLen(const char* pBuff);
int LKI_Ascii2Bin(const char* pHex, unsigned char** ppBin);
int LKI_Encode21(char* pBuff, COMID eID, const char* pParam);

#if __cplusplus
}
#endif 

#endif 


