/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#pragma once








typedef  int (*PROC_Initialize )();
typedef  int (*PROC_Finalize   )();
typedef  int (*PROC_ReadBuffer )(char* ptr,int size);
typedef  int (*PROC_PeekBuffer )(char* ptr,int size);
typedef  int (*PROC_WriteBuffer)(char* ptr,int size);

typedef	int (*PROC_MovePointer)(unsigned int size);
typedef BOOL (*PROC_ReSetOverFlow)();
typedef BOOL (*PROC_SetDCHandle)(unsigned long dcHandle);

class DDIHookClass {
public:
	DDIHookClass();
	~DDIHookClass();

	
	BOOL	LoadLib(char *psAppPath);
	
	

	BOOL	FreeLib();

	BOOL	call_Initialize();
	BOOL	call_Finalize();
	int		call_ReadBuffer (char* ptr,int size);
	int		call_PeekBuffer (char* ptr,int size);
	int		call_WriteBuffer(char* ptr,int size);

	int		call_MovePointer(int size);
	BOOL	call_ReSetOverFlow();
	BOOL	call_SetDCHandle(unsigned long dcHandle);

	int		ReadRect(RECT *rect);
	BOOL	IsWin9x(){return m_bIsWin9x;};

	BOOL	CheckDriverFiles();
	

private:
	BOOL  m_bIsWin9x;
	HMODULE m_hLibModule;
	PROC_Initialize  m_pfnInitialize;
	PROC_Finalize    m_pfnFinalize;
	PROC_ReadBuffer  m_pfnReadBuffer;
	PROC_PeekBuffer  m_pfnPeekBuffer;
	PROC_WriteBuffer m_pfnWriteBuffer;

	PROC_MovePointer m_pfnMovePointer;
	PROC_ReSetOverFlow m_pfnReSetOverFlow;
	PROC_SetDCHandle m_pfnSetDCHandle;
};