/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#include "stdhdrs.h"
#include "vncDesktop.h"
#include "VNeSThread.h"
#include "HeadBuff.h"
#include "VNeS.h"
#include "VNeSConst.h"




DWORD WINAPI 
DDIHookThreadProc(LPVOID lParam)
{
	
	vncDesktop *pDesktop = (vncDesktop *)lParam;

	if(pDesktop == NULL)
		return -1;

	CClientThread  *pClientTrd   = pDesktop->m_pClientTrd;
	CDDIHookThread *pDDIHookTrd = pDesktop->m_pDDIHookTrd; 

	if(pClientTrd == NULL ||
	   pDDIHookTrd == NULL)
	{
		log.Print(0,"ERROR: pClientTrd or pDDIHookTrd NULL.");
		
		pDesktop->QuitAppMessage(VERROR_Init);
		return -1;
	}

	log.Print(0,"THREAD: DDIHookThreadProc() called");

	
	int nScreenPart = 0;
	int nRefreshdelay = 0;
	RECT rectPart;
	RECT rectFull; 
	int nCheck,nLoops = 0;

	
	int nSmallRectCount = 0;
	

	
	RECT oneRect;
	SetRectEmpty(&oneRect);

	
	BOOL bError = FALSE;

	
	vncRegion vrUpdateRegCheck;

	
	DWORD dwWaitDelay = pDDIHookTrd->m_dwWaitDelay;
	DWORD dwStartTime,dwEndTime  = 0;
	DWORD dwLoopTime = 0;
	BOOL  bNewUpdate = FALSE;

	
	

	do{
		RECT	rectTemp;
		nLoops = 0;

		
		nSmallRectCount	= 0;
		

		
		
		
		
		

		
		dwStartTime = GetTickCount();
		

		
		timelog.Print(0,"HOOK: Loop Start = %lu ms"
					,dwStartTime-gdwAppStartTime);

		while(pDesktop->m_bClientReady	&& 
			 (nCheck = pDesktop->ddiHook.ReadRect(&rectTemp)))
		{
		
			if(nCheck == sizeof(CONTAINER))
			{
				
				
				#ifdef _DEBUG
				
				if(rectTemp.right > pDDIHookTrd->m_fullscreen.right ||
				   rectTemp.bottom > pDDIHookTrd->m_fullscreen.bottom ||
				   rectTemp.top < 0 || rectTemp.bottom < 0)
				{
					rectlog.Print(0,"ERROR HOOK: Rect %d %d %d %d  : %d x %d"
						,rectTemp.left,rectTemp.top,rectTemp.right,rectTemp.bottom
						,rectTemp.right-rectTemp.left,rectTemp.bottom-rectTemp.top);
				}
				#endif

				
				if(pDesktop->ddiHook.IsWin9x())
				{
					if(!pDesktop->CheckHookValidate(rectTemp))
						continue;
				}

				if(!pDDIHookTrd->IsHookIntoOneRect())
				{
					
					
					
					CMyMutexLock lock(pDesktop->m_csRegionLock);

					
					if(IntersectRect(&rectTemp, &rectTemp, &pDDIHookTrd->m_fullscreen))
					{
						pDesktop->m_vrUpdateReg.AddRect(rectTemp);
						
						bNewUpdate = TRUE;
						
					}

					rectlog.Print(0,"HOOK: Rect %d %d %d %d  : %d x %d"
						,rectTemp.left,rectTemp.top,rectTemp.right,rectTemp.bottom
						,rectTemp.right-rectTemp.left,rectTemp.bottom-rectTemp.top);
				}
				else
				{
					UnionRect(&oneRect,&oneRect,&rectTemp);

					
					DWORD rectHeight,rectWidth,rectArea = 0;
					rectHeight	= rectTemp.bottom - rectTemp.top;
					rectWidth	= rectTemp.right - rectTemp.left;
					rectArea	= rectWidth * rectHeight;

					
					if(pDDIHookTrd->IsCheckDetailArea() && 
						((rectArea   < pDDIHookTrd->GetDetailArea()   ) || 
						 (rectWidth  < pDDIHookTrd->GetDetailWidth()  ) || 
						 (rectHeight < pDDIHookTrd->GetDetailHeight() ) ))
					{
						nSmallRectCount++;
					}
					

					
				}
				
				
				
				if(IntersectRect(&rectTemp, &rectTemp, &pDDIHookTrd->m_fullscreen))
				{
					RECT limit		= pDDIHookTrd->m_fullscreen;
					int nArea		= (rectTemp.bottom-rectTemp.top) * 
									  (rectTemp.right-rectTemp.left);
					int nAreaLimit	= ((limit.bottom-limit.top) * 
									  (limit.right-limit.left))/8;

					if(nArea <= nAreaLimit)
						vrUpdateRegCheck.AddRect(rectTemp);
					else
					{
						nRefreshdelay	= 0;
						nScreenPart		= 0;
					}
				}
				

				
				
				
				
			}
			else if(nCheck == 1)
			{
				
				log.Print(0,"HOOK: OVERFLOW!");
				
				
				{
					CMyMutexLock lock(pDesktop->m_csRegionLock);
					pDesktop->m_vrUpdateReg.AddRect(pDDIHookTrd->m_fullscreen);
				}

				bNewUpdate = TRUE;
				
				
				pDesktop->ddiHook.call_ReSetOverFlow();
				log.Print(0,"HOOK: OVERFLOW RESET.");
				break;
			}
			else 
			{
				
				
				pDDIHookTrd->KillLoop();
				bError = TRUE;
				break;
			}		
		
			
			
			if(bNewUpdate)
			{
				pDesktop->SignalSendUpdate(TRUE);
				bNewUpdate = FALSE;
			}
			

			if(++nLoops >= pDesktop->m_dwHookCaptureLimit)
			{
				rectlog.Print(0,"LOOPS: BREAK at %d", nLoops);
				break;
			}
		}
			
		
		if(pDDIHookTrd->IsHookIntoOneRect() && !IsRectEmpty(&oneRect))
		{
			
			{
				CMyMutexLock lock(pDesktop->m_csRegionLock);
			
				if(IntersectRect(&oneRect, &oneRect, &pDDIHookTrd->m_fullscreen))
				{
					pDesktop->m_vrUpdateReg.AddRect(oneRect);
					bNewUpdate = TRUE;
				}
			}
			
			
			
			if(nSmallRectCount > pDDIHookTrd->GetDetailLimit())
			{
				rectlog.Print(0,"DISSOLVE: SmallRECTLimit %lu nSmallRectCount = %d Calling Sleep()"
				         ,pDDIHookTrd->GetDetailLimit(),nSmallRectCount);

				Sleep(pDDIHookTrd->GetDetailDelay()) ; 
			}
			

			rectlog.Print(0,"HOOK: ONE Rect %d %d %d %d  : %d x %d"
					,oneRect.left,oneRect.top,oneRect.right,oneRect.bottom
					,oneRect.right-oneRect.left,oneRect.bottom-oneRect.top);

			
			SetRectEmpty(&oneRect);
		}
		
		
		
		
		
		
		
		
		
		if(!vrUpdateRegCheck.IsEmpty() && pDesktop->m_bClientReady)
		{
			
			if(!pDDIHookTrd->IsNegligibleRegion(vrUpdateRegCheck))
			{
				rectlog.Print(0,"Found Valid region.");
				nRefreshdelay = 0;
				nScreenPart = 0;
			}

			
			pDDIHookTrd->m_vbRegionBuff.Add(vrUpdateRegCheck);
			vrUpdateRegCheck.Clear();
		}
		

		
		if(pDesktop->m_bClientReady && 
		   nRefreshdelay++ > pDesktop->m_dwFullScrRefreshDelay &&
		   nScreenPart<= (pDesktop->m_dwFullScreenCount-1) &&
		   pDesktop->m_bSendFullScreen)
		
		
		{
			rectFull  = pDDIHookTrd->m_fullscreen;
			rectPart.left  = rectFull.left;
			rectPart.right = rectFull.right;

			int amari = rectFull.bottom % pDesktop->m_dwFullScreenCount;
			int syou  = rectFull.bottom / pDesktop->m_dwFullScreenCount;

			
			rectPart.top = syou * nScreenPart;

			
			if(nScreenPart <= (pDesktop->m_dwFullScreenCount-2))
			{
				rectPart.bottom = rectPart.top + syou;
			}
			else if(nScreenPart == (pDesktop->m_dwFullScreenCount-1))
			{
				rectPart.bottom = rectPart.top + syou + amari;
				
				
				
				rectlog.Print(0,"FULLSCREEN: Sent Last Strip Update");
			}

			nScreenPart++;

			rectlog.Print(0,"FULLSCREEN: Rect %d %d %d %d  : %d x %d"
				,rectPart.left,rectPart.top,rectPart.right,rectPart.bottom
				,rectPart.right-rectPart.left,rectPart.bottom-rectPart.top);

			pClientTrd->AddRectToFullScr(rectPart);
		
			bNewUpdate = TRUE;
		}

		if(bNewUpdate)
		{
			pDesktop->SignalSendUpdate(TRUE);
			bNewUpdate = FALSE;
		}
		else
		{
			
			if(pDesktop->ddiHook.IsWin9x())
			{
				pDesktop->SetMouseRect();
				RECT newRect = pDesktop->MouseRect();
				if(pClientTrd->IsMouseMoved(newRect))
					pDesktop->SignalSendUpdate(TRUE);
			}
		}
	
		
		pDesktop->CheckSendTimes();

		
		pDesktop->CheckSendBuffers();

		
		dwEndTime = GetTickCount();
		dwLoopTime = dwEndTime-dwStartTime;
		dwWaitDelay = pDDIHookTrd->m_dwWaitDelay;
		dwWaitDelay -= (dwLoopTime>dwWaitDelay) ? dwWaitDelay : dwLoopTime;
		
		
		timelog.Print(0,"HOOK: Loop Stop = %lu ms"
					,dwEndTime-gdwAppStartTime);

	}while(WaitForSingleObject(pDDIHookTrd->m_hEventKill,dwWaitDelay)== WAIT_TIMEOUT);

	if(bError)
	{
		
		pClientTrd->KillLoop();
		pDesktop->SignalSendUpdate(TRUE);
		pDesktop->SignalSendBuffsReady(TRUE);
		
		
		pDesktop->PostDriverErrorMsg();
	}

	log.Print(0,"THREAD: DDIHookThreadProc() end");
	return 0;
}
