/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/






#ifndef __VNES_MYMUTEX_H__
#define __VNES_MYMUTEX_H__

#include "stdhdrs.h"

class CMyMutex  
{

public:
    CMyMutex(void);
    ~CMyMutex(void);

    void lock(void);
    void unlock(void);

private:
    
    CMyMutex(const CMyMutex&);
    CMyMutex& operator=(const CMyMutex&);

    CRITICAL_SECTION	m_csLock;
};





class CMyMutexLock  
{
    CMyMutex& m_myMutex;

public:
	
    CMyMutexLock(CMyMutex &m) : m_myMutex(m) 
	{ 
		m_myMutex.lock(); 
		bUnlock = false;
	}
    
	
	~CMyMutexLock(void) 
	{ 
		if(!bUnlock)
			m_myMutex.unlock(); 
	}
	
	void unlock(void) 
	{ 
		m_myMutex.unlock(); 
		bUnlock = true;
	}

private:
    
    CMyMutexLock(const CMyMutexLock&);
    CMyMutexLock& operator=(const CMyMutexLock&);

	BOOL	bUnlock;
};



#endif	
