/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#include "stdhdrs.h"
#include "vncDesktop.h"
#include "VNeSThread.h"
#include "VNeS.h"
#include "VNeSConst.h"




DWORD WINAPI 
SendThreadProc(LPVOID lParam)
{
	log.Print(0,"THREAD: SendThreadProc() called");

	
	VNES_SENDTRDPARAM *pValue	= (VNES_SENDTRDPARAM *)lParam;
	vncDesktop *pDesktop		=  pValue->pDesktop;

	
	if(pDesktop == NULL)
		return -1;

	CSendThread  *pSendTrd   = pDesktop->m_pSendTrds[pValue->dwClientID];

	if(pSendTrd == NULL)
	{
		log.Print(0,"ERROR: pSendTrd NULL.");
		
		pDesktop->QuitAppMessage(VERROR_Init);
		return -1;
	}

	log.Print(0,"SEND THREAD: client IpAdd = 0x%8x",pSendTrd->GetIPAdd());

	
	BOOL bError = false;

	
	DWORD dwWaitDelay = pSendTrd->m_dwWaitDelay;

	while (WaitForSingleObject(pSendTrd->m_hEventKill,dwWaitDelay) 
		   == WAIT_TIMEOUT)
	{	
		
		WaitForSingleObject(pSendTrd->GetSendDataEventHandle(), INFINITE);
		pSendTrd->SignalSendData(FALSE);

		
		
		timelog.Print(0,"SEND: Loop Start = %lu ms"
					,GetTickCount()-gdwAppStartTime);

		if(!pSendTrd->SendUpdate())
		{
			log.Print(0,"SEND THREAD: ERROR SendUpdate() failed. Client ID = %d",pValue->dwClientID);
			
			pSendTrd->KillLoop();
			bError = true;
			break;
		}

		
		

		

		timelog.Print(0,"SEND: Loop Stop = %lu ms"
					,GetTickCount()-gdwAppStartTime);
	}

	if(bError)
	{
		
		pDesktop->EVClientLost(pSendTrd->GetIPAdd());
	}

	pSendTrd->SetAlive(false);
	

	log.Print(0,"THREAD: SendThreadProc() end");
	return 0;
}
