/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#ifndef _VNES_DLL_H
#define _VNES_DLL_H



#include "EVStream.h"
#include "rfb.h"

#ifdef __cplusplus
#define VEXPORT extern "C" __declspec (dllexport)
#else
#define VEXPORT __declspec (dllexport)
#endif



VEXPORT BOOL StartVNeS(HWND hEMPWnd);





VEXPORT BOOL StopVNeS();





VEXPORT BOOL Connect(CEVStream &ConnInfo);





VEXPORT BOOL Disconnect();





VEXPORT BOOL IsSending(DWORD &dwBytes);





VEXPORT BOOL SetSendImage(BOOL bPause);





VEXPORT BOOL ReSendFullScrRect(DWORD dwID);





VEXPORT BOOL GetScreenFormat(rfbServerInitMsg &format);






const UINT EV_COMMAND = 
		RegisterWindowMessage("EPSON.EMPController.VNeS.Messages");

enum MessageTypes
{
	resolutionChange	= 0x8000,
	clientLost			= 0x8001,
	vnesError			= 0x8002
};

enum ErrorCodes
{
	VERROR_Memory			= 0x9000,			
	VERROR_AppWindow		= 0x9001,			
	VERROR_ZlibLoadLib		= 0x9002,			
	VERROR_DDILoadLib		= 0x9003,			
	VERROR_SocketInit		= 0x9004,			
	VERROR_HookDriver		= 0x9005,			
	VERROR_AlreadyExists	= 0x9006,			
	VERROR_Init				= 0x9007,			
	VERROR_Palette			= 0x9008			
};




#endif _VNES_DLL_H