/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#ifndef __VNES_BUFFER_H__
#define __VNES_BUFFER_H__


#include "vncRegion.h"
#include "stdhdrs.h"
#include <list>

typedef struct {
	BYTE *pScreenBuff;				
	DWORD dwScrBuffsize;
}VNES_SCRBUFFER;


typedef std::list<VNES_SCRBUFFER> vBufList; 




class CVNeSBufferList  
{
public:
	
	CVNeSBufferList();
	virtual ~CVNeSBufferList();

	
	int		Add(BYTE *pScrBuff,DWORD dwBufSize);
	int		Add(VNES_SCRBUFFER &entry);
	
	
 	void	Clear(void);					

	
	BOOL	InitRingBuffer(DWORD dwBufferSize, DWORD dwListSizeLimit);

	
	BOOL	GetFront(VNES_SCRBUFFER &scrBuffer);
	BOOL	IsEmpty(); 
	BOOL	IsFull();  
	DWORD	GetListSize() { return m_dwListSize; };

	
	vBufList	m_BufferList;

	
	DWORD		m_dwListSizeLimit;

	
	DWORD		m_dwScrBufferSize;
	
	
	
	
	vBufList::iterator	m_RingHead;
	vBufList::iterator  m_RingTail;

	
	DWORD		m_dwListSize;

	void		ResetListSize(){ m_dwListSize = 0;};

	void		IncrementRingTail()
				{
					
					
					m_RingTail++;
					m_RingTail = (m_RingTail == m_BufferList.end()) ? m_BufferList.begin() : m_RingTail;
				};
	
	void		IncrementRingHead()
				{
					
					
					m_RingHead++;
					m_RingHead = (m_RingHead == m_BufferList.end())? m_BufferList.begin() : m_RingHead;
				};
	
	void		ResetRingPointers()
				{ 
					
					
					m_RingHead = m_BufferList.begin();
					m_RingTail = m_BufferList.begin();
				};
};

#endif 
