/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#include "VNeSThread.h"


#include "VNeSConst.h"





CDDIHookThread::CDDIHookThread()
	: CVNeSThread()
{
	log.Print(0,"THREAD: DDIHookThread constructor.");
	
	
	m_bHookStyle = FALSE;

	
	SetRectEmpty(&m_fullscreen);

	
	
	m_vbRegionBuff.Clear();
	

	
	m_dwHookDetailDelay = VNES_DEF_HOOK_DETAIL_DELAY;
	m_dwDetailArea		= VNES_DEF_DETAIL_AREA; 
	m_dwDetailWidth		= VNES_DEF_DETAIL_WIDTH;
	m_dwDetailHeight	= VNES_DEF_DETAIL_HEIGHT;
	m_dwDetailLimit		= VNES_DEF_DETAIL_LIMIT;

	m_bCheckDetailArea	= VNES_DEF_CHECK_DETAIL_AREA;
	
}

CDDIHookThread::~CDDIHookThread()
{
	log.Print(0,"THREAD: DDIHookThread desstructor.");
}











BOOL	
CDDIHookThread::IsNegligibleRegion(vncRegion &region)
{
	BOOL ret = FALSE;

	vncRegion tempRgn;
	
	if(region.IsEmpty())
		return TRUE;

	
	
	m_vbRegionBuff.GetFullRegion(tempRgn);

	if(tempRgn.IsEmpty())
	{
		rectlog.Print(0,"Ring buffer region empty.");
		return TRUE;
	}

	
	tempRgn.Intersect(region);

	
	
	if(tempRgn.IsEqualRgn(region))
	{
		rectlog.Print(0,"Found negligible region.");
		ret = TRUE;
	}

	return ret;
}