/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#include "VNeSRgnBuff.h"



#include "VNeSConst.h"







CVNeSRgnBuff::CVNeSRgnBuff()
{	
	m_dwListSizeLimit = VNES_DEF_MAX_RGNBUFFSIZE;

	
	ResetRingPointers();
}

CVNeSRgnBuff::~CVNeSRgnBuff()
{
	Clear();
}


	
void CVNeSRgnBuff::Clear()
{
	
	m_BufferList.clear();
	ResetRingPointers();
}



int	
CVNeSRgnBuff::Add(vncRegion &entry)
{
	
	vRgnBufList::iterator input;
	input = m_RingHead;
	
	
	
	
	
	
	
	(*input).Clear();
	(*input).Combine(entry);

	IncrementRingHead();

	return 1;
}




BOOL	
CVNeSRgnBuff::InitRingBuffer()
{
	
	
	
	m_BufferList.resize(m_dwListSizeLimit);
	
	
	

	vRgnBufList::iterator entry;
	for (entry = m_BufferList.begin(); entry != m_BufferList.end(); entry++)
	{
		
		(*entry).Clear();
		
	}

	
	ResetRingPointers();

	log.Print(0,"RGN RING BUFF: Initialized successfully. Size: %lu.",m_dwListSizeLimit);
	return TRUE;
}


void	
CVNeSRgnBuff::GetFullRegion(vncRegion &vrFullRgn)
{
	vrFullRgn.Clear();

	if(!m_BufferList.empty())
	{
		vRgnBufList::iterator entry;
		for (entry = m_BufferList.begin(); entry != m_BufferList.end(); entry++)
		{
			if(!(*entry).IsEmpty())
				vrFullRgn.Combine(*entry);
		}
	}

	return;
}
