/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#ifndef __VNES_THREADS_H__
#define __VNES_THREADS_H__

#include "stdhdrs.h"

#include  "VSocket.h"
#include  "vncBuffer.h"
#include  "EVStream.h"
#include  "MyMutex.h"
#include  "VNeSRgnBuff.h"
#include  "VNeSBuff.h"





class CVNeSThread 
{
public:
	
	CVNeSThread();
	virtual ~CVNeSThread();

protected:
	
	HANDLE		m_hThread;						
	DWORD		m_dwThreadID;					
		
public:
	
	HANDLE m_hEventKill;						
												
	
												
	DWORD m_dwWaitDelay;	
									
public:
	
	
	BOOL CreateVNeSThread(LPTHREAD_START_ROUTINE ThreadProc,
						  LPVOID lpParameter = NULL, 
						  DWORD dwCreationFlags = 0);

	
	DWORD ResumeVNeSThread();
	DWORD SuspendVNeSThread();
	
	
	void SetWaitDelay(DWORD dwDelay){ m_dwWaitDelay = dwDelay; };

	
	void KillThread();

	
	void KillLoop();

	
	

	
	
	BOOL	SetVNeSThreadPriority(DWORD dwPriority);
	
};




class CDDIHookThread : public CVNeSThread 
{
public:
	
	CDDIHookThread();
	virtual ~CDDIHookThread();

	
	void	SetHookStyle(BOOL bStyle) { m_bHookStyle = bStyle;};
	BOOL	IsHookIntoOneRect(){ return m_bHookStyle;};

	
	BOOL	m_bHookStyle;

	
	RECT	m_fullscreen;

	
	
	BOOL	IsNegligibleRegion(vncRegion &region);
	
	
	
	CVNeSRgnBuff	m_vbRegionBuff;
	

	
	void	SetDetailLimit(DWORD dwVal){ m_dwDetailLimit = dwVal;};
	void	SetDetailDelay(DWORD dwVal){ m_dwHookDetailDelay = dwVal;};
	void	SetDetailArea(DWORD dwVal){ m_dwDetailArea = dwVal;};
	void	SetDetailWidth(DWORD dwVal){ m_dwDetailWidth = dwVal;};
	void	SetDetailHeight(DWORD dwVal){ m_dwDetailHeight = dwVal;};

	DWORD	GetDetailLimit()	{ return m_dwDetailLimit;};
	DWORD	GetDetailDelay()	{ return m_dwHookDetailDelay;};
	DWORD	GetDetailArea()		{ return m_dwDetailArea;};
	DWORD	GetDetailWidth()	{ return m_dwDetailWidth;};
	DWORD	GetDetailHeight()	{ return m_dwDetailHeight;};

	void	SetCheckDetailArea(BOOL bUse){ m_bCheckDetailArea = bUse; };
	BOOL	IsCheckDetailArea() { return m_bCheckDetailArea; };
	

protected:
	
	DWORD	m_dwDetailLimit;
	DWORD	m_dwHookDetailDelay; 
	DWORD	m_dwDetailArea; 
	DWORD	m_dwDetailWidth; 
	DWORD	m_dwDetailHeight;

	BOOL	m_bCheckDetailArea;
	
};




class CClientThread : public CVNeSThread
{
public:
	
	CClientThread();
	virtual ~CClientThread();

protected:
	
	
	vncBuffer	*m_pBuffer;
	
	
	vncRegion	m_vrRegionToSend;
	vncRegion	m_vrFullScreen;						

	
	
	CMyMutex	m_csFullscreenlock;

	
	
	DWORD dwTotTime;
	DWORD dwLoopCount;
	

	
	
	
	BOOL	SendRectangle(RECT &rect, BOOL bJpeg, DWORD dwFullScrID);
	BOOL	SendRectangles(rectlist &rects, BOOL bJpeg = FALSE, DWORD dwFullScrStartID = 0);
	BOOL	SendUpdateTCP(rectlist &listrect, BOOL bJpeg);

	

	
	
	BOOL	SendRFBMsg(CARD8 type,BYTE *buffer,int buflen,BOOL bHeader);
	

	
	DWORD	m_dwDetailLimit;
	DWORD	m_dwHookDetailDelay; 
	DWORD	m_dwDetailArea; 
	DWORD	m_dwDetailWidth; 
	DWORD	m_dwDetailHeight;

	BOOL	m_bCheckDetailArea;
	

public:
	
	void	SetGrabStyle(BOOL bGrab) { m_bGrabStyle = bGrab;};
	void	SetSendStyle(BOOL bSend) { m_bSendStyle = bSend;};

	
	BOOL	IsGrabStyle() { return m_bGrabStyle; };
	BOOL	IsSendStyle() { return m_bSendStyle; };
	
	
	
	BOOL	Init(vncBuffer *buffer);
	
	
	BOOL	CopyUpdateRegion(vncRegion *captured);
	
	
	BOOL	SendUpdate(RECT &mouseRect,BOOL bJpeg = TRUE);
	
	BOOL	GrabRegion(vncRegion &region);
	BOOL	GrabRect(RECT &rect);
	BOOL	GrabRegionBox(vncRegion &region);
	
	
	
	void	AddRectToFullScr(RECT &rect);
	
	BOOL	IsFullScrRgnEmpty();
	
	
	void	AddFullScr();
	

	
	
	BOOL	SendFullScr(RECT &mouseRect);
	

	
	RECT	m_fullscreen;
	
	
	
	
	
	
	
	BOOL	m_bGrabStyle;						
	BOOL	m_bSendStyle;						

	
	BOOL	m_bSendFullScr;
	void	SetSendFullScreen(BOOL bSend){m_bSendFullScr = bSend;};
	

	
	void	CheckMouseUpdate(RECT &tmpRect, vncRegion &region);
	void	CheckMouseRegion(vncRegion &region);
	RECT	m_rctMouse;
	BOOL	m_bMouseMoved;
	

	
	BOOL	IsMouseMoved(RECT &newMouseRect) { return (!EqualRect(&newMouseRect,&m_rctMouse));};
	

	
	BOOL	SetClientFormat(rfbPixelFormat &format);

	DWORD	m_dwFullScreenCount;
	void	SetFullScreenCount(DWORD dwCnt){ m_dwFullScreenCount = dwCnt; };
	DWORD	GetFullScreenCount(){ return m_dwFullScreenCount; };

	
	void	SetDetailLimit(DWORD dwVal){ m_dwDetailLimit = dwVal;};
	void	SetDetailDelay(DWORD dwVal){ m_dwHookDetailDelay = dwVal;};
	void	SetDetailArea(DWORD dwVal){ m_dwDetailArea = dwVal;};
	void	SetDetailWidth(DWORD dwVal){ m_dwDetailWidth = dwVal;};
	void	SetDetailHeight(DWORD dwVal){ m_dwDetailHeight = dwVal;};

	DWORD	GetDetailLimit()	{ return m_dwDetailLimit;};
	DWORD	GetDetailDelay()	{ return m_dwHookDetailDelay;};
	DWORD	GetDetailArea()		{ return m_dwDetailArea;};
	DWORD	GetDetailWidth()	{ return m_dwDetailWidth;};
	DWORD	GetDetailHeight()	{ return m_dwDetailHeight;};

	void	SetCheckDetailArea(BOOL bUse){ m_bCheckDetailArea = bUse; };
	BOOL	IsCheckDetailArea() { return m_bCheckDetailArea; };
	

	
	BYTE*	m_pSendBuffer;
	DWORD	m_dwSendBuffSize;
	DWORD	m_dwSendBuffptr;

	BOOL	CreateSendBuff(DWORD dwSize);
	BOOL	CopyToSendBuff(BYTE *buff,DWORD dwSize);
	void	ResetSendBuffPtr();
	BYTE*	GetSendBuff() { return m_pSendBuffer; };
	DWORD	GetSendSize() { return m_dwSendBuffptr; };

	BOOL	m_bNewUpdate;
	BOOL	IsNewUpdate() { return m_bNewUpdate; };
	void	SetNewUpdate(BOOL bValue) { m_bNewUpdate = bValue; };
	

	
	
	LARGE_INTEGER	m_lpStart;
	LARGE_INTEGER	m_lpStop;
	LARGE_INTEGER	m_lpBrk1;

	
	vncRegion	m_vrResendRegion;			
	DWORD		m_dwResendJpegRects;		
	void		SetResendJpegRects(DWORD num) { m_dwResendJpegRects = num;};
	
	DWORD		m_dwClientWaitDelaySlow;
	
	
	
	
	DWORD		m_dwClientWaitDelaySlowLimitRects;
	void		SetClientWaitDelaySlow(DWORD num){m_dwClientWaitDelaySlow = num;};
	void		SetClientWaitDelaySlowLimitRects(DWORD num){m_dwClientWaitDelaySlowLimitRects = num;};

	
	
	
	
	
	

	DWORD m_dwResendZlibAreaLimit;	
	void SetResendZlibAreaLimit(DWORD num) { m_dwResendZlibAreaLimit = num;};

	
};




class CSendThread : public CVNeSThread 
{
public:
	
	CSendThread();
	virtual ~CSendThread();

	BOOL	Init(VSocket *sock, DWORD dwBuffsize, DWORD dwListSize);

	VSocket*	m_pSock;
	
	DWORD		m_dwSendBuffSize;
	DWORD		m_dwSendSize;
	DWORD		m_dwCopySize;

	CMyMutex	m_csBuff;
	BYTE*		m_pBuffToSend;
	BOOL		TransferBuffers();
	
	DWORD		m_dwIPAdd;
	void		SetIPAdd(DWORD dwIPAdd){ m_dwIPAdd = dwIPAdd; };
	DWORD		GetIPAdd() { return m_dwIPAdd; };

    CMyMutex	m_csSendSignal;
	HANDLE		m_hSendData;
	BOOL		SignalSendData(BOOL bSet);
	HANDLE		GetSendDataEventHandle(){ return m_hSendData; };

	CMyMutex	m_csSendBuffList;
	BOOL		CopyData(BYTE *buff,DWORD dwSize);
	BOOL		SendUpdate();

	BOOL		m_bAlive;
	void		SetAlive(BOOL bVal){ m_bAlive = bVal; };
	BOOL		IsAlive(){ return m_bAlive; };
	
	BOOL		IsListFull()  { return m_SendBuffList.IsFull();  };
	BOOL		IsListEmpty() { return m_SendBuffList.IsEmpty(); };
	DWORD		GetListSize() { return m_SendBuffList.GetListSize(); };

	CVNeSBufferList	m_SendBuffList;

	LARGE_INTEGER m_lpTimeStart;
	LARGE_INTEGER m_lpTimeStop;
	
	CMyMutex	m_csBytesSent;

	DWORD		m_dwSentBytes;
	DWORD		GetSentBytes() 
				{
					CMyMutexLock lock(m_csBytesSent);
					DWORD dwRet = m_dwSentBytes;
					m_dwSentBytes = 0;
					return dwRet;
				}

	
	DWORD	m_dwSendThreadTimeStart;
	void	SetTimeStart(DWORD dwTime) { m_dwSendThreadTimeStart = dwTime; };
	DWORD	GetTimeStart() { return m_dwSendThreadTimeStart; };

	
	BOOL	CloseSocket();
	

	
	
	
protected:

};




#endif 
