/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/































class VSocket;

#if (!defined(_ATT_VSOCKET_DEFINED))
#define _ATT_VSOCKET_DEFINED

#include "VTypes.h"
#include "MyMutex.h"





class VSocketSystem
{
public:
	VSocketSystem();
	~VSocketSystem();
	VBool Initialised() {return m_status;};
private:
	VBool m_status;
};


class VSocket
{
public:
  
  VSocket();
  virtual ~VSocket();

  
  

  
  
  VBool Create();

  
  
  VBool Shutdown();

  
  
  VBool Close();

  
  
  
  VBool Connect(const VString address, const VCard port);
  VBool	Connect(DWORD dwIPAd, const VCard port); 

  
  
  
  
  
  

  
  
  
  
  
  

  
  
  
	
 
  VBool SendData(const char *buff,
	              const VCard bufflen,
				  BOOL bBlock = FALSE,
				  BOOL bHeader = FALSE
				  );

  
  
protected:
	
	int sock;

	
	VCard				m_TCPport;							

	
	

	
	VInt Send(const char *buff, const VCard bufflen);				
  				 
	
	VBool	SendVNESHeader(const VCard bufflen);
	VBool	SendLoop(const char *buff, const VCard bufflen);
	
	




	
	VBool	CreateTCP();
	VBool	BindTCP(const VCard port);

	void	InsertVnesENCHeader(char *buff,VCard bytes);
	void	InsertVnesENCData(char *buff,const char *srcbuff,VCard bufflen,
							  int remainder);
	
	

public:
	
	

	DWORD	m_dwIPAddress;
	void	SetIPAddress(DWORD dwIP){ m_dwIPAddress = dwIP; };
	

};

#endif 
