/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#ifndef __VNES_ZLIBLIB_H__
#define __VNES_ZLIBLIB_H__

#include "stdhdrs.h"
#include "zlib/zlib.h"

class CZlibLib;



typedef  int ( *PROC_Deflate		)(z_streamp,int);
typedef  int ( *PROC_DeflateEnd		)(z_streamp);
typedef  int ( *PROC_DeflateParams	)(z_streamp,int,int);
typedef  int ( *PROC_DeflateInit2	)(z_streamp,int,int,int,int,int,const char*,int);

typedef  int ( *PROC_DeflateReset	)(z_streamp);
class CZlibLib {
public:
	CZlibLib();
	~CZlibLib();

	BOOL LoadLib(char *psAppPath);
	BOOL FreeLib();

	int  Deflate(z_streamp zpStrm, int nFlush);
	int  DeflateEnd(z_streamp zpStrm);
	int  DeflateParams(z_streamp zpStrm, int nLevel, int nStrategy);
	int  DeflateInit2(z_streamp zpStrm, int nLevel, int nMethod, int nWindowBits,
		              int nMemLevel,int nStrategy);

	
	int  DeflateReset(z_streamp zpStrm);

private:
	HMODULE m_hLibModule;
	PROC_Deflate		m_pfnDeflate;
	PROC_DeflateEnd		m_pfnDeflateEnd;
	PROC_DeflateParams	m_pfnDeflateParams;
	PROC_DeflateInit2	m_pfnDeflateInit2;

	
	PROC_DeflateReset	m_pfnDeflateReset;
};

#endif 
