/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/






























class vncBuffer;

#if !defined(_WINVNC_VNCBUFFER)
#define _WINVNC_VNCBUFFER
#pragma once



#include "vncDesktop.h"
#include "vncEncoder.h"
#include "vncRegion.h"
#include "RectList.h"


#include "VSocket.h"




class vncBuffer
{

public:
	
	vncBuffer(vncDesktop *desktop);
	~vncBuffer();

	
	RECT GetFullScreenRect();
	rfbPixelFormat GetLocalFormat();
	BYTE *GetClientBuffer();
	
	BOOL GetRemotePalette(RGBQUAD *quadbuff, UINT ncolours);

	
	BOOL CheckBuffer();

	
	
	
	
	
	UINT GetNumCodedRects(RECT &rect);

	
	
	
	BOOL GrabRect(RECT &rect);
	

	RECT GrabMouse();					
	BOOL SetClientFormat(rfbPixelFormat &format);

	
	
	void SetCompressLevel(int level);
	void SetQualityLevel(int level);

	
	BOOL SetEncoding(CARD32 encoding);
	UINT TranslateRect(const RECT &rect,BOOL bJpeg = TRUE);


protected:

	
	inline BOOL FastCheckMainbuffer();
	
	BYTE		*m_mainbuff;
	BOOL		m_freemainbuff;
	
	
	UINT		m_mainsize;

	BYTE		*m_clientbuff;
	UINT		m_clientbuffsize;
	BOOL		m_clientfmtset;

	rfbServerInitMsg	m_scrinfo;
	rfbPixelFormat		m_clientformat;
	rfbTranslateFnType	m_transfunc;

	vncDesktop	   *m_desktop;
	vncEncoder	   *m_encoder;
	bool           zlib_encoder_in_use;
	vncEncoder     *m_hold_zlib_encoder;
	bool           tight_encoder_in_use;
	vncEncoder     *m_hold_tight_encoder;
	
	bool           zlibhex_encoder_in_use;
	vncEncoder     *m_hold_zlibhex_encoder;

	
	
	
	
	int				m_compresslevel;
	int				m_qualitylevel;

	
	DWORD			m_dwBitmapWidth;
	DWORD			m_dwBitmapHeight;
	
	

public:
	
	vncEncoder* GetVNCEncoder() {return m_encoder;}  
	rfbPixelFormat GetClientFormat() { return m_clientformat;}

	
	BOOL IsUsedJpeg();
	
};

#endif 
