/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/




































class vncEncodeZlibHex;

#if !defined(_WINVNC_ENCODEZLIBHEX)
#define _WINVNC_ENCODEZLIBHEX
#pragma once

#include "vncEncoder.h"

#include "zlib/zlib.h"



#define VNC_ENCODE_ZLIBHEX_MIN_COMP_SIZE (17)


#define ZLIBHEX_COMP_UNINITED (-1)




#define VNC_ENCODE_ZLIBHEX_MIN_DATAXFER (1400)



class vncEncodeZlibHex : public vncEncoder
{

public:


public:
	
	vncEncodeZlibHex();
	~vncEncodeZlibHex();

	void Init();
	virtual void LogStats();

	virtual UINT RequiredBuffSize(UINT width, UINT height);
	virtual UINT NumCodedRects(RECT &rect);

	
	virtual UINT EncodeRect(BYTE *source, BYTE *dest, const RECT &rect);

protected:
	virtual UINT zlibCompress(BYTE *from_buf, BYTE *to_buf, UINT length, struct z_stream_s *compressor);

	virtual UINT EncodeHextiles8(BYTE *source, BYTE *dest,
		 int x, int y, int w, int h);
	virtual UINT EncodeHextiles16(BYTE *source, BYTE *dest,
		 int x, int y, int w, int h);
	virtual UINT EncodeHextiles32(BYTE *source, BYTE *dest,
		 int x, int y, int w, int h);


protected:
	BYTE		      *m_buffer;
	int			       m_bufflen;
	struct z_stream_s  compStreamRaw;
	struct z_stream_s  compStreamEncoded;

	
	int	m_nBuffsize;
	int m_nEncodedbytes;
};

#endif 

