/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/





























class vncEncoder;

#if !defined(RFBENCODER_DEFINED)
#define RFBENCODER_DEFINED
#pragma once

#include "vncBuffer.h"
#include "translate.h"
#include "vncDesktop.h"



class vncEncoder
{

public:


public:
	
	vncEncoder();
	virtual ~vncEncoder();

	
	virtual void Init();

	
	virtual void LogStats();

	
	virtual UINT RequiredBuffSize(UINT width, UINT height);
	virtual UINT NumCodedRects(RECT &rect);

	
	
	
	
	
	virtual void Translate(BYTE *source, BYTE *dest, const RECT &rect);
	virtual UINT EncodeRect(BYTE *source, BYTE *dest, const RECT &rect);
	
	

	
	
	void Translate(BYTE *source, BYTE *dest, int w, int h, int bytesPerRow);

	
	BOOL SetLocalFormat(rfbPixelFormat &pixformat, int width, int height);
	BOOL SetRemoteFormat(rfbPixelFormat &pixformat);

	
	
	void SetCompressLevel(int level);
	void SetQualityLevel(int level);

	
	BOOL GetRemotePalette(RGBQUAD *quadlist, UINT ncolours);

	
	void SetEdgeCheckColorPercent(DWORD num){m_dwEdgeCheckColorPercent = num;};
	void SetEdgeCheckSamplingPixels(DWORD num){m_dwEdgeCheckSamplingPixels = num;};
	void SetOldEdgeCheck(BOOL bOld){m_bOldEdgeCheck = bOld;};
	BOOL IsUsedJpeg(){return m_bUsedJpeg;};
	

protected:
	BOOL SetTranslateFunction();

public:
	
	int GetDataSize() { return dataSize; }		
	int GetEncodedSize() { return encodedSize;} 
	int GetTransmittedSize() { return transmittedSize; } 


protected:
	rfbTranslateFnType	m_transfunc;			
	char*				m_transtable;			
	char*				m_localpalette;			
	rfbPixelFormat		m_localformat;			
	rfbPixelFormat		m_remoteformat;			
	rfbPixelFormat		m_transformat;			
	int					m_bytesPerRow;			
	
	
	int					dataSize;				
	int					rectangleOverhead;		
	int					encodedSize;			
	int					transmittedSize;		

	
	int					m_compresslevel;		
	int					m_qualitylevel;			
	
	
	
	
	
	
	
	DWORD	m_dwEdgeCheckColorPercent;
	DWORD	m_dwEdgeCheckSamplingPixels;
	BOOL	m_bOldEdgeCheck;
	BOOL	m_bUsedJpeg;
	
};

#endif 
