/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


























#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "vncauth.h"
#include "d3des.h"



unsigned char fixedkey[8] = {23,82,107,6,35,78,88,7};







unsigned char rdKey[8] = {'s','u','p','e','r','m','a','n'}; 


int
vncEncryptPasswd(char *passwd, char *encryptedPasswd)
{
    unsigned int i;

    

    for (i = 0; i < MAXPWLEN; i++) {
	if (i < strlen(passwd)) {
	    encryptedPasswd[i] = passwd[i];
	} else {
	    encryptedPasswd[i] = 0;
	}
    }

    

    deskey(fixedkey, EN0);
	des(encryptedPasswd, encryptedPasswd);

    return 8;
}


char *
vncDecryptPasswd(char *inouttext)
{
    unsigned char *passwd = (unsigned char *)malloc(9);

    deskey(fixedkey, DE1);
    des(inouttext, passwd);

    passwd[8] = 0;

    return (char *)passwd;
}


void
vncRandomBytes(unsigned char *where) {
  int i;
  unsigned int seed = (unsigned int) time(0);

  srand(seed);
  for (i=0; i < CHALLENGESIZE; i++) {
    where[i] = (unsigned char)(rand() & 255);    
  }
}


void
vncEncryptBytes(unsigned char *where, const char *passwd)
{
    unsigned char key[8];
    unsigned int i;

    

    for (i = 0; i < 8; i++) {
	if (i < strlen(passwd)) {
	    key[i] = passwd[i];
	} else {
	    key[i] = 0;
	}
    }

    deskey(key, EN0);

    for (i = 0; i < CHALLENGESIZE; i += 8) {
	des(where+i, where+i);
    }
}




void 
vncDESEncryptBytes(unsigned char *bytes, const char *passwd, 
				unsigned int nLength)
{
    unsigned char key[8];
    unsigned int i,j = 0;

    

    for (i = 0; i < 8; i++) 
	{
		if (i < strlen(passwd)) {
			key[i] = passwd[i];
		} else {
			key[i] = 0;
		}
    }

    deskey(key, EN0);

	while(nLength >= 8)
	{
		des(bytes+j,bytes+j);
		nLength -= 8;
		j+=8;
	}

	if(nLength != 0)
	{
		
		
	}
}



void
vncDESDecryptBytes(unsigned char *bytes, const char *keyword,
							unsigned int nLength)
{
	unsigned char key[8];
    unsigned int i,j = 0;

    


    for (i = 0; i < 8; i++) 
	{
		if (i < strlen(keyword)) 
			key[i] = keyword[i];
		else 
			key[i] = 0;
		
    }

    deskey(key, DE1);

	while(nLength >= 8)
	{
		des(bytes+j,bytes+j);
		nLength -= 8;
		j+=8;
	}

	if(nLength != 0)
	{
		
		
	}
}


int
rdEncryptBytes(unsigned char *bytes,unsigned int nLength)
{
    unsigned int j = 0;

	if(nLength % 8 != 0)
		return 0;

	
    deskey(rdKey, EN0);

	while(nLength >= 8)
	{
		des(bytes+j,bytes+j);
		nLength -= 8;
		j+=8;
	}

	return 1;
}



int
rdDecryptBytes(unsigned char *bytes,unsigned int nLength)
{
	
    unsigned int j = 0;

	if(nLength % 8 != 0)
		return 0;

	
    deskey(rdKey, DE1);

	while(nLength >= 8)
	{
		des(bytes+j,bytes+j);
		nLength -= 8;
		j+=8;
	}

	return 1;
}

int 
rdSetKey(unsigned char* key, int length)
{
	
	if(length < 0)
		length = 0;
	
	
	length = (length > MAXKEYLENGTH)? MAXKEYLENGTH : length;	
	
	rdResetKey();
	
	
	memcpy(rdKey,key,length);
	return 1;
}

void
rdResetKey()
{
	int i=0;
	
	
	for(i=0 ; i < MAXKEYLENGTH ; i++)
	{
		rdKey[i] = 0;
	}
	
}