/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#ifndef NETWORK_DOMAIN_H
#define NETWORK_DOMAIN_H

#include <sys/un.h>

#define UNIX_PATH_MAX   108

class Domain
{
public:
    enum SocketType {
        STREAM,
        DATAGRAM
    };
    
public:
	Domain();
	~Domain();

	bool Create(SocketType type);

	bool Bind( const char path[UNIX_PATH_MAX] );
	bool Connect( const char path[UNIX_PATH_MAX] );

	int Send( const char* buffer, size_t len );
	int Recv( char* buffer, size_t len );

	void SetTimeout( int timeout );
    void SetNonBlocking(const bool async = true);
	int GetLastError();

	int GetFD() const { return m_fd; }

protected:
	int m_fd;						
	struct sockaddr_un m_addr;		
	int m_timeout;					
	int m_errno;					
    bool m_isNoBlock;               
    SocketType m_socketType;        
};

#endif 
