/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/




#ifndef NETWORK_UTIL_H
#define NETWORK_UTIL_H

#include <netinet/in.h>


class IP;
class Domain;


namespace NetworkUtil
{
    
    bool StringToAddress(const char* ip_address, in_addr_t* addr);

    
    const char* AddressToString(const unsigned char addr[4]);

    
    in_addr_t MaskToAddress(int mask);

    
    in_addr_t MakeAddress(const unsigned char buf[4]);

    
    void PrintSocketError(IP& sock);

    
    void PrintSocketError(Domain& sock);

    
    bool IsSameAddress(const unsigned char* addr1, 
                       const unsigned char* addr2);

    
    void TimeToTimeval( int ms, struct timeval *tv );

    
    const char* GetHardwareAddress(const char* device);

    
    in_addr_t GetInterfaceAddress(const char* device);

    
    bool IsValidNetAddress(in_addr_t addr, in_addr_t subnet);
};


#endif 
