/*
    Copyright (C) SEIKO EPSON CORPORATION 2002-2003. All Rights Reserved.

    3-3-5, Owa, Suwa-shi Nagano-ken, 392-8502 Japan
    Phone: +81-266-52-3131

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include <arpa/inet.h>
#include <cstdio>
#include <fcntl.h>
#include "configfile.h"
#include "netutil.h"
#include "debug.h"
#include "domain.h"

#if 0
int
main(int argc, char* argv[])
{
    in_addr myAddr;

    myAddr.s_addr = NetworkUtil::GetInterfaceAddress("eth1");

    DebugPrint("Address: %s\n", inet_ntoa(myAddr));
}
#else
int
main(int argc, char* argv[] )
{
    Domain sock;

    sock.Create(Domain::DATAGRAM);

#if 1
    sock.SetTimeout(5000);
    sock.SetNonBlocking(true);

    int flags = fcntl(sock.GetFD(), F_GETFL, 0);
    flags |= O_NONBLOCK;
    fcntl(sock.GetFD(), F_SETFL, flags);

    flags = fcntl(sock.GetFD(), F_GETFL, 0);
    if ( flags & O_NONBLOCK) {
        DebugPrint("socket is really non-blocking\n");
    } else {
        DebugPrint("socket is *not* really non-blocking\n");
    }
#endif

    char path[UNIX_PATH_MAX];
    memset(path, 0, UNIX_PATH_MAX);
    strcpy(path+1, "TEST");

    const int size = 100;
    char data[size];
    int bytes;

    if ( argc > 1 ) {
        if ( sock.Connect(path) ) {
            DebugPrint("Connected\n");
        } else {
            DebugPrint("Failed to connect\n");
        }

        for( int i = 0 ;; i++) {
            sprintf(data, "TESTING...%d", i);
            bytes = sock.Send(data, size);
            if ( bytes < 0 ) {
                DebugPrint("Error: %d\n", sock.GetLastError());
                NetworkUtil::PrintSocketError(sock);
                break;
            }
        }

    } else {
        if ( sock.Bind(path) ) {
            DebugPrint("Bound\n");
        } else {
            DebugPrint("Failed to bind\n");
        }

        while(1) {
            bytes = sock.Recv(data, size);
            if ( bytes <= 0 ) {
                NetworkUtil::PrintSocketError(sock);
                break;
            }
            if ( bytes > 0 )
                printf("Data: %s\n", data);
        }
    }

    return 0;
}
#endif
